FyrMM = {}
FyrMM.Panel = {}
FyrMM.Options = {}
FyrMM.questPins = {}
FyrMM.requestedquestPins = {}
FyrMM.noMap = false
FyrMM.Visible = true
FyrMM.FpsTest = false
FyrMM.Fps = 0
FyrMM.FpsRaw = 0
FyrMM.Initialized = false
FyrMM.MM_Pin_Update_Needed = true
FyrMM.MM_pScale = 75
FyrMM.MM_pScalePercent = 0.75
FyrMM.currentTasks = {}
FyrMM.questPinCount = 0
FyrMM.currentLocationsCount = 0
FyrMM.currentPOICount = 0
FyrMM.currentForwardCamps = 0
FyrMM.currentMapPins = 0
FyrMM.currentWayshrineCount = 0
FyrMM.AfterCombatUnhidePending = false
FyrMM.AfterCombatUnhideTimeStamp = 0
FyrMM.needQuestPinUpdate = true
FyrMM.QuestPinsUpdating = false
FyrMM.QuestTasksPending = false
FyrMM.CustomPinsCopying = false
FyrMM.LastQuestPinRequest = 0
FyrMM.MovementSpeed = 0
FyrMM.MovementSpeedPrevious = 0
FyrMM.MovementSpeedMax = 0
FyrMM.UseOriginalFunctions = true
FyrMM.MeasureMaps = true
FyrMM.DistanceMeasurementStarted = false
FyrMM.InitialPreloadTimeStamp = nil
FyrMM.currentMap = {}
FyrMM.currentMap.mapBuilt = false
FyrMM.IsGroup = false
FyrMM.IsWaypoint = false
FyrMM.Waypoint = nil
FyrMM.IsRally = false
FyrMM.Rally = nil
FyrMM.IsPing = false
FyrMM.Ping = nil
FyrMM.OverMiniMap = false
FyrMM.OverMenu = false
FyrMM.MenuFadingIn = false
FyrMM.MenuFadingOut = false
FyrMM.DisableSubzones = false
FyrMM.Wayshrines = {}
FyrMM.Treasures = {}
FyrMM.AvailableQuestGivers = {}
FyrMM.Halted = false
FyrMM.HaltTimeOffset = 0
FyrMM.LastReload = 0
FyrMM.CWSTimeStamp = 0
FyrMM.AQGTimeStamp = 0
FyrMM.AQGList = {}
FyrMM.DebugMode = false

FYRMM_ZOOM_MAX = 20
FYRMM_ZOOM_MIN = 1
FYRMM_DEFAULT_ZOOM_LEVEL = 10
FYRMM_ZOOM_INCREMENT_AMOUNT = nil
FYRMM_QUEST_PIN_REQUEST_TIMEOUT = 10000 -- Time in miliseconds to wait for quest pin data
FYRMM_QUEST_PIN_REQUEST_MINIMUM_DELAY = 1000 -- Time in miliseconds to be passed before requesting quest pins again

MM_GetNumMapLocations = GetNumMapLocations -- Location pin count
MM_IsMapLocationVisible = IsMapLocationVisible -- is Location visible
MM_GetMapLocationIcon = GetMapLocationIcon -- Location pin texture
MM_GetNumPOIs = GetNumPOIs -- POI pin count
MM_GetPOIMapInfo = GetPOIMapInfo -- POI pin info

local MenuAnimation
local wrc = 0
local mapContentType = 0
local AVA_OBJECTIVE_PINS_WITH_ARROWS =

{    
	[MAP_PIN_TYPE_FLAG_ALDMERI_DOMINION] = true,
	[MAP_PIN_TYPE_FLAG_EBONHEART_PACT] = true,
	[MAP_PIN_TYPE_FLAG_DAGGERFALL_COVENANT] = true,
	[MAP_PIN_TYPE_FLAG_NEUTRAL] = true,
	[MAP_PIN_TYPE_BALL_ALDMERI_DOMINION] = true,
	[MAP_PIN_TYPE_BALL_EBONHEART_PACT] = true,
	[MAP_PIN_TYPE_BALL_DAGGERFALL_COVENANT] = true,
	[MAP_PIN_TYPE_BALL_NEUTRAL] = true,       
}
local ASSISTED_PIN_TYPES =
{
    [MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION] = true,
    [MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION] = true,
    [MAP_PIN_TYPE_ASSISTED_QUEST_ENDING] = true,
}

local QUEST_PIN_TYPES =
{
	[MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION] = true,
	[MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION] = true,
	[MAP_PIN_TYPE_ASSISTED_QUEST_ENDING] = true,
	[MAP_PIN_TYPE_TRACKED_QUEST_CONDITION] = true,
	[MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION] = true,
	[MAP_PIN_TYPE_TRACKED_QUEST_ENDING] = true,
}

local questPinTextures =
{
	[MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[MAP_PIN_TYPE_ASSISTED_QUEST_ENDING] = "EsoUI/Art/Compass/quest_icon_assisted.dds",
	[MAP_PIN_TYPE_TRACKED_QUEST_CONDITION] = "EsoUI/Art/Compass/quest_icon.dds",
	[MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION] = "EsoUI/Art/Compass/quest_icon.dds",
	[MAP_PIN_TYPE_TRACKED_QUEST_ENDING] = "EsoUI/Art/Compass/quest_icon.dds",
}
local breadcrumbQuestPinTextures =
{
	[MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[MAP_PIN_TYPE_ASSISTED_QUEST_ENDING] = "EsoUI/Art/Compass/quest_icon_door_assisted.dds",
	[MAP_PIN_TYPE_TRACKED_QUEST_CONDITION] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION] = "EsoUI/Art/Compass/quest_icon_door.dds",
	[MAP_PIN_TYPE_TRACKED_QUEST_ENDING] = "EsoUI/Art/Compass/quest_icon_door.dds",
}

----------------------------------------------------------------

local function MM_GetQuestPinCount()
	local count = 0
	local l
	for i  = 1, Fyr_MM_Scroll_Map_QuestPins:GetNumChildren()+100 do
		l = GetControl("Fyr_MM_Scroll_Map_QuestPins_Pin"..tostring(i))
		if l ~= nil then
			if l.m_PinTag ~= nil then
				count = count + 1
			end
		end
	end
	return count
end

local function MM_GetQuestFreePinIndex()
	local l
	for i  = 1, Fyr_MM_Scroll_Map_QuestPins:GetNumChildren()+100 do
		l = GetControl("Fyr_MM_Scroll_Map_QuestPins_Pin"..tostring(i))
		if l ~= nil then
			if l.m_PinTag == nil then
				return i
			end
		else
			return i
		end
	end
	return i
end

MM_RequestJournalQuestConditionAssistance = RequestJournalQuestConditionAssistance
function RequestJournalQuestConditionAssistance(questIndex, stepIndex, conditionIndex, assisted)
	local taskId = MM_RequestJournalQuestConditionAssistance(questIndex, stepIndex, conditionIndex, assisted)
	local tag = ZO_MapPin.CreateQuestPinTag(questIndex, stepIndex, conditionIndex)
	if GetFrameTimeMilliseconds() - FyrMM.LastQuestPinRequest > FYRMM_QUEST_PIN_REQUEST_MINIMUM_DELAY then
		FyrMM.questPinCount = MM_GetQuestPinCount()
		FyrMM.QuestPinsUpdating = true
	end
	if taskId ~= nil and not FyrMM.Halted then
		FyrMM.LastQuestPinRequest = GetFrameTimeMilliseconds()
		FyrMM.currentTasks[taskId] = {}
		FyrMM.currentTasks[taskId] = tag
		FyrMM.currentTasks[taskId].RequestTimeStamp = FyrMM.LastQuestPinRequest
		FyrMM.currentTasks[taskId].ZoneIndex = MM_GetMapId()
		FyrMM.currentTasks[taskId].Fetched = true
		FyrMM.currentTasks[taskId].ZO_MapVisible = ZO_WorldMap:IsHidden()
	end
	return taskId
end

-----------------------------------------------------------------
-- Utility functions
-----------------------------------------------------------------
function table.empty (self)
    for _, _ in pairs(self) do
        return false
    end
    return true
end

local function MM_IsCurrentLocation(pin)
	if pin == nil then return end
	local x, y, _ = GetMapPlayerPosition("player")
	local nX, nY
	if pin.normalizedX ~= nil and pin.normalizedY ~= nil then
		nX = pin.normalizedX
		nY = pin.normalizedY
	end
	if pin.nX ~= nil and pin.nY ~= nil then
		nX = pin.nX
		nY = pin.nY
	end
	if nX ~= nil and nY ~= nil and FyrMM.currentMap.TrueMapSize ~= nil then
		local distance = zo_round(FyrMM.currentMap.TrueMapSize*math.sqrt((x-nX)*(x-nX)+(y-nY)*(y-nY))*7.55)/10 -- assumed size is 1.325 times larger than approximate effective skill distance in meters.
		local message = GetString(SI_MM_STRING_DISTANCE).." "..tostring(distance).." m"
		if not InformationTooltip:IsHidden() then
			InformationTooltip:AddLine(message, "", ZO_HIGHLIGHT_TEXT:UnpackRGB())
		end
		if not ZO_MapLocationTooltip:IsHidden() then
			ZO_MapLocationTooltip:AddLine(message, "", ZO_HIGHLIGHT_TEXT:UnpackRGB())
		end
		return FyrMM.currentMap.TrueMapSize*math.sqrt((x-nX)*(x-nX)+(y-nY)*(y-nY)) < 14 -- Approximate distance to use a wayshrine
	else
		return false
	end
end

 local function IsCraftingService(pin)
	if not pin then return false end
	local pos = nil
	local text, ntl, n, _
	if pin.locationIndex then
		ntl = GetNumMapLocationTooltipLines(pin.locationIndex)
		for i, v in pairs(FyrMM.CSProviders) do
			if v ~= nil then
				for j =1, ntl do
					_, n, _, _ = GetMapLocationTooltipLineInfo(pin.locationIndex, j)
					pos = select(2, n:find(v))
					if pos ~= nil then return true end
				end
			end
		end
	end
	return false
end

local function SetTooltipMessage(pin)
	if pin:IsFastTravelWayShrine() then
		local nodeIndex = pin:GetFastTravelNodeIndex()
		local known, name = GetFastTravelNodeInfo(nodeIndex)
		if not known then name = name.." (undiscovered)" end
		InformationTooltip:AddLine(zo_strformat(SI_WORLD_MAP_LOCATION_NAME, name), "", ZO_TOOLTIP_DEFAULT_COLOR:UnpackRGB()) -- Wayshrine name
		if MM_IsCurrentLocation(pin) then
			InformationTooltip:AddLine(GetString(SI_TOOLTIP_WAYSHRINE_CURRENT_LOC), "", ZO_HIGHLIGHT_TEXT:UnpackRGB()) -- Player is near wayshrine
		else				
			if MM_IsCurrentMapCyrodiil() then
				InformationTooltip:AddLine(GetString(SI_TOOLTIP_WAYSHRINE_CANT_RECALL_AVA), "", ZO_ERROR_COLOR:UnpackRGB()) -- Can't travel to a wayshrine in Cyrodiil
			else
				local _, premiumTimeLeft = GetRecallCooldown()
				if premiumTimeLeft == 0 then
					InformationTooltip:AddLine(GetString(SI_TOOLTIP_WAYSHRINE_CLICK_TO_RECALL), "", ZO_HIGHLIGHT_TEXT:UnpackRGB()) -- Recall text line
					local cost = GetRecallCost()
					if cost > 0 then
						if cost <= GetCurrentMoney() then
							ZO_ItemTooltip_AddMoney(InformationTooltip, cost, SI_TOOLTIP_RECALL_COST, CURRENCY_HAS_ENOUGH)
						else
							ZO_ItemTooltip_AddMoney(InformationTooltip, cost, SI_TOOLTIP_RECALL_COST, CURRENCY_NOT_ENOUGH)
						end
					end
				else
					local cooldownText = zo_strformat(SI_TOOLTIP_WAYSHRINE_RECALL_COOLDOWN, ZO_FormatTimeMilliseconds(premiumTimeLeft, TIME_FORMAT_STYLE_DESCRIPTIVE, TIME_FORMAT_PRECISION_SECONDS))
			InformationTooltip:AddLine(cooldownText, "", ZO_HIGHLIGHT_TEXT:UnpackRGB())
	    	end
    		end
    	end
    else
		local poiIndex = pin:GetPOIIndex()
		local zoneIndex = pin:GetPOIZoneIndex()
		local poiName, _, poiStartDesc, poiFinishedDesc = GetPOIInfo(zoneIndex, poiIndex)
		InformationTooltip:AddLine(zo_strformat(SI_WORLD_MAP_LOCATION_NAME, poiName), "", ZO_TOOLTIP_DEFAULT_COLOR:UnpackRGB()) 
		local pinType = select(3, MM_GetPOIMapInfo(zoneIndex, poiIndex))
		if not (ZO_MapPin.POI_PIN_TYPES[pinType]) then InformationTooltip:AddLine("(undiscovered)", "", ZO_HIGHLIGHT_TEXT:UnpackRGB()) end
		if pinType == MAP_PIN_TYPE_POI_COMPLETE then
			if poiFinishedDesc ~= "" then
				InformationTooltip:AddLine(poiFinishedDesc, "", ZO_HIGHLIGHT_TEXT:UnpackRGB())
			end
		else
			if poiStartDesc ~= "" then
				InformationTooltip:AddLine(poiStartDesc, "", ZO_HIGHLIGHT_TEXT:UnpackRGB())
			end
    	end
    end
end

 function GetCurrentMapTextureFileInfo()
	local tileTexture = (GetMapTileTexture()):lower()
	if tileTexture == nil or tileTexture == "" then
		return "tamriel_0", "tamriel_", "art/maps/tamriel/"
	end
	local pos = select(2,tileTexture:find("maps/([%w%-]+)/"))
	if pos == nil then
		return "tamriel_0", "tamriel_", "art/maps/tamriel/"
	end
	pos = pos + 1
	return string.gsub(string.sub(tileTexture, pos),".dds",""), string.gsub(string.sub(tileTexture, pos),"0.dds",""), string.sub(tileTexture, 1, pos - 1)
end

function MM_GetMapId(map)
	local _, pos, tileTexture
	if map == nil and FyrMM.currentMap.MapId ~= nil then
		return FyrMM.currentMap.MapId
	end
	if map == nil then
		if FyrMM.currentMap.filename then
			map = FyrMM.currentMap.filename
		else
			tileTexture = (GetMapTileTexture()):lower()
			pos = select(2,tileTexture:find("maps/([%w%-]+)/"))
			map = string.gsub(string.sub(tileTexture, pos + 1),".dds","")
		end
	end
	if FyrMM.MapTable then
		if FyrMM.MapTable[map] then
			return FyrMM.MapTable[map].MapId
		end
	end
	return "unknown"
end

function MM_SetMapToZone()
	if FyrMM.DisableSubzones == true and GetMapType() == 1 then
		MapZoomOut()
	end
end

function MM_MapHalfDiagonal()
	local x1 = Fyr_MM_Player:GetRight() local y1 = Fyr_MM_Player:GetTop()
	local x2 = Fyr_MM:GetRight() local y2 = Fyr_MM:GetTop()
	FyrMM.DiagonalND = math.sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2))
	return FyrMM.DiagonalND
end

local function IsSubmap()
	return GetMapContentType() == MAP_CONTENT_DUNGEON or GetMapType() == MAPTYPE_SUBZONE
end

local function MM_GetQuestJournalMaxValidIndex()
	local index = 0
	for i = 1, MAX_JOURNAL_QUESTS do
		if(IsValidQuestIndex(i)) and index < i then
			index = i
		end
	end
	return index
end

local function IsAssisted(pinType)
	local function check(i)
		return ASSISTED_PIN_TYPES[i]
	end
	if pinType then
		if check(pinType) then
			return true
		else
			return false
		end
	end
	return false
end

local function IsQuestType(pinType)
	local function check(i)
		return QUEST_PIN_TYPES[i]
	end
	if check(pinType) then
		return true
	else
		return false
	end
end

local function valueExists(i, x)
	for _, v in ipairs(x) do
		if v == i then
			return true
		end
	end
	return false
end

local function questpinDataExists(pinData, array)
	for i, v in pairs(array) do
		if v.questIndex == pinData.questIndex and v.questName == pinData.questName and v.coditionText == pinData.coditionText and v.stepIndex == pinData.stepIndex and v.stepIndex == pinData.stepIndex and v.conditionIndex == pinData.conditionIndex
			and v.normalizedX == pinData.normalizedX and v.normalizedY == pinData.normalizedY and v.areaRadius == pinData.areaRadius then
			return i
		end
	end
	return nil
end


local function questpinDataCount()
	local count = 0
	for i, v in pairs(FyrMM.questPins) do
		count = count + 1
	end
	return count
end

function MM_SetTargetScale(pin, targetScale)
	if pin == nil or targetScale == nil then return end
    if((pin.targetScale ~= nil and targetScale ~= pin.targetScale) or (pin.targetScale == nil and targetScale ~= pin:GetScale())) then
        pin.targetScale = targetScale
		for i=1, 50 do
			zo_callLater(function() if pin == nil or pin.targetScale == nil then return end local newScale = zo_deltaNormalizedLerp(pin:GetScale(), pin.targetScale, 0.1)
            if(zo_abs(newScale - pin.targetScale) < 0.01) then
                pin:SetScale(pin.targetScale)
				if pin.primaryPin ~= nil then
					pin.primaryPin:SetScale(pin.targetScale)
				end
				if pin.secondaryPin ~= nil then
					pin.secondaryPin:SetScale(pin.targetScale)
				end
				if pin.tertiaryPin ~= nil then
					pin.tertiaryPin:SetScale(pin.targetScale)
				end
                pin.targetScale = nil                
            else
                pin:SetScale(newScale)
				if pin.primaryPin ~= nil then
					pin.primaryPin:SetScale(newScale)
				end
				if pin.secondaryPin ~= nil then
					pin.secondaryPin:SetScale(newScale)
				end
				if pin.tertiaryPin ~= nil then
					pin.tertiaryPin:SetScale(newScale)
				end
				end end, i*5)
		end
    end
end

local function AfterCombatShow()
	if not FyrMM.AfterCombatUnhidePending then return end
	if GetFrameTimeMilliseconds() - FyrMM.AfterCombatUnhideTimeStamp < 1000 * (FyrMM.SV.AfterCombatUnhideDelay -1) then return end
	FyrMM.AfterCombatUnhidePending = false
	if not IsUnitInCombat("player") then FyrMM.Visible = true end
end

local function MM_WayshrineDistances()
	if FyrMM.currentWayshrineCount == 0 or GetFrameTimeMilliseconds() - FyrMM.CWSTimeStamp < 2000 then return end
	local x, y, _, minDistance, minId
	minDistance = 1000
	minId = 0
	if FyrMM.currentMap.PlayerNX ~= nil and FyrMM.currentMap.PlayerNY ~= nil and not Fyr_MM:IsHidden() then
		x = FyrMM.currentMap.PlayerNX
		y = FyrMM.currentMap.PlayerNY
	else
		x, y, _ = GetMapPlayerPosition("player")
	end
	for i, v in pairs(FyrMM.Wayshrines) do 
		if v.nX ~= nil and v.nY ~= nil then
			v.nDistance = math.sqrt((x-v.nX)*(x-v.nX)+(y-v.nY)*(y-v.nY))
			v.Closest = false
			if v.nDistance < minDistance then
				minDistance = v.nDistance
				minId = i
			end
		end
	end
	if minId > 0 then
		FyrMM.Wayshrines[minId].Closest = true
	end
end

local function MM_QuestGiverDistances()
	if #FyrMM.AvailableQuestGivers == 0 or not FyrMM.SV.BorderQuestGivers then return end
	local x, y, _, minDistance, minId
	if FyrMM.currentMap.PlayerNX ~= nil and FyrMM.currentMap.PlayerNY ~= nil and not Fyr_MM:IsHidden() then
		x = FyrMM.currentMap.PlayerNX
		y = FyrMM.currentMap.PlayerNY
	else
		x, y, _ = GetMapPlayerPosition("player")
	end
	for i, v in pairs(FyrMM.AvailableQuestGivers) do 
		if v.nX ~= nil and v.nY ~= nil then
			v.nDistance = math.sqrt((x-v.nX)*(x-v.nX)+(y-v.nY)*(y-v.nY))
		end
	end
end

function MM_MenuTooltip(button, message)
	--Fyr_MM_Menu:SetAlpha(1)
	FyrMM.OverMenu = true
	Fyr_MM_Close:SetAlpha(1)
	if message == nil or message == "" or button == nil then return end
	InitializeTooltip(InformationTooltip, Fyr_MM, TOPLEFT, 38, button:GetTop())
	InformationTooltip:AddLine(message, "", ZO_TOOLTIP_DEFAULT_COLOR:UnpackRGB())
end

function MM_TooltipExit()
	FyrMM.OverMenu = false
	--Fyr_MM_Menu:SetAlpha(0.1)
	Fyr_MM_Close:SetAlpha(0)
	ClearTooltip(InformationTooltip)
end

function MM_PinToggle(value)
	MM_SetLockPosition(value)
	MM_RefreshPanel()
end

function MM_SettingsPanel()
	FyrMM.LAM:OpenToPanel(FyrMM.CPL)
end

function MM_API_Check()
	if FyrMM.SV.UseOriginalAPI then -- if Zygor is active and original functions to be used
		if _IsMapLocationVisible then
			MM_IsMapLocationVisible = _IsMapLocationVisible
		end
		if _GetMapLocationIcon then
			MM_GetNumMapLocations = _GetNumMapLocations
		end
		if _GetMapLocationIcon then
			MM_GetMapLocationIcon = _GetMapLocationIcon
		end
		if _GetPOIMapInfo_ORIG_ZGV then
			MM_GetPOIMapInfo = _GetPOIMapInfo_ORIG_ZGV
		end
	else
		MM_GetNumMapLocations = GetNumMapLocations
		MM_IsMapLocationVisible = IsMapLocationVisible
		MM_GetMapLocationIcon = GetMapLocationIcon
		MM_GetPOIMapInfo = GetPOIMapInfo
	end
end

function GetCurrentMapSize() -- Returns calculated map size in assumed feet, returns nil if size is not yet calculated, or it is not possible to do so
	if FyrMM.currentMap then
		return FyrMM.currentMap.TrueMapSize
	else return nil end
end

function MM_GetRotatedPosition(x, y) -- Inspired by DeathAngel's RadarMiniMap
	local  mWidth, mHeight = Fyr_MM_Scroll_Map:GetDimensions()
	if x and FyrMM.currentMap.PlayerX then
	local ix = (x * mWidth) - FyrMM.currentMap.PlayerX
	local iy = (y * mHeight) - FyrMM.currentMap.PlayerY
	local rx = (math.cos(-FyrMM.currentMap.Heading) * ix) - (math.sin(-FyrMM.currentMap.Heading) * iy)
	local ry = (math.sin(-FyrMM.currentMap.Heading) * ix) + (math.cos(-FyrMM.currentMap.Heading) * iy)
	return zo_round(rx), zo_round(ry)
	end
	return x, y
end

function MM_GetNorthFacingPosition(x, y)
	local  mWidth, mHeight = Fyr_MM_Scroll_Map:GetDimensions()
	if x and y then
		return zo_round(mWidth * x), zo_round(mHeight * y)
	else
		return x, y
	end
end

local function MM_AxisPosition_Original(a) -- Original by Fyrakin
	local mmWidth, mmHeight = Fyr_MM:GetDimensions()
	local na = math.atan((mmWidth/2)/(mmHeight/2))
	local nb = math.pi * 0.5 - na
	local npos, epos, spos, wpos
	if a >= math.pi * 2 - na or a <= na then -- upper border line
		if a <= na then
			npos = mmWidth/2 + mmHeight/2 * math.sin(a) / math.sin(math.pi * 0.5 - a)
		else
			npos = mmWidth/2 - mmHeight/2 * math.sin(math.pi * 2 - a) / math.sin(math.pi * 0.5 - (math.pi * 2 - a))
		end
		return npos, 0
	end
	if a > na and a < na + 2 * nb then -- right border line
		if a - na > nb then
			epos = mmHeight/2 + mmWidth/2 * math.sin(a - na - nb) / math.sin(math.pi * 0.5 - (a - na - nb))
		else
			epos = mmWidth/2 * math.sin(a - na ) / math.sin(math.pi * 0.5 - (a - na))
		end
		return mmWidth, epos
	end
	if a >= na + 2 * nb and a <= 3 * na + 2 * nb then -- bottom border line
		if a - (na + 2 * nb) > na then -- 2 * na - 2 * nb == math.pi
			spos = mmWidth/2 - mmHeight/2 * math.sin(a - 2 * na - 2 * nb) / math.sin(math.pi * 0.5 - (a - 2 * na - 2 * nb))
		else
			spos = mmWidth - mmHeight/2 * math.sin(a - na - 2 * nb) / math.sin(math.pi * 0.5 - (a - na - 2 * nb))
		end
		return spos, mmHeight
	end
	if a > math.pi * 2 - na - 2 * nb and a < math.pi * 2 - na then -- left border line
		if a - na > nb then
			wpos = mmHeight/2 - mmWidth/2 * math.sin(a - 3 * na - 3 * nb) / math.sin(math.pi * 0.5 - (a - 3 * na - 3 * nb))
		else
			wpos = mmHeight/2 - mmWidth/2 * math.sin(a - 3 * na - 2 * nb) / math.sin(math.pi * 0.5 - (a - 3 * na - 2 * nb))
		end
		return 0, wpos
	end
end

function MM_AxisPosition(a) -- slightly optimized by eventHandler
    local mmWidth, mmHeight = Fyr_MM:GetDimensions()

    local piHalf = math.pi * 0.5
    local piDoub = math.pi * 2.0

    mmWidth = mmWidth/2
    mmHeight = mmHeight/2

    local na = math.atan((mmWidth)/(mmHeight))
    local nb = piHalf - na
    local npos, epos, spos, wpos

    local nbX2 = nb*2
    local aMna = a - na
    local aPna = a + na

    if aPna >= piDoub or aMna <= 0 then -- upper border line
        if aMna <= 0 then
            npos = mmWidth + mmHeight * math.sin(a) / math.sin(piHalf - a)
        else
            npos = mmWidth - mmHeight * math.sin(piDoub - a) / math.sin(piHalf - (piDoub - a))
        end
        return npos, 0
    end
    if aMna > 0 and aMna < nbX2 then -- right border line
        if aMna > nb then
            epos = mmHeight + mmWidth * math.sin(aMna - nb) / math.sin(piHalf - (aMna - nb))
        else
            epos = mmWidth * math.sin(aMna) / math.sin(piHalf - (aMna))
        end
        return mmWidth*2, epos
    end
    if aMna >= nbX2 and a <= 3 * na + nbX2 then -- bottom border line
        if aMna - na > nbX2 then
            spos = mmWidth - mmHeight * math.sin(a - 2 * na - nbX2) / math.sin(piHalf - (a - 2 * na - nbX2))
        else
            spos = mmWidth*2 - mmHeight * math.sin(aMna - nbX2) / math.sin(piHalf - (aMna - nbX2))
        end
        return spos, mmHeight*2
    end
    if aPna > piDoub - nbX2 and aPna < piDoub then -- left border line
        if aMna > nb then
            wpos = mmHeight - mmWidth * math.sin(a - 3 * na - 3 * nb) / math.sin(piHalf - (a - 3 * na - 3 * nb))
        else
            wpos = mmHeight - mmWidth * math.sin(a - 3 * na - nbX2) / math.sin(piHalf - (a - 3 * na - nbX2))
        end
        return 0, wpos
    end
end

local function MM_RoundArc(angle)
	if angle > math.pi * 2 then angle = angle - math.pi * 2 end
	return angle
end

local function MM_AxisSwitch()
	for i =1, Fyr_MM_Axis_Textures:GetNumChildren() do
		local l = Fyr_MM_Axis_Textures:GetChild(i)
		if l ~= nil then
			l:ClearAnchors()
			l:SetHidden(FyrMM.SV.WheelMap or not FyrMM.SV.RotateMap)
			l:SetDimensions(20, 20)
		end
	end
	for i =1, Fyr_MM_Axis_Labels:GetNumChildren() do
		local l = Fyr_MM_Axis_Labels:GetChild(i)
		if l ~= nil then
			l:ClearAnchors()
			l:SetHidden(FyrMM.SV.WheelMap or not FyrMM.SV.RotateMap)
		end
	end
end

function MM_AxisPins()
	if (FyrMM.SV.WheelMap and not Fyr_MM_Axis_N:IsHidden()) or not (FyrMM.SV.RotateMap and not Fyr_MM_Axis_N:IsHidden()) then
		MM_AxisSwitch()
		return
	end
	if not FyrMM.SV.RotateMap or not FyrMM.currentMap.Heading then return end
	--Fyr_MM_Axis_Control:SetTopmost(true)

	local n = math.pi * 2  - FyrMM.currentMap.Heading
	local ne = MM_RoundArc(n + math.pi * 0.25)
	local e = MM_RoundArc(n + math.pi * 0.5)
	local se = MM_RoundArc(n + math.pi * 0.75)
	local s = MM_RoundArc(n + math.pi)
	local sw = MM_RoundArc(n + math.pi * 1.25)
	local w = MM_RoundArc(n + math.pi * 1.5)
	local nw = MM_RoundArc(n + math.pi * 1.75)

	Fyr_MM_Axis_N:ClearAnchors()
	Fyr_MM_Axis_N_Label:ClearAnchors()
	Fyr_MM_Axis_N:SetAnchor(CENTER, Fyr_MM_Axis_Control, TOPLEFT, MM_AxisPosition(n))
	Fyr_MM_Axis_N_Label:SetAnchor(CENTER, Fyr_MM_Axis_Control, TOPLEFT, MM_AxisPosition(n))

	Fyr_MM_Axis_NE:ClearAnchors()
	Fyr_MM_Axis_NE_Label:ClearAnchors()
	Fyr_MM_Axis_NE:SetAnchor(CENTER, Fyr_MM_Axis_Control, TOPLEFT, MM_AxisPosition(ne))
	Fyr_MM_Axis_NE_Label:SetAnchor(CENTER, Fyr_MM_Axis_Control, TOPLEFT, MM_AxisPosition(ne))

	Fyr_MM_Axis_E:ClearAnchors()
	Fyr_MM_Axis_E_Label:ClearAnchors()
	Fyr_MM_Axis_E:SetAnchor(CENTER, Fyr_MM_Axis_Control, TOPLEFT, MM_AxisPosition(e))
	Fyr_MM_Axis_E_Label:SetAnchor(CENTER, Fyr_MM_Axis_Control, TOPLEFT, MM_AxisPosition(e))
	
	Fyr_MM_Axis_SE:ClearAnchors()
	Fyr_MM_Axis_SE_Label:ClearAnchors()
	Fyr_MM_Axis_SE:SetAnchor(CENTER, Fyr_MM_Axis_Control, TOPLEFT, MM_AxisPosition(se))
	Fyr_MM_Axis_SE_Label:SetAnchor(CENTER, Fyr_MM_Axis_Control, TOPLEFT, MM_AxisPosition(se))

	Fyr_MM_Axis_S:ClearAnchors()
	Fyr_MM_Axis_S_Label:ClearAnchors()
	Fyr_MM_Axis_S:SetAnchor(CENTER, Fyr_MM_Axis_Control, TOPLEFT, MM_AxisPosition(s))
	Fyr_MM_Axis_S_Label:SetAnchor(CENTER, Fyr_MM_Axis_Control, TOPLEFT, MM_AxisPosition(s))

	Fyr_MM_Axis_SW:ClearAnchors()
	Fyr_MM_Axis_SW_Label:ClearAnchors()
	Fyr_MM_Axis_SW:SetAnchor(CENTER, Fyr_MM_Axis_Control, TOPLEFT, MM_AxisPosition(sw))
	Fyr_MM_Axis_SW_Label:SetAnchor(CENTER, Fyr_MM_Axis_Control, TOPLEFT, MM_AxisPosition(sw))

	Fyr_MM_Axis_W:ClearAnchors()
	Fyr_MM_Axis_W_Label:ClearAnchors()
	Fyr_MM_Axis_W:SetAnchor(CENTER, Fyr_MM_Axis_Control, TOPLEFT, MM_AxisPosition(w))
	Fyr_MM_Axis_W_Label:SetAnchor(CENTER, Fyr_MM_Axis_Control, TOPLEFT, MM_AxisPosition(w))

	Fyr_MM_Axis_NW:ClearAnchors()
	Fyr_MM_Axis_NW_Label:ClearAnchors()
	Fyr_MM_Axis_NW:SetAnchor(CENTER, Fyr_MM_Axis_Control, TOPLEFT, MM_AxisPosition(nw))
	Fyr_MM_Axis_NW_Label:SetAnchor(CENTER, Fyr_MM_Axis_Control, TOPLEFT, MM_AxisPosition(nw))
end

local function MM_Is_PinInsideWheel(pin)
	local di = Fyr_MM:GetWidth()
	local x = (pin:GetRight()+pin:GetLeft())/2
	local y = (pin:GetTop()+pin:GetBottom())/2
	local x1 = (Fyr_MM_Player:GetRight()+Fyr_MM_Player:GetLeft())/2
	local y1 = (Fyr_MM_Player:GetBottom()+Fyr_MM_Player:GetTop())/2
	if pin.areaRadius ~= nil then
		if pin.areaRadius > 0 then
			return math.sqrt((x-x1)*(x-x1)+(y-y1)*(y-y1)) < di/2 - ((30 / 512) * di) + pin:GetWidth()/2 - 10
		end
	end
	return math.sqrt((x-x1)*(x-x1)+(y-y1)*(y-y1)) < di/2 - ((30 / 512) * di) 
end

function MM_IsCoordinateInRange(x, y)
	if not FyrMM.currentMap.TrueMapSize or not FyrMM.currentMap.PlayerNX or not FyrMM.SV.CustomPinViewRange or not FyrMM.SV.ViewRangeFiltering then return true end
	return FyrMM.currentMap.TrueMapSize * math.sqrt((x-FyrMM.currentMap.PlayerNX)*(x-FyrMM.currentMap.PlayerNX)+(y-FyrMM.currentMap.PlayerNY)*(y-FyrMM.currentMap.PlayerNY)) <= FyrMM.SV.CustomPinViewRange
end

function MM_SetPinSize(pin, size, _)
	local properSize = math.floor(size/2)*2
	pin:SetDimensions(properSize, properSize)
end

function MM_SetPinAnchor(pin, x, y, AnchorToControl, hidden)
	local newX, newY, currentX, currentY, currentObject, _
	if pin and x and y and AnchorToControl then
		_, _, currentObject, _, currentX, currentY = pin:GetAnchor()
		if FyrMM.SV.RotateMap then
			newX, newY = MM_GetRotatedPosition(x, y)
			AnchorToControl = Fyr_MM_Scroll
		else
			newX, newY = MM_GetNorthFacingPosition(x, y)
		end
			
		if newX ~= currentX or newY ~= currentY or currentObject ~= AnchorToControl then
			pin:ClearAnchors()
			if FyrMM.SV.RotateMap then
				pin:SetAnchor(CENTER, AnchorToControl, CENTER, newX, newY)
			else
				pin:SetAnchor(CENTER, AnchorToControl, TOPLEFT, newX, newY)
			end
		end
	end
	if hidden then
		pin:SetHidden(true)
	else
		if FyrMM.SV.WheelMap then
			pin:SetHidden(not MM_Is_PinInsideWheel(pin))
		end
	end
end

local function GetQuestData(pin)
	return pin.m_PinTag[1], pin.m_PinTag[3], pin.m_PinTag[2]
end

local function SetQuestTooltip(pin)
	if pin == nil then
		return
	end
	local tooltipLines = {}
	local line = ""
	nX = pin.normalizedX
	nY = pin.normalizedY
	local pinCount = Fyr_MM_Scroll_Map_QuestPins:GetNumChildren()
	for i=1, pinCount+10 do
		local l = GetControl("Fyr_MM_Scroll_Map_QuestPins_Pin"..tostring(i))
		if l ~= nil then
			if not l:IsHidden() or FyrMM.SV.WheelMap then
				
				line = ""
				if l.normalizedX == nX and l.normalizedY == nY then
				    if l.m_PinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING or l.m_PinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING then
						line = GenerateQuestEndingTooltipLine(questIndex)
						if valueExists(line, tooltipLines) then
							line = ""
						else
				    		InformationTooltip:AppendQuestEnding(l.m_PinTag[1])
						end
				    end
				    if (l.m_PinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION or l.m_PinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION or
						l.m_PinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION or l.m_PinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION) then
						line = GenerateQuestConditionTooltipLine(GetQuestData(l))
						if valueExists(line, tooltipLines) then
							line = ""
						else
							InformationTooltip:AppendQuestCondition(GetQuestData(l))
						end
					end
					if GetTrackedIsAssisted(TRACK_TYPE_QUEST, l.questIndex) then
						l:SetMouseEnabled(true)
					else
						l:SetMouseEnabled(false)
					end
				end
				if line ~= "" then
					table.insert(tooltipLines, line)
				end
			end
		end
	end
	pin:SetMouseEnabled(true)
end

local function MM_GetQuestPinById(Id) -- Returns first visible pin by quest Id
	for i=1, FyrMM.questPinCount do
		local l = GetControl("Fyr_MM_Scroll_Map_QuestPins_Pin"..tostring(i))
		if l ~= nil then
			if l.questIndex == Id and not l:IsHidden() then
				return l
			end
		end
	end
	return nil
end

function MM_IsPinVisible(pin) -- Check for pin leaving map limits
	return (pin:GetRight() >= Fyr_MM:GetLeft() + 6 and pin:GetLeft() <= Fyr_MM:GetRight() - 10 and pin:GetBottom() >= Fyr_MM:GetTop() + 6 and pin:GetTop() <= Fyr_MM:GetBottom() - 10)
end

function MM_Is_ValidBorderPin(pin)
	local Visible, Tracked
	if FyrMM.SV.WheelMap then
		Visible = MM_Is_PinInsideWheel(pin)
	else
		Visible = MM_IsPinVisible(pin)
	end
	if pin.m_PinType == MAP_PIN_TYPE_GROUP or pin.m_PinType == MAP_PIN_TYPE_GROUP_LEADER then
		if IsUnitOnline(pin.unitTag) then
			if FyrMM.SV.BorderPinsOnlyLeader then 
				Tracked = IsUnitGroupLeader(pin.unitTag) and (GetUnitZone("player") == GetUnitZone(pin.unitTag))
			else
				Tracked = (GetUnitZone("player") == GetUnitZone(pin.unitTag))
			end
		end
	else
		if FyrMM.SV.BorderPinsOnlyAssisted then
			Tracked = GetTrackedIsAssisted(TRACK_TYPE_QUEST, pin.questIndex)
		else
			Tracked = true
		end
	end
	if pin.m_Pin ~= nil then
		if pin.m_Pin:IsMapPing() then
			Tracked = FyrMM.SV.BorderPinsWaypoint 
		end
		if pin.m_Pin:IsFastTravelWayShrine() then
			local index, _ = string.gsub(pin:GetName(),"Fyr_MM_Scroll_Map_WayshrinePins_Pin", "")
			if FyrMM.Wayshrines[tonumber(index)] ~= nil then
				if FyrMM.Wayshrines[tonumber(index)].Closest then
					Tracked = FyrMM.SV.BorderWayshrine
				else
					Tracked = false
				end
			end
		end
	end
	if pin.m_PinType == MAP_PIN_TYPE_LOCATION then
		Tracked = false
		if pin.IsBankPin and FyrMM.SV.BorderPinsBank then
			Tracked = pin.IsBankPin
		end
		if pin.IsStablePin and FyrMM.SV.BorderPinsStables then
			Tracked = pin.IsStablePin
		end
		if pin.IsCraftingServicePin and FyrMM.SV.BorderCrafting then
			Tracked = pin.IsCraftingServicePin
		end
	end
	if pin.IsTreasure then
		if string.sub(string.lower(pin.pinTexture),1,12) == "losttreasure" then
			Tracked = FyrMM.SV.BorderTreasures
		else
			pin.IsTreasure = nil
		end
	end
	if pin.IsAvailableQuest then
		if pin.m_Pin ~= nil then
			if pin.m_Pin.m_PinTag ~= nil then
				if pin.m_Pin.m_PinTag.IsAvailableQuest then
					Tracked = FyrMM.SV.BorderQuestGivers
				else
					pin.IsAvailableQuest = nil
				end
			else
				pin.IsAvailableQuest = nil
			end
		else
			pin.IsAvailableQuest = nil
		end
	end
	return not Visible and Tracked and FyrMM.SV.BorderPins
end

local function MM_GetNumBorderPins()
	local totalPins = Fyr_MM_Axis_Border_Pins:GetNumChildren()
	local count = 0
	for i=1, totalPins do
		local l = Fyr_MM_Axis_Border_Pins:GetChild(i)
		if l ~= nil then
			if l.pin then
				count = count + 1
			else
				l:SetHidden(true)
			end
		end
	end
	return count
end

local function MM_RemoveBorderPin(pin)
	if pin ~= nil then
		pin:SetHidden(true)
		pin:ClearAnchors()
		pin:SetTexture("")
		if pin.pin then
			if pin.pin.OnBorder then
				pin.pin.OnBorder = nil
			end
			if pin.pin.BorderPin then
				pin.pin.BorderPin = nil
			end
			pin.pin = nil
		end
	end
end

local function MM_GetNewBorderPinIndex()
	if Fyr_MM_Axis_Border_Pins:GetNumChildren() == 0 then return 1 end
	if Fyr_MM_Axis_Border_Pins:GetNumChildren() ~= MM_GetNumBorderPins() then
		for i=1, Fyr_MM_Axis_Border_Pins:GetNumChildren() do
			local l = Fyr_MM_Axis_Border_Pins:GetChild(i)
			if l ~= nil then
				if l.pin == nil then
					return i
				end
			end
		end
	end
	return Fyr_MM_Axis_Border_Pins:GetNumChildren() + 1
end

local function MM_GetTextureForBorderPin(pin)
local texture = ""
	if pin.IsTreasure or pin.IsAvailableQuest then
		if pin.pinTexture ~= nil then
			return pin.pinTexture
		end
	end
	if pin.m_Pin ~= nil then
		if pin.m_Pin.m_PinType == MAP_PIN_TYPE_PLAYER_WAYPOINT then
			return "EsoUI/Art/MapPins/UI_Worldmap_pin_customDestination.dds"
		end
		if pin.m_Pin.m_PinType == MAP_PIN_TYPE_RALLY_POINT then
			return "MiniMap/Textures/rally.dds"
		end
		if pin.m_Pin.m_PinType == MAP_PIN_TYPE_PING then
			return "MiniMap/Textures/ping.dds"
		end
		if pin.m_Pin:IsFastTravelWayShrine() then
			if pin.m_Pin.m_PinTag[2] ~= nil then
				return pin.m_Pin.m_PinTag[2]
			else
				return "/esoui/art/icons/poi_wayshrine_complete.dds"
			end
		end
	end
	if pin.m_PinType == MAP_PIN_TYPE_LOCATION then
		if pin.m_PinTag[2] ~= nil then
			return pin.m_PinTag[2]
		end
	end
	if pin.m_PinType == MAP_PIN_TYPE_GROUP or pin.m_PinType == MAP_PIN_TYPE_GROUP_LEADER then
		local isgmDps, isgmHeal, isgmTank = GetGroupMemberRoles(pin.unitTag)
		if IsUnitGroupLeader(pin.unitTag) then
			if FyrMM.SV.LeaderPin == "Default" then
				texture = "EsoUI/Art/Compass/groupLeader.dds"
			elseif FyrMM.SV.LeaderPin == "Class" then
				texture = GetClassIcon(GetUnitClassId(pin.unitTag))
			elseif isgmDps then
				texture = "EsoUI/Art/LFG/LFG_dps_down.dds"
    		elseif isgmHeal then
				texture = "EsoUI/Art/LFG/LFG_healer_down.dds"
    		elseif isgmTank then
				texture = "EsoUI/Art/LFG/LFG_tank_down.dds"
    		else
				texture = "EsoUI/Art/Compass/groupLeader.dds"
    		end
		else
			if FyrMM.SV.MemberPin == "Default" then
				texture = "EsoUI/Art/MapPins/UI-WorldMapGroupPip.dds"
			elseif FyrMM.SV.MemberPin == "Class" then
				texture = GetClassIcon(GetUnitClassId(pin.unitTag))
			elseif isgmDps then
				texture = "EsoUI/Art/LFG/LFG_dps_down.dds"
    		elseif isgmHeal then
				texture = "EsoUI/Art/LFG/LFG_healer_down.dds"
    		elseif isgmTank then
				texture = "EsoUI/Art/LFG/LFG_tank_down.dds"
    		else
				texture = "EsoUI/Art/MapPins/UI-WorldMapGroupPip.dds"
			end
		end
		return texture
	end
	if QUEST_PIN_TYPES[pin.m_PinType] then
		return questPinTextures[pin.m_PinType]
		else return "MiniMap/Textures/Blank.dds"
	end
end

local function MM_SetBorderPinHandlers(pin)
	if pin.pin.m_Pin then
		if pin.pin.m_Pin:IsFastTravelWayShrine() then
			pin:SetHandler("OnMouseEnter", function(pin) if pin.pin == nil then MM_RemoveBorderPin(pin) return end MM_SetTargetScale(pin, 1.3) if not FyrMM.SV.PinTooltips then return end InitializeTooltip(InformationTooltip, Fyr_MM, TOPLEFT, 0, 0) SetTooltipMessage(pin.pin.m_Pin) end)
			pin:SetHandler("OnMouseExit", function(pin) MM_SetTargetScale(pin, 1) ClearTooltip(InformationTooltip) end)
			pin:SetHandler("OnMouseUp", function(pin) if not MM_IsCurrentMapCyrodiil() and FyrMM.SV.FastTravelEnabled then
									if MM_IsCurrentLocation(pin.pin.m_Pin) then return end -- No need to recall if player is near wayshrine
										local nodeIndex = pin.pin.m_Pin:GetFastTravelNodeIndex()
										ZO_Dialogs_ReleaseDialog("FAST_TRAVEL_CONFIRM")
										local name = select(2, GetFastTravelNodeInfo(nodeIndex))
										ZO_Dialogs_ShowDialog("FAST_TRAVEL_CONFIRM", {nodeIndex = nodeIndex, recall = true}, {mainTextParams = {name}}) 
       								end end)
			pin:SetMouseEnabled(true)
		end
	end
	if (pin.pin and pin.pin.m_PinType) then
		if pin.pin.m_PinType ~= MAP_PIN_TYPE_LOCATION then
			if pin.pin.m_PinType == MAP_PIN_TYPE_GROUP or pin.pin.m_PinType == MAP_PIN_TYPE_GROUP_LEADER then
				pin:SetHandler("OnMouseEnter", function(pin) if pin.pin == nil then MM_RemoveBorderPin(pin) return end MM_SetTargetScale(pin, 1.3) if not FyrMM.SV.PinTooltips then return end
												InitializeTooltip(InformationTooltip, Fyr_MM, TOPLEFT, 0, 0) InformationTooltip:AppendUnitName(pin.pin.unitTag) MM_IsCurrentLocation(pin.pin) end)
			else
				if QUEST_PIN_TYPES[pin.pin.m_PinType] then
					pin:SetHandler("OnMouseEnter", function(pin) if pin.pin == nil then MM_RemoveBorderPin(pin) return end MM_SetTargetScale(pin, 1.3) if not FyrMM.SV.PinTooltips then return end
												InitializeTooltip(InformationTooltip, Fyr_MM, TOPLEFT, 0, 0) SetQuestTooltip(pin.pin) MM_IsCurrentLocation(pin.pin)  end)
				end
			end
			pin:SetHandler("OnMouseExit", function(pin) MM_SetTargetScale(pin, 1) ClearTooltip(InformationTooltip) end)
		else
			pin:SetHandler("OnMouseEnter", function(pin) if pin.pin == nil then MM_RemoveBorderPin(pin) return end MM_SetTargetScale(pin, 1.3) if not FyrMM.SV.PinTooltips then return end if ZO_MapPin.TOOLTIP_CREATORS[MAP_PIN_TYPE_LOCATION].tooltip then InitializeTooltip(ZO_MapLocationTooltip, Fyr_MM, TOPLEFT, 0, 0) ZO_MapPin.TOOLTIP_CREATORS[MAP_PIN_TYPE_LOCATION].creator(pin.pin.m_Pin) end MM_IsCurrentLocation(pin.pin)  end)
			pin:SetHandler("OnMouseExit", function(pin) MM_SetTargetScale(pin, 1) ClearTooltip(ZO_MapLocationTooltip) end)
		end
		pin:SetMouseEnabled(true)
	end
	if pin.pin then
		if pin.pin.IsTreasure or pin.pin.IsAvailableQuest then
				pin:SetHandler("OnMouseEnter", function(pin) if pin.pin == nil then  MM_RemoveBorderPin(pin) return end if pin.pin.m_Pin == nil then MM_RemoveBorderPin(pin) return end  MM_SetTargetScale(pin, 1.3) if not FyrMM.SV.PinTooltips then return end if ZO_MapPin.TOOLTIP_CREATORS[pin.pin.m_Pin.m_PinType] == nil then return end
			    				if ZO_MapPin.TOOLTIP_CREATORS[pin.pin.m_Pin.m_PinType].tooltip then InitializeTooltip(InformationTooltip, Fyr_MM, TOPLEFT, 0, 0) end
		   	    				ZO_MapPin.TOOLTIP_CREATORS[pin.pin.m_Pin.m_PinType].creator(pin.pin.m_Pin) MM_IsCurrentLocation(pin.pin) end)
   				pin:SetHandler("OnMouseExit", function(pin) MM_SetTargetScale(pin, 1) if pinTooltipInfo == nil then return end
   								if ZO_MapPin.TOOLTIP_CREATORS[pin.pin.m_Pin.m_PinType].tooltip then ClearTooltip(InformationTooltip) end end)
				pin:SetMouseEnabled(true)
		end
	end
end

function MM_CreateBorderPin(pin)
	if not MM_Is_ValidBorderPin(pin) then
		if pin.BorderPin ~= nil then
			MM_RemoveBorderPin(pin.BorderPin)
		end
		return nil
	end
	local mmWidth, mmHeight = Fyr_MM:GetDimensions()
	local mmX, mmY = Fyr_MM_Player:GetRight(), Fyr_MM_Player:GetTop()
	local pinX, pinY = math.abs(pin:GetRight() - mmX), math.abs(pin:GetTop() - mmY)
	local m = 0
	if pinX ~= 0 then
		m = pinY/pinX
	end
	local D = mmWidth/2 - ((38 / 512) * mmWidth)
	local newX, newY
	local na = math.atan((mmWidth/2)/(mmHeight/2))
	local nb = math.pi * 0.5 - na
	local pa = math.atan(pinX/(pinY))
	local pb = math.pi * 0.5 - pa
	local borderpin
	local index = MM_GetNewBorderPinIndex()
	if not pin.OnBorder then
		if Fyr_MM_Axis_Border_Pins:GetChild(index) == nil then
			borderpin = WINDOW_MANAGER:CreateControl("Fyr_MM_Axis_Border_Pin"..tostring(index), Fyr_MM_Axis_Border_Pins, CT_TEXTURE)
		else
			borderpin = Fyr_MM_Axis_Border_Pins:GetChild(index)
		end
		pin.BorderPin = borderpin
		borderpin.pin = pin
		MM_SetBorderPinHandlers(borderpin)
	else
		borderpin = pin.BorderPin
	end
	 MM_SetBorderPinHandlers(borderpin)
	pin.OnBorder = true
	borderpin:SetTexture(MM_GetTextureForBorderPin(pin))

	if pinX > 0 and pinY > 0 then
			if pa <= na then
				if pin:GetRight() >=  mmX then
					newX = mmWidth/2 + mmHeight/2 * math.sin(pa) / math.sin(math.pi * 0.5 - pa)
				else
					newX = mmWidth/2 - mmHeight/2 * math.sin(pa) / math.sin(math.pi * 0.5 - pa)
				end
				if pin:GetTop() < mmY then
					newY = 4
				else
					newY = mmHeight - (32 * FyrMM.MM_pScalePercent)/2 + 2
				end
			else
				if pin:GetRight() > mmX then
					newX = mmWidth - (32 * FyrMM.MM_pScalePercent)/2 + 4
				else
					newX = 2
				end
				pa = math.pi * 0.5 - (pa - na)
				if pin:GetTop() <=  mmY then
					newY = mmHeight/2 - mmWidth/2 * math.sin(pa - na) / math.sin(math.pi * 0.5 - (pa - na))
				else
					newY = mmHeight/2 + mmWidth/2 * math.sin(pa - na) / math.sin(math.pi * 0.5 - (pa - na))
				end
			end
			if pin.m_PinType == MAP_PIN_TYPE_GROUP then
				MM_SetPinSize(borderpin, pin:GetDimensions())
			else
				MM_SetPinSize(borderpin, 32 * FyrMM.MM_pScalePercent, 0)
			end
			if FyrMM.SV.WheelMap then
				if pin:GetRight() >= mmX and pin:GetTop() >= mmY then
					newX = D/math.sqrt(1+m*m) + mmWidth/2
					newY = (m*D)/math.sqrt(1+m*m) + mmHeight/2
				end
				if pin:GetRight() >= mmX and pin:GetTop() < mmY then
					newX = D/math.sqrt(1+m*m) + mmWidth/2
					newY =  mmWidth/2 -(m*D)/math.sqrt(1+m*m)
				end
				if pin:GetRight() < mmX and pin:GetTop() < mmY then
					newX = mmWidth/2 - D/math.sqrt(1+m*m) 
					newY = mmWidth/2 - (m*D)/math.sqrt(1+m*m) 
				end
				if pin:GetRight() < mmX and pin:GetTop() >= mmY then
					newX = mmWidth/2 -D/math.sqrt(1+m*m)
					newY = (m*D)/math.sqrt(1+m*m) + mmWidth/2
				end
			end
			borderpin:SetHidden(false)
			borderpin:ClearAnchors()
			borderpin:SetAnchor(CENTER, Fyr_MM_Axis_Control, TOPLEFT, newX, newY)
		end
	return borderpin
end

function MM_PlaceBorderPins()
	local i, j, l, v
	if ((not FyrMM.Visible or Fyr_MM:IsHidden())) then return end
	for i=1, Fyr_MM_Axis_Border_Pins:GetNumChildren() do
		l = Fyr_MM_Axis_Border_Pins:GetChild(i)
		if l ~= nil then
			if FyrMM.SV.BorderPins then
				if not l.pin then
					l:SetHidden(true)
				else
					if not MM_Is_ValidBorderPin(l.pin) then
						MM_RemoveBorderPin(l)
					end
				end
			else
				MM_RemoveBorderPin(l)
			end
		end
	end
	if not FyrMM.SV.BorderPins then return end
	MM_PlaceWaypointBorderPins()
	if Fyr_MM_Axis_Control:IsHidden() and FyrMM.SV.BorderPins then
		Fyr_MM_Axis_Control:SetHidden(false)
	end
	for i, v in pairs(FyrMM.questPins) do
		if not v.Pin:IsHidden() and MM_Is_ValidBorderPin(v.Pin) then
			MM_CreateBorderPin(v.Pin)
		end
	end
	for i=1, 24 do
		l = Fyr_MM_Scroll_Map_Pins:GetNamedChild("group"..tostring(i))
		if l ~= nil then
			if not l:IsHidden() and MM_Is_ValidBorderPin(l) then 
				MM_CreateBorderPin(l)
			end
		end
	end
	if FyrMM.SV.BorderPinsBank or FyrMM.SV.BorderPinsStables or FyrMM.SV.BorderCrafting then
		for i=1, FyrMM.currentLocationsCount do
			l = GetControl("Fyr_MM_Scroll_Map_LocationPins_Pin"..tostring(i))
			if l ~= nil then
				if l.m_PinType == MAP_PIN_TYPE_LOCATION and MM_Is_ValidBorderPin(l) then
					MM_CreateBorderPin(l)
				end
			end
		end
	end
	if FyrMM.SV.BorderWayshrine and FyrMM.currentWayshrineCount > 0 then
		for i, v in pairs(FyrMM.Wayshrines) do 
			if v.Closest then
				l = GetControl("Fyr_MM_Scroll_Map_WayshrinePins_Pin"..tostring(i))
				if l ~= nil then
					MM_CreateBorderPin(l)
				end
			end
		end
	end
	if FyrMM.SV.BorderTreasures and not table.empty(FyrMM.Treasures) then
		for i, v in pairs(FyrMM.Treasures) do 
			if v ~= nil then
				if v.IsTreasure then
					MM_CreateBorderPin(v)
				end
			end
		end
	end
	if FyrMM.SV.BorderQuestGivers and not table.empty(FyrMM.AvailableQuestGivers) then
		if #FyrMM.AvailableQuestGivers <= 5 then
			for i, v in pairs(FyrMM.AvailableQuestGivers) do 
				if v ~= nil then
					if v.IsAvailableQuest then
						MM_CreateBorderPin(v)
					end
				end
			end
		else
			if GetFrameTimeMilliseconds() - FyrMM.AQGTimeStamp > 2000 then
				FyrMM.AQGTimeStamp = GetFrameTimeMilliseconds()
				FyrMM.AQGList = {}
				for j=1, #FyrMM.AvailableQuestGivers do
					table.insert(FyrMM.AQGList, {["nDistance"] = 1000, ["Index"] = 1})				
				end
				if FyrMM.AvailableQuestGivers[1].nDistance == nil then MM_QuestGiverDistances() end
				for j=1, #FyrMM.AQGList  do
					for i, v in pairs(FyrMM.AvailableQuestGivers) do 
						if v ~= nil then
							if v.nDistance == nil then return end
							if v.IsAvailableQuest then
								if j == 1 then
									if FyrMM.AQGList[1].nDistance > v.nDistance then
										FyrMM.AQGList[1].nDistance = v.nDistance
										FyrMM.AQGList[1].Index = i
									end
								else
									if FyrMM.AQGList[j-1].nDistance < v.nDistance and FyrMM.AQGList[j].nDistance > v.nDistance then
										FyrMM.AQGList[j].nDistance = v.nDistance
										FyrMM.AQGList[j].Index = i
									end
								end					
							end
						end
					end
				end
			end
			j = 0
			for i=1, #FyrMM.AQGList do
				l = FyrMM.AvailableQuestGivers[FyrMM.AQGList[i].Index]
				if l ~= nil then
					if MM_Is_ValidBorderPin(l) then
						MM_CreateBorderPin(l)
						j = j + 1
					end
				end
				if j > 5 then return end
			end
		end
	end
end

local function MM_RemoveBorderWaypoints()
	local l
	for i=1, Fyr_MM_Axis_Border_Pins:GetNumChildren() + 50 do
		l = GetControl("Fyr_MM_Axis_Border_Pins_Pin"..tostring(i))
		if l ~= nil then
			if l.pin ~= nil then
				if l.pin.m_Pin ~= nil then
					if l.pin.m_Pin.m_PinType ==  MAP_PIN_TYPE_PLAYER_WAYPOINT or l.pin.m_Pin.m_PinType == MAP_PIN_TYPE_RALLY_POINT  or l.pin.m_Pin.m_PinType == MAP_PIN_TYPE_PING then
						MM_RemoveBorderPin(l)
					end
				end
			end
		else
			return
		end
	end
end

function MM_PlaceWaypointBorderPins()
	MM_RemoveBorderWaypoints()
	if FyrMM.SV.BorderPinsWaypoint then
		if FyrMM.IsWaypoint then
			if not FyrMM.Waypoint:IsHidden() then
				MM_CreateBorderPin(FyrMM.Waypoint)
				if FyrMM.Waypoint.BorderPin then
					FyrMM.Waypoint.BorderPin:SetHandler("OnMouseEnter", function(pin) if pin.pin == nil then MM_RemoveBorderPin(pin) return end MM_SetTargetScale(pin, 1.3) if not FyrMM.SV.PinTooltips then return end
											InitializeTooltip(InformationTooltip, Fyr_MM, TOPLEFT, 0, 0) InformationTooltip:AppendMapPing(pin.pin.m_Pin.m_PinType, "player") MM_IsCurrentLocation(pin.pin) end)
					FyrMM.Waypoint.BorderPin:SetHandler("OnMouseExit", function(pin) MM_SetTargetScale(pin, 1) ClearTooltip(InformationTooltip) end)
					FyrMM.Waypoint.BorderPin:SetMouseEnabled(true)
				end
			else
				if  FyrMM.Waypoint.BorderPin ~= nil then
					MM_RemoveBorderPin(FyrMM.Waypoint)
				end
			end
		end
		if FyrMM.IsPing then
			if not FyrMM.Ping:IsHidden() then
				MM_CreateBorderPin(FyrMM.Ping)
				if FyrMM.Ping.BorderPin then
					FyrMM.Ping.BorderPin:SetHandler("OnMouseEnter", function(pin) if pin.pin == nil then MM_RemoveBorderPin(pin) return end MM_SetTargetScale(pin, 1.3) if not FyrMM.SV.PinTooltips then return end
											InitializeTooltip(InformationTooltip, Fyr_MM, TOPLEFT, 0, 0) InformationTooltip:AppendMapPing(pin.pin.m_Pin.m_PinType, "player") MM_IsCurrentLocation(pin.pin) end)
					FyrMM.Ping.BorderPin:SetHandler("OnMouseExit", function(pin) MM_SetTargetScale(pin, 1) ClearTooltip(InformationTooltip) end)
					FyrMM.Ping.BorderPin:SetMouseEnabled(true)
				end
			else
				if  FyrMM.Ping.BorderPin ~= nil then
					MM_RemoveBorderPin(FyrMM.Ping)
				end
			end
		end
		if FyrMM.IsRally then
			if not FyrMM.Rally:IsHidden() then
				MM_CreateBorderPin(FyrMM.Rally)
				if FyrMM.Rally.BorderPin then
					FyrMM.Rally.BorderPin:SetHandler("OnMouseEnter", function(pin) if pin.pin == nil then MM_RemoveBorderPin(pin) return end MM_SetTargetScale(pin, 1.3) if not FyrMM.SV.PinTooltips then return end
											InitializeTooltip(InformationTooltip, Fyr_MM, TOPLEFT, 0, 0) InformationTooltip:AppendMapPing(pin.pin.m_Pin.m_PinType, "player") MM_IsCurrentLocation(pin.pin) end)
					FyrMM.Rally.BorderPin:SetHandler("OnMouseExit", function(pin) MM_SetTargetScale(pin, 1) ClearTooltip(InformationTooltip) end)
					FyrMM.Rally.BorderPin:SetMouseEnabled(true)
				end
			else
				if  FyrMM.Rally.BorderPin ~= nil then
					MM_RemoveBorderPin(FyrMM.Rally)
				end
			end
		end
	end
end

-----------------------------------------------------------------
-- Pin Clean up
-----------------------------------------------------------------
local function MM_CleanupMapLocations()
	debug_d("MM_CleanupMapLocations "..tostring(GetFrameTimeMilliseconds()))
	local totalPins = Fyr_MM_Scroll_Map_LocationPins:GetNumChildren()
	if totalPins > FyrMM.currentLocationsCount then
		for i=FyrMM.currentLocationsCount+1, totalPins do
			local l = Fyr_MM_Scroll_Map_LocationPins:GetNamedChild("_Pin"..tostring(i))
			if l ~= nil then
				if l.BorderPin ~= nil then
					MM_RemoveBorderPin(l.BorderPin)
				end
				l:ClearAnchors()
				l:SetHidden(true)
				l.m_Pin = nil
			end
		end
	end
end

local function MM_CleanupWayshrines()
	debug_d("MM_CleanupWayshrines "..tostring(GetFrameTimeMilliseconds()))
	local totalPins = Fyr_MM_Scroll_Map_WayshrinePins:GetNumChildren()
	if totalPins > FyrMM.currentWayshrineCount then
		for i=FyrMM.currentWayshrineCount+1, totalPins do
			local l = Fyr_MM_Scroll_Map_WayshrinePins:GetNamedChild("_Pin"..tostring(i))
			if l ~= nil then
				if l.BorderPin ~= nil then
					MM_RemoveBorderPin(l.BorderPin)
				end
				l:ClearAnchors()
				l:SetHidden(true)
				l.m_Pin = nil
			end
		end
	end
end

local function MM_CleanupPOIs()
	local totalPins = Fyr_MM_Scroll_Map_POIPins:GetNumChildren()
	debug_d("MM_CleanupPOIs ("..tostring(FyrMM.currentPOICount+1).." - "..tostring(totalPins)..") "..tostring(GetFrameTimeMilliseconds()))
	if totalPins > FyrMM.currentPOICount then
		for i=FyrMM.currentPOICount+1, totalPins do
			local l = Fyr_MM_Scroll_Map_POIPins:GetNamedChild("_Pin"..tostring(i))
			if l ~= nil then
				l:ClearAnchors()
				l:SetHidden(true)
				l.m_Pin = nil
			end
		end
	end
end

local function MM_RemoveQuestPin(l)
	if l == nil then return end
	if l.MM_Tag ~= nil then
		if l.MM_Tag == 1 then
			if l.secondaryPin ~= nil then
				l.secondaryPin.MM_Tag = nil
				MM_RemoveQuestPin(l.secondaryPin)
			end
			if l.tertiaryPin ~= nil then
				l.tertiaryPin.MM_Tag = nil
				MM_RemoveQuestPin(l.tertiaryPin)
			end
		else
			if l.primaryPin ~= nil then
				l.primaryPin.MM_Tag = nil
				MM_RemoveQuestPin(l.primaryPin)
			end
		end
	end
	if l.OnBorder then
		if l.BorderPin then
			l.BorderPin:ClearAnchors()
			l.BorderPin:SetHidden()
			l.BorderPin.pin = nil
			l.BorderPin = nil
		end
		l.OnBorder = nil
	end
	if l.questdataIndex ~= nil then
		FyrMM.questPins[l.questdataIndex] = nil
	end
	l:SetParent(Fyr_MM_Scroll_Map_QuestPins)
	l:ClearAnchors()
	l:SetHidden(true)
	l.questdataIndex = nil
	l.MM_Tag = nil
	l.m_PinTag = nil
	l.m_PinType = nil
	l.m_Pin = nil
	l.normalizedX = nil
	l.normalizedY = nil
	l.areaRadius = nil
	l.ZoneIndex = nil
	l.questIndex = nil
	l.questName = nil
	l.PinToolTipText = nil
	l.primaryPin = nil
	l.secondaryPin = nil
	l.tertiaryPin = nil
	l.pinAge = nil
end

local function MM_CleanUpQuestPins() -- unconditional clean up
	debug_d("MM_CleanUpQuestPins "..tostring(GetFrameTimeMilliseconds()))
	FyrMM.questPins = {}
	FyrMM.requestedquestPins = {}
	local pinCount = Fyr_MM_Scroll_Map_QuestPins:GetNumChildren()
		for i = 1, pinCount+100 do
			local l = GetControl("Fyr_MM_Scroll_Map_QuestPins_Pin"..tostring(i))
			if l ~= nil then
				if l.MM_Tag ~= nil then
		if l.MM_Tag == 1 then
			if l.secondaryPin ~= nil then
				l.secondaryPin.MM_Tag = nil
				MM_RemoveQuestPin(l.secondaryPin)
			end
			if l.tertiaryPin ~= nil then
				l.tertiaryPin.MM_Tag = nil
				MM_RemoveQuestPin(l.tertiaryPin)
			end
		else
			if l.primaryPin ~= nil then
				l.primaryPin.MM_Tag = nil
				MM_RemoveQuestPin(l.primaryPin)
			end
				end
				end

				if l.OnBorder then
					if l.BorderPin then
						l.BorderPin:ClearAnchors()
						l.BorderPin:SetHidden()
						l.BorderPin.pin = nil
						l.BorderPin = nil
					end
					l.OnBorder = nil
				end
				if l.questdataIndex ~= nil then
					FyrMM.questPins[l.questdataIndex] = nil
					l.questdataIndex = nil
				end
				l:SetParent(Fyr_MM_Scroll_Map_QuestPins)
				l:ClearAnchors()
				l:SetHidden(true)
				l.m_PinTag = nil
				l.m_PinType = nil
				l.m_Pin = nil
				l.normalizedX = nil
				l.normalizedY = nil
				l.areaRadius = nil
				l.ZoneIndex = nil
				l.questName = nil
				l.PinToolTipText = nil
				l.primaryPin = nil
				l.secondaryPin = nil
				l.tertiaryPin = nil
				l.MM_Tag = nil
				l.pinAge = nil
			end
		end
end

--IsValidQuestIndex
function MM_RemoveInvalidQuestPins()
	local _
	local compleate
	local min, max
	for i, v in pairs(FyrMM.questPins) do
		local l = v.Pin
		if l ~= nil then
			if not l:IsHidden() then
				if l.questIndex ~= nil then
					if not IsValidQuestIndex(l.questIndex) or GetJournalQuestName(l.questIndex) ~= l.questName then
						MM_RemoveQuestPin(l)
					else
						if l.m_PinTag ~= nil and l.PinToolTipText ~= nil then
							if l.PinToolTipText ~= GenerateQuestConditionTooltipLine(l.m_PinTag[1], l.m_PinTag[3], l.m_PinTag[2]) then
								MM_RemoveQuestPin(l)
							else
								_, min, max, _, compleate, _ = GetJournalQuestConditionInfo(l.m_PinTag[1], l.m_PinTag[3], l.m_PinTag[2])
								if compleate then
									MM_RemoveQuestPin(l)
								end
							end
						else
							MM_RemoveQuestPin(l)
						end
					end
				else
					MM_RemoveQuestPin(l)
				end
			end
		end
	end
end

local function MM_CleanUpKeepNetwork()
	debug_d("MM_CleanUpKeepNetwork "..tostring(GetFrameTimeMilliseconds()))
	local l
	if not MM_IsCurrentMapCyrodiil() then
		for i=1, 100 do
			l = GetControl("Fyr_MM_Scroll_Map_Links_Link"..tostring(i))
			if l ~= nil then
				l:ClearAnchors()
				l:SetHidden(true)
			end
			l = GetControl("Fyr_MM_Scroll_Map_LinksNS_Link"..tostring(i))
			if l ~= nil then
				l:ClearAnchors()
				l:SetHidden(true)
			end
			l = GetControl("Fyr_MM_Scroll_Map_LinksWE_Link"..tostring(i))
			if l ~= nil then
				l:ClearAnchors()
				l:SetHidden(true)
			end
		end
	end
	local Count = Fyr_MM_Scroll_Map_Kill_Locations:GetNumChildren()
	for i=1, Count do
		l = Fyr_MM_Scroll_Map_Kill_Locations:GetChild(i)
		if l ~= nil then
			l:ClearAnchors()
			l:SetHidden(true)
		end
	end
	for i=1, 100 do
		l = GetControl("Fyr_MM_Scroll_Map_Locks_Lock"..tostring(i))
		if l ~= nil then
			l:ClearAnchors()
			l:SetHidden(true)
		end
	end
	local Count = Fyr_MM_Scroll_Map_ForwardCamps:GetNumChildren()
	for i=1, Count do
		l = Fyr_MM_Scroll_Map_ForwardCamps:GetChild(i)
		if l ~= nil then
			l:ClearAnchors()
			l:SetHidden(true)
		end
	end
	local Count = Fyr_MM_Scroll_Map_Objectives:GetNumChildren()
	for i=1, Count do
		l = Fyr_MM_Scroll_Map_Objectives:GetChild(i)
		if l ~= nil then
			l:ClearAnchors()
			l:SetHidden(true)
		end
	end
	local Count = Fyr_MM_Scroll_Map_Keeps:GetNumChildren()
	for i=1, Count do
		l = Fyr_MM_Scroll_Map_Keeps:GetChild(i)
		if l ~= nil then
			l:ClearAnchors()
			l:SetHidden(true)
		end
	end
	local uakeepCount = Fyr_MM_Scroll_Map_Keeps_Under_Attack:GetNumChildren()
	for i=1, uakeepCount do
		l = Fyr_MM_Scroll_Map_Keeps_Under_Attack:GetChild(i)
		if l ~= nil then
			l:ClearAnchors()
			l:SetHidden(true)
		end
	end
end


function MM_UpdateLabels()
	if not FyrMM.SV then return end -- too soon
	local currentMapName, _ = string.gsub(GetMapName(), "(%w+)[%^]+.*", "%1")
	local currentAreaName = string.gsub(GetPlayerLocationName(), "(%w+)[%^]+.*", "%1")
	if not FyrMM.SV.ZoneNameContents ~= nil then
		if FyrMM.SV.ZoneNameContents == "Classic (Map only)" then
			Fyr_MM_Zone:SetText(currentMapName)
		elseif FyrMM.SV.ZoneNameContents == "Map & Area" then
			if currentMapName  ~= currentAreaName then
				Fyr_MM_Zone:SetText(currentMapName.."\n"..currentAreaName)
			else
				Fyr_MM_Zone:SetText(currentMapName)
			end
		else
			Fyr_MM_Zone:SetText(currentAreaName)
		end
	else
		Fyr_MM_Zone:SetText(currentMapName)
	end
	Fyr_MM_ZoomLevel:SetText(tostring(FyrMM.currentMap.ZoomLevel))
end
-----------------------------------------------------------------
-- Updates
-----------------------------------------------------------------
local function MM_FinishDistanceMeasurement()
	if Fyr_MM:IsHidden() or not ZO_WorldMap:IsHidden() then return end
	FyrMM.DistanceMeasurementStarted = false
	if FyrMM.currentMap.TrueMapSize ~= nil and FyrMM.SV.MapTable[FyrMM.currentMap.filename].MapSize ~= nil then return end
	local x, y = FyrMM.MeasurementX, FyrMM.MeasurementY
	SetMapToPlayerLocation()
	local xl, yl = FyrMM.MeasurementXl, FyrMM.MeasurementYl
	local x2l, y2l, _ = GetMapPlayerPosition("player")
	local mapId = GetCurrentMapIndex()
	if mapId == nil then
		MapZoomOut()
		mapId = GetCurrentMapIndex()
	end
	local worldsize, multiplier
	multiplier = 1
	if mapId ~= 23 then
		SetMapToMapListIndex(1)
		worldsize = 33440   -- Assumed Tamriel size in feet taken from ZygorGuides
		-- Based on assumption that player constantly moves at the same speed anywhere - world size has to be adjusted to match it. According to Tamriel distance difference for some specific maps I made a few adjustments for the worldsizes while in those maps.
		-- Maps like Auridon or Glenumbra indicate same player speeds while Cyrodiil, Craglorn and starting maps show compleately different speeds (for mapsize 33440)
		if mapId == 14 then
			multiplier = 2.2 
		end
		if mapId == 18 then
			multiplier = 1.353
		end
		if mapId == 19 then
			multiplier = 2.6
		end
		if mapId == 20 or mapId == 21 then
			multiplier = 2.4865
		end
		if mapId == 22 then
			multiplier = 3.1
		end
		if mapId == 25 then
			multiplier = 1.087
		end
	else
		worldsize = 5684    -- Assumed Coldharbour size in feet
	end
	local x2, y2, _ = GetMapPlayerPosition("player")
	MM_SetMapToPlayerLocation()
	local localdistance = math.sqrt((xl-x2l)*(xl-x2l)+(yl-y2l)*(yl-y2l)) -- Local map distance
	local continentdistance = math.sqrt((x-x2)*(x-x2)+(y-y2)*(y-y2)) -- Tamriel/Coldharbour 
	local mapSize = (worldsize * continentdistance / localdistance) * multiplier
	if not (mapSize > 0) then -- Error
		FyrMM.DistanceMeasurementStarted = true
		return
	end
	FyrMM.SV.MapTable[FyrMM.currentMap.filename].MapSize = mapSize
	FyrMM.currentMap.TrueMapSize = mapSize
end

function MM_MeasureDistance()
	if FyrMM.SV.MapTable[FyrMM.currentMap.filename] ~= nil then
		if FyrMM.SV.MapTable[FyrMM.currentMap.filename].MapSize ~= nil then
			if FyrMM.SV.MapTable[FyrMM.currentMap.filename].MapSize > 0 then
				FyrMM.DistanceMeasurementStarted = false
				return
			end
		end
	end
	SetMapToPlayerLocation()
	FyrMM.MeasurementXl, FyrMM.MeasurementYl, _ = GetMapPlayerPosition("player")
	local mapId = GetCurrentMapIndex()
	if mapId == nil then
		MapZoomOut()
		mapId = GetCurrentMapIndex()
	end
	if mapId ~= 23 then
		SetMapToMapListIndex(1)
	end
	FyrMM.MeasurementX, FyrMM.MeasurementY, _ = GetMapPlayerPosition("player")
	FyrMM.DistanceMeasurementStarted = true
	MM_SetMapToPlayerLocation()
end

function MM_InCombatAutoHideCheck()
	if not FyrMM.SV.InCombatAutoHide then return end
	if IsUnitInCombat("player") then
		FyrMM.AfterCombatUnhidePending = false
		FyrMM.Visible = false
	else
		if Fyr_MM:IsHidden() then
			if not FyrMM.AfterCombatUnhidePending then
				FyrMM.AfterCombatUnhidePending = true
				FyrMM.AfterCombatUnhideTimeStamp = GetFrameTimeMilliseconds()
				zo_callLater(AfterCombatShow, 1000 * FyrMM.SV.AfterCombatUnhideDelay)
			end
		end
	end
end

function MM_HideCheck() -- fires every 100 ticks
	local siegeControlling = IsPlayerControllingSiegeWeapon()
	local menuHidden = ZO_KeybindStripControl:IsHidden()
	local interactHidden = ZO_InteractWindow:IsHidden()
	local gameMenuHidden = ZO_GameMenu_InGame:IsHidden()
	local crownStoreActive = WINDOW_MANAGER:IsSecureRenderModeEnabled()
	local frameRate = GetFramerate()
	if FyrMM.SV.ShowFPS or FyrMM.FpsTest then 
		if (frameRate < 20.0) then
	    Fyr_MM_FPS:SetColor(1, 0, 0, 1)
	elseif (frameRate < 30.0) then
	    Fyr_MM_FPS:SetColor(1, 0.6, 0, 1)
	elseif (frameRate < 60.0) then
			Fyr_MM_FPS:SetColor(0, 1, 0, 1)
		else
			Fyr_MM_FPS:SetColor(1, 1, 1, 1)
		end
		Fyr_MM_FPS:SetText(string.format(" %.1f", frameRate))
	end
	if FyrMM.SV.ShowClock then
		Fyr_MM_Time:SetText(GetTimeString())
		if Fyr_MM_Time:IsHidden() then Fyr_MM_Time:SetHidden(false) end
	else
		Fyr_MM_Time:SetHidden(true)
	end
	if not Fyr_MM:IsHidden() and FyrMM.FpsTest then
		if FyrMM.Fps == 0 then
			FyrMM.Fps = frameRate
		else
			FyrMM.Fps = (FyrMM.Fps + frameRate) / 2
		end
	end
	if not FyrMM.SV.ShowFPS and not FyrMM.FpsTest then
		Fyr_MM_FPS:SetText("")
		Fyr_MM_FPS:SetAlpha(0)
	end
	if Fyr_MM:IsHidden() and FyrMM.FpsTest then
		if FyrMM.FpsRaw == 0 then
			FyrMM.FpsRaw = frameRate
		else
			FyrMM.FpsRaw = (FyrMM.FpsRaw + frameRate) / 2
		end
	end
	MM_InCombatAutoHideCheck()
	if siegeControlling and FyrMM.SV.Siege then
		zo_callLater(MM_Show,200)
		return
	end
	if crownStoreActive then
		MM_Hide()
		return
	end
	if FyrMM.Visible == false or FyrMM.noMap == true then
		MM_Hide()
	elseif menuHidden == true and interactHidden == true and gameMenuHidden == true then
		zo_callLater(MM_Show,200)
	elseif menuHidden == false or interactHidden == false or gameMenuHidden == false then
		if gameMenuHidden == false then
			zo_callLater(MM_Show,200)
		else
			MM_Hide()
		end
	end
	if FyrMM.Visible == true and FyrMM.noMap == true then
		FyrMM.noMap = false;
		zo_callLater(MM_Reload,100)
		zo_callLater(MM_Show,200)
		return
	end
end

function MM_WorldMapShowHide()
	if ZO_WorldMap:IsHidden() then
		MM_UnregisterUpdates()
		MM_Hide()
	else
		zo_callLater(MM_SetMapToPlayerLocation,50)
	end
end

function MM_SetMapToPlayerLocation(stealth)
	local changed = false
	if not Stealth then
		if Fyr_MM:IsHidden() then return end
	end
	if FyrMM.DisableSubzones == true and GetMapType() ~= 1 then return end
	if not ZO_WorldMap:IsHidden() then return end
	if SetMapToPlayerLocation() ~= SET_MAP_RESULT_CURRENT_MAP_UNCHANGED  then
		changed = true
		if FyrMM.SV.WorldMapRefresh or stealth then
			CALLBACK_MANAGER:FireCallbacks("OnWorldMapChanged")
		end
	end
	if FyrMM.DisableSubzones == true and GetMapType() == 1 then
		MM_SetMapToZone()
	end
	return changed
end

function MM_Hide()
	if Fyr_MM:IsHidden() then return end
	MM_UnregisterUpdates()
	Fyr_MM:SetHidden(true)
	Fyr_MM_Wheel_Background:SetHidden(true)
	Fyr_MM_Menu:SetHidden(true)
	Fyr_MM_Coordinates:SetHidden(true)
	Fyr_MM_Axis_Control:SetHidden(true)
	Fyr_MM_Scroll_WheelCenter:SetHidden(true)
	Fyr_MM_Scroll_WheelNS:SetHidden(true)
	Fyr_MM_Scroll_WheelWE:SetHidden(true)
	Fyr_MM_Frame_Wheel:SetHidden(true)
	if not FyrMM.SV.ShowBorder then Fyr_MM_Border:SetAlpha(0) end
	Fyr_MM:SetMouseEnabled(false)
	Fyr_MM_Menu:SetMouseEnabled(false)
	Fyr_MM_FPS_Frame:SetHidden(true)
	Fyr_MM_ZoneFrame:SetHidden(true)
	Fyr_MM_Speed:SetHidden(true)
	Fyr_MM:SetMouseEnabled(false)
	Fyr_MM_Frame_Control:SetMouseEnabled(false)
	Fyr_MM_ZoneFrame:SetMouseEnabled(false)
	Fyr_MM_FPS_Frame:SetMouseEnabled(false)
end

function MM_Show_WheelScrolls()
	MM_UpdateMapTiles()
	Fyr_MM_Wheel_Background:SetHidden(not FyrMM.SV.WheelMap)
	Fyr_MM_Scroll_WheelCenter:SetHidden(not FyrMM.SV.WheelMap)
	Fyr_MM_Scroll_WheelNS:SetHidden(not FyrMM.SV.WheelMap)
	Fyr_MM_Scroll_WheelWE:SetHidden(not FyrMM.SV.WheelMap)
	Fyr_MM_Scroll:SetHorizontalScroll(FyrMM.currentMap.hpos)
	Fyr_MM_Scroll:SetVerticalScroll(FyrMM.currentMap.vpos)
	Fyr_MM_Scroll_WheelCenter:SetHorizontalScroll(FyrMM.currentMap.hpos)
	Fyr_MM_Scroll_WheelCenter:SetVerticalScroll(FyrMM.currentMap.vpos)
    Fyr_MM_Scroll_WheelNS:SetHorizontalScroll(FyrMM.currentMap.hpos)
	Fyr_MM_Scroll_WheelNS:SetVerticalScroll(FyrMM.currentMap.vpos)
    Fyr_MM_Scroll_WheelWE:SetHorizontalScroll(FyrMM.currentMap.hpos)
	Fyr_MM_Scroll_WheelWE:SetVerticalScroll(FyrMM.currentMap.vpos)
end

function MM_Show()
	if FyrMM.Halted and FyrMM.Visible and ZO_WorldMap:IsHidden() and FyrMM.HaltTimeOffset ~= 0 then
		if GetFrameTimeMilliseconds() - FyrMM.HaltTimeOffset > 1000 then
			MM_Register_Updates()
		end
	end
	if not (IsPlayerControllingSiegeWeapon() and FyrMM.SV.Siege) then 
		if not FyrMM.Visible or not ZO_WorldMap:IsHidden() or not ZO_KeybindStripControl:IsHidden() or not ZO_InteractWindow:IsHidden() or not ZO_GameMenu_InGame:IsHidden() or WINDOW_MANAGER:IsSecureRenderModeEnabled() then return end
	end
	if FyrMM.SV.hideCompass == true then
		ZO_CompassFrame:SetHidden(true)
	end
	MM_SetMapToPlayerLocation()
	if Fyr_MM:IsHidden() then
		zo_callLater(MM_Register_Updates,100)
		Fyr_MM_Frame_Wheel:SetHidden(not FyrMM.SV.WheelMap)
		if FyrMM.SV.WheelMap then
			zo_callLater(MM_Show_WheelScrolls, 20)
		end
		Fyr_MM_Frame_Control:SetHidden(not FyrMM.SV.WheelMap)
		Fyr_MM:SetHidden(false)
		Fyr_MM_Menu:SetHidden(FyrMM.SV.MenuDisabled)
		Fyr_MM_Menu:SetMouseEnabled(not FyrMM.SV.MenuDisabled)
		Fyr_MM_ZoneFrame:SetHidden(FyrMM.SV.HideZoneLabel)
		Fyr_MM_Coordinates:SetHidden(not FyrMM.SV.ShowPosition)
		Fyr_MM_Axis_Control:SetHidden(not (FyrMM.SV.RotateMap or FyrMM.SV.BorderPins))
		Fyr_MM_FPS_Frame:SetHidden(not FyrMM.SV.ShowFPS)
		Fyr_MM_Speed:SetHidden(not FyrMM.SV.ShowSpeed)
		Fyr_MM_ZoneFrame:SetMouseEnabled(true)
		Fyr_MM:SetMouseEnabled(true)
	end
	if FyrMM.SV.ShowBorder then
		Fyr_MM_Border:SetAlpha(100)
	end
	Fyr_MM:SetMouseEnabled(true)
end

function MM_ZoneUpdate()
	if FyrMM.SV.DisableSubzones then MM_ZoneCheck() end
end

function MM_ZoneCheck()
	if not ZO_WorldMap:IsHidden() then return end
	local filename, _, _ = GetCurrentMapTextureFileInfo()
	if filename == "tamriel_0" then zo_callLater(MM_ZoneCheck, 20) return end

	FyrMM.currentMapZoneId = GetCurrentMapZoneIndex()
	if FyrMM.currentMap.filename ~= filename then
		MM_UnregisterUpdates()
		if FyrMM.SV.ZoneList == nil then
			FyrMM.SV.ZoneList = {}
		end
		FyrMM.SV.ZoneList[GetCurrentMapZoneIndex()] = {TextureFile = filename}
		FyrMM.MovementSpeed = 0
		FyrMM.MovementSpeedPrevious = 0
		FyrMM.MovementSpeedMax = 0
		FyrMM.currentMap.PlayerNX, FyrMM.currentMap.PlayerNY, _ = GetMapPlayerPosition("player")
		FyrMM.currentMap.MapId = MM_GetMapId()
		CALLBACK_MANAGER:FireCallbacks("OnFyrMiniNewMapEntered")
	end
end

local function MM_TaskCount()
	local count = 0
	for i,v in pairs(FyrMM.currentTasks) do
		if FyrMM.currentTasks[i] ~= nil then
			if GetFrameTimeMilliseconds() - FyrMM.currentTasks[i].RequestTimeStamp < FYRMM_QUEST_PIN_REQUEST_TIMEOUT then
				count = count + 1
			else
				FyrMM.currentTasks[i] = nil
			end
		end
	end
	return count
end

local function TaskExists(tag)
	for i,v in pairs(FyrMM.currentTasks) do
		if FyrMM.currentTasks[i] ~= nil then
			if GetFrameTimeMilliseconds() - FyrMM.currentTasks[i].RequestTimeStamp < FYRMM_QUEST_PIN_REQUEST_TIMEOUT then
				if FyrMM.currentTasks[i][1] == tag[1] and FyrMM.currentTasks[i][2] == tag[2] and FyrMM.currentTasks[i][3] == tag[3]
				 and FyrMM.currentTasks[i].isBreadcrumb == tag.isBreadcrumb 
				 then return true end
			else
				--FyrMM.currentTasks[i] = nil
			end
		end
	end
	return false
end

local function MM_DestroyTasks()
	for i,v in pairs(FyrMM.currentTasks) do
		if FyrMM.currentTasks[i] ~= nil then
			FyrMM.currentTasks[i] = nil
		end
	end
end

local function MM_RemoveObsoleteQuestPins()
	for i,v in pairs(FyrMM.questPins) do
		if questpinDataExists(v, FyrMM.requestedquestPins) == nil then
			MM_RemoveQuestPin(v.Pin)
		end
	end
	local pinCount = Fyr_MM_Scroll_Map_QuestPins:GetNumChildren()
	local l
	local nilcount = 0
	for i = 1, pinCount+100 do
		l = GetControl("Fyr_MM_Scroll_Map_QuestPins_Pin"..tostring(i))
		if l == nil then
			nilcount = nilcount + 1
			if nilcount > 1 then return end
		end
		if l ~= nil and l.questdataIndex ~= nil then
			if FyrMM.questPins[l.questdataIndex] == nil then
				if  l.MM_Tag == nil then
					MM_RemoveQuestPin(l)
				else
					if l.MM_Tag == 1 then
						if l.secondaryPin ~= nil then
							l.secondaryPin.MM_Tag = nil
							MM_RemoveQuestPin(l.secondaryPin)
						end
						if l.tertiaryPin ~= nil then
							l.tertiaryPin.MM_Tag = nil
							MM_RemoveQuestPin(l.tertiaryPin)
						end
						l.MM_Tag = nil
						MM_RemoveQuestPin(l)
					end
				end
				zo_callLater(MM_RequestQuestPinUpdate,1000)
			end
		end
	end
end

local function MM_AddMissingQuestPins()
	local properType, pinTexture, size
	for i,v in pairs(FyrMM.requestedquestPins) do
		if questpinDataExists(v, FyrMM.questPins) == nil then
			properType, pinTexture, size = MM_GetQuestPinInfo(MAP_PIN_TYPE_TRACKED_QUEST_CONDITION, GetTrackedIsAssisted(TRACK_TYPE_QUEST, v.questIndex), v.isBreadcrumb, v.areaRadius)
			MM_CreateQuestPin(properType, v.tag, v.normalizedX, v.normalizedY, v.areaRadius)
			zo_callLater(MM_RequestQuestPinUpdate,1000)
		end
	end
end

function MM_PinUpdate()
	if FyrMM.Halted then return end
    if ((not FyrMM.Visible or Fyr_MM:IsHidden()) and FyrMM.Initialized) or not ZO_WorldMap:IsHidden() then return end
	MM_RemoveInvalidQuestPins()
	if MM_TaskCount() == 0 and FyrMM.QuestPinsUpdating and not FyrMM.QuestTasksPending then
		MM_RemoveObsoleteQuestPins()
		MM_AddMissingQuestPins()
		MM_GetNumBorderPins()
		FyrMM.QuestPinsUpdating = false
	end
    if (FyrMM.needQuestPinUpdate or FyrMM.questPinCount == 0) and MM_GetQuestJournalMaxValidIndex() > 0 then
		if not FyrMM.QuestPinsUpdating then
			if not (MM_TaskCount() == 0 and GetFrameTimeMilliseconds() - FyrMM.LastQuestPinRequest < FYRMM_QUEST_PIN_REQUEST_MINIMUM_DELAY) then
				FyrMM.requestedquestPins = {}
				MM_UpdateQuestPins()
				FyrMM.needQuestPinUpdate = false
			end
		end
	end
    if FyrMM.MM_Pin_Update_Needed then MM_CustomPins() end	
	if FyrMM.SV.BorderPins then
		for i=1, Fyr_MM_Axis_Border_Pins:GetNumChildren() do
			local l = Fyr_MM_Axis_Border_Pins:GetChild(i)
			if l ~= nil then
				if FyrMM.SV.BorderPins then
					if not l.pin then
						l:SetHidden(true)
					else
						if MM_IsPinVisible(l.pin) then
							MM_RemoveBorderPin(l)
						end
					end
				else
					MM_RemoveBorderPin(l)
				end
			end
		end
	end
end

function debug_d(value)
	if FyrMM.DebugMode then
		d("["..GetTimeString()..string.format("] %s",tostring(value)))
	end
end

local function MM_CleanupCustomPins()
	debug_d("MM_CleanupCustomPins "..tostring(GetFrameTimeMilliseconds()))
	local l
	for i=1, Fyr_MM_Scroll_Map_Pins:GetNumChildren() do  -- custom pin clean up
		l = Fyr_MM_Scroll_Map_Pins:GetChild(i)
		if l ~= nil then
			if l.BorderPin ~= nil then
				MM_RemoveBorderPin(l.BorderPin)
			end
			l:ClearAnchors()
			l:SetHidden(true)
			l.IsTreasure = nil
			l.IsAvailableQuest = nil
			l.pinTexture = nil
		end
	end
end

function MM_PinCleanup()
	debug_d("MM_PinCleanup "..tostring(GetFrameTimeMilliseconds()))
	MM_CleanupCustomPins()
	MM_CleanUpKeepNetwork()
	MM_CleanUpQuestPins()
	MM_CleanupMapLocations()
	MM_CleanupPOIs()
	MM_CleanupWayshrines()
	MM_GroupPins()
end

function MM_Reload()
	if FyrMM.Reloading then return end
	if GetFrameTimeMilliseconds() - FyrMM.LastReload < 500 then zo_callLater(MM_Reload, 100) return end -- eliminate reload spam
	debug_d("MM_Reload "..tostring(GetFrameTimeMilliseconds()))
	FyrMM.Reloading = true
	FyrMM.LastReload = GetFrameTimeMilliseconds()
	MM_UnregisterUpdates()
	MM_UpdateLabels()
	if FyrMM.Initialized then
		MM_SetMapToPlayerLocation()
	end
	zo_callLater(MM_PinCleanup, 1)
	FyrMM.DistanceMeasurementStarted = false
	FyrMM.MovementSpeedMax = 0
	FyrMM.questPinCount = 0
	FyrMM.currentLocationsCount = 0
	FyrMM.currentPOICount = 0
	FyrMM.currentForwardCamps = 0
	FyrMM.currentMapPins = 0
	FyrMM.currentWayshrineCount = 0
	MM_MeasureDistance()
	FyrMM.MM_Pin_Update_Needed = true
	MM_PlaceWaypointBorderPins()
	zo_callLater(MM_InitialPreload, 20)
	zo_callLater(MM_Register_Updates, 100)
	FyrMM.Reloading = nil
end

function MM_WheelScroll(x, y)
	if x and y then
		Fyr_MM_Scroll_WheelCenter:SetHorizontalScroll(x)
		Fyr_MM_Scroll_WheelCenter:SetVerticalScroll(y)
		Fyr_MM_Scroll_WheelNS:SetHorizontalScroll(x)
		Fyr_MM_Scroll_WheelNS:SetVerticalScroll(y)
		Fyr_MM_Scroll_WheelWE:SetHorizontalScroll(x)
		Fyr_MM_Scroll_WheelWE:SetVerticalScroll(y)
	end
end

function MM_PositionUpdate()
    if ((not FyrMM.Visible or Fyr_MM:IsHidden()) and FyrMM.Initialized) or not ZO_WorldMap:IsHidden() then return end
	local x, y, pheading = GetMapPlayerPosition("player")
	local currentTimeStamp = GetFrameTimeMilliseconds()
	local speed = 0
	local moved = (x ~= FyrMM.currentMap.PlayerNX or y ~= FyrMM.currentMap.PlayerNY)
	local cheading = GetPlayerCameraHeading()
	local cpheading = cheading
	if FyrMM.SV.RotateMap then
		cpheading =  math.abs(pheading - math.pi *2) + cheading
	end
	Fyr_MM_Camera:SetTextureRotation(cpheading)
	if FyrMM.DistanceMeasurementStarted and FyrMM.currentMap.MapId then
		if math.sqrt((x-FyrMM.MeasurementXl)*(x-FyrMM.MeasurementXl)+(y-FyrMM.MeasurementYl)*(y-FyrMM.MeasurementYl)) > 0.01 then MM_FinishDistanceMeasurement() end
	end
    Fyr_MM_Player_incombat:SetHidden(not (FyrMM.SV.InCombatState and IsUnitInCombat("player")))
	Fyr_MM_Position:SetText(string.format("%05.02f, %05.02f", zo_round(x*10000)/100, zo_round(y*10000)/100)) -- thanks Garkin
	Fyr_MM_Speed:SetHidden(not FyrMM.SV.ShowSpeed)
	if FyrMM.currentMap.SCNX == nil or FyrMM.currentMap.SCNY == nil or FyrMM.currentMap.currentTimeStap == nil or FyrMM.currentMap.SCMI == nil then
		FyrMM.currentMap.SCNX = x
		FyrMM.currentMap.SCNY = y
		FyrMM.currentMap.currentTimeStap = currentTimeStamp
		FyrMM.currentMap.SCMI = FyrMM.currentMap.MapId
	end
	if moved and (FyrMM.currentMap.SCNX ~= nil and FyrMM.currentMap.SCNY ~= nil and FyrMM.currentMap.TrueMapSize ~= nil and FyrMM.currentMap.currentTimeStap ~= nil) then
		if currentTimeStamp - FyrMM.currentMap.currentTimeStap > 100 and FyrMM.currentMap.SCMI == FyrMM.currentMap.MapId then
			speed = math.sqrt((x-FyrMM.currentMap.SCNX)*(x-FyrMM.currentMap.SCNX)+(y-FyrMM.currentMap.SCNY)*(y-FyrMM.currentMap.SCNY)) * FyrMM.currentMap.TrueMapSize / ((currentTimeStamp - FyrMM.currentMap.currentTimeStap)/10)
			FyrMM.currentMap.SCNX = x
			FyrMM.currentMap.SCNY = y
			FyrMM.currentMap.currentTimeStap = currentTimeStamp
			FyrMM.currentMap.SCMI = FyrMM.currentMap.MapId
			if speed*100 > 30 then -- sanity check
				if FyrMM.MovementSpeed ~= 0 then
					speed = FyrMM.MovementSpeed
				else
					speed = 0
				end
			end
			if FyrMM.MovementSpeed ~= 0 or speed ~= 0 then -- average
				speed = (FyrMM.MovementSpeed + speed ) /2 
				if FyrMM.MovementSpeedPrevious ~= 0 then
					speed = (FyrMM.MovementSpeedPrevious + speed ) /2
				end
			end
		else
			if FyrMM.MovementSpeed ~= 0 then
				speed = FyrMM.MovementSpeed
			end
		end
	end
	if FyrMM.MovementSpeedPrevious ~= FyrMM.MovementSpeed then
		CALLBACK_MANAGER:FireCallbacks("MovementSpeedChanged", speed*100)
		FyrMM.MovementSpeedPrevious = FyrMM.MovementSpeed
	end
	FyrMM.MovementSpeed = speed
	if speed > FyrMM.MovementSpeedMax then
		FyrMM.MovementSpeedMax = speed
	end
	if FyrMM.SV.ShowSpeed then
		if speed ~= 0 then
			Fyr_MM_SpeedLabel:SetText(string.format("(%05.02f ft/s)", zo_round(speed*10000)/100))
		else
			Fyr_MM_SpeedLabel:SetText("(0 ft/s)")
		end
	end
	FyrMM.currentMap.PlayerNX = x
	FyrMM.currentMap.PlayerNY = y
	zo_callLater(MM_WayshrineDistances, 1)
	if not table.empty(FyrMM.AvailableQuestGivers) and FyrMM.SV.BorderQuestGivers then zo_callLater(MM_QuestGiverDistances, 1) end
    if (not FyrMM.Visible or Fyr_MM:IsHidden()) and not FyrMM.Initialized then return end
	if Fyr_MM_Scroll_Map_0 == nil then return end
	local mapWidth = Fyr_MM_Scroll_Map_0:GetWidth()
	local mmWidth = Fyr_MM_Scroll:GetWidth()
	local widthCenter = math.floor(mmWidth / 2)
	if FyrMM.currentMap.Dx == nil then return end
	local mapWidth = mapWidth * FyrMM.currentMap.Dx
	local mapHeight = Fyr_MM_Scroll_Map_0:GetHeight()
	local mmHeight = Fyr_MM_Scroll:GetHeight()
	FyrMM.currentMap.PlayerX, FyrMM.currentMap.PlayerY = Fyr_MM_Scroll_Map:GetDimensions()
	FyrMM.currentMap.PlayerX = FyrMM.currentMap.PlayerX * x
	FyrMM.currentMap.PlayerY = FyrMM.currentMap.PlayerY * y
	local heightCenter = math.floor(mmHeight / 2)
	local mapHeight = mapHeight * FyrMM.currentMap.Dx 
	local stepping = MM_GetMapStepping()
	if speed > 11 then
		stepping = stepping * (speed / 5)
	end
	local hscroll = math.floor(x * (10000 / stepping))/(10000 / stepping) * mapWidth
	local hpos = zo_round((hscroll - widthCenter)*10000)/10000
	local vscroll = math.floor(y * (10000 / stepping))/(10000 / stepping) * mapHeight
	local vpos = zo_round((vscroll - heightCenter)*10000)/10000
	local zoomlevel = 0
	local chp, cvp = Fyr_MM_Scroll:GetScrollOffsets()
	local heading = pheading

	if FyrMM.SV.PPStyle ~= GetString(SI_MM_STRING_PLAYERANDCAMERA) then
		if FyrMM.SV.Heading == "CAMERA" then
			heading = cheading
		end
		if not moved and FyrMM.SV.Heading == "MIXED" then
			heading = cheading
		end
	end
	if moved and FyrMM.SV.BorderPins then
		zo_callLater(MM_PlaceBorderPins, 1)
	end
	if zo_round(chp/stepping) ~= zo_round(hpos/stepping) or zo_round(cvp/stepping) ~= zo_round(vpos/stepping) then -- scroll stepping for smoother UI performance
		if ((x < 1.2 and x > -0.2) and (y < 1.2 and y > - 0.2)) then -- Can't let the scroll go too far outside view (Black map issue)
			if not Fyr_MM:IsHidden() then MM_SetMapToPlayerLocation() end
			FyrMM.currentMap.hpos = hpos
			FyrMM.currentMap.vpos = vpos
			if FyrMM.SV.RotateMap then
    			Fyr_MM_Scroll:SetHorizontalScroll(0)
				Fyr_MM_Scroll:SetVerticalScroll(0)
				MM_UpdateMapTiles(true)
			else
    			Fyr_MM_Scroll:SetHorizontalScroll(hpos)
				Fyr_MM_Scroll:SetVerticalScroll(vpos)
			end
			if FyrMM.SV.WheelMap then
				MM_RescalePinPositions()
				MM_WheelScroll(FyrMM.currentMap.hpos, FyrMM.currentMap.vpos)
			end
		else
    		Fyr_MM_Scroll:SetHorizontalScroll(FyrMM.currentMap.hpos)
			Fyr_MM_Scroll:SetVerticalScroll(FyrMM.currentMap.vpos)
			if FyrMM.SV.WheelMap then
				MM_UpdateMapTiles(true)
				MM_RescalePinPositions()
				MM_WheelScroll(FyrMM.currentMap.hpos, FyrMM.currentMap.vpos)
			 end
		end
	end
	FyrMM.currentMap.Heading = math.abs(heading - math.pi *2)
	if FyrMM.SV.RotateMap then
		MM_UpdateMapTiles(true)
		Fyr_MM_Player:SetTextureRotation(0)
		MM_AxisPins()
		MM_RescalePinPositions()
	else
		Fyr_MM_Player:SetTextureRotation(heading)
	end
end

-------------------------------------------------------------
-- Map Building
-------------------------------------------------------------
-- get map info for minimap
function MM_UpdateMapInfo()
	debug_d("MM_UpdateMapInfo "..tostring(GetFrameTimeMilliseconds()))
	FyrMM.currentMap = {} 
	FyrMM.currentMap.ready = false
	FyrMM.currentMap.name = GetMapName()
	FyrMM.currentMap.tileTexture = string.lower(GetMapTileTexture())
	FyrMM.currentMap.Dx, FyrMM.currentMap.Dy = GetMapNumTiles()
	FyrMM.currentMap.filename, FyrMM.currentMap.nameNoNum, FyrMM.currentMap.path = GetCurrentMapTextureFileInfo()
	if FyrMM.currentMap.Dx < 2 or FyrMM.currentMap.Dy < 2 or FyrMM.currentMap.Dx == nil or FyrMM.currentMap.Dy == nil then
		if FyrMM.MapTable[string.lower(FyrMM.currentMap.filename)] then
			FyrMM.currentMap.Dx = FyrMM.MapTable[string.lower(FyrMM.currentMap.filename)].Dx
			FyrMM.currentMap.Dy = FyrMM.MapTable[string.lower(FyrMM.currentMap.filename)].Dy
		else
			FyrMM.currentMap.Dx = 3
			FyrMM.currentMap.Dy = 3
		end
	end
	FyrMM.currentMap.type = GetMapType() 

-- if we have no texture we have nothing further to do
	if FyrMM.currentMap.tileTexture == "" or FyrMM.currentMap.Dx == nil or FyrMM.currentMap.Dy == nil then
		FyrMM.noMap = true;
		return 
	else
		FyrMM.noMap = false;
	end
	
	FyrMM.currentMap.numTiles = FyrMM.currentMap.Dx * FyrMM.currentMap.Dy
	if string.lower(FyrMM.currentMap.filename) == "tamriel_0" then zo_callLater(MM_UpdateMapInfo, 5) return end

	FyrMM.currentMap.TrueMapSize = nil
	if FyrMM.MapTable[string.lower(FyrMM.currentMap.filename)] ~= nil then
		if FyrMM.MapTable[string.lower(FyrMM.currentMap.filename)].MapSize > 0 then
			FyrMM.currentMap.TrueMapSize = FyrMM.MapTable[string.lower(FyrMM.currentMap.filename)].MapSize
		end
	end
	-- store tile textures in table
	FyrMM.currentMap.tiles = {}
	for i = 1, FyrMM.currentMap.numTiles do
		table.insert(FyrMM.currentMap.tiles, string.lower(GetMapTileTexture(i)))
	end
	if FyrMM.SV.MapTable[FyrMM.currentMap.filename] == nil then
		FyrMM.SV.MapTable[FyrMM.currentMap.filename] = {}
	end
	if FyrMM.MapTable[string.lower(FyrMM.currentMap.filename)] ~= nil then
		FyrMM.currentMap.MapId = FyrMM.MapTable[string.lower(FyrMM.currentMap.filename)].MapId
		if FyrMM.currentMap.TrueMapSize == nil then
			if FyrMM.SV.MapTable[FyrMM.currentMap.filename].MapSize then 
				FyrMM.currentMap.TrueMapSize = FyrMM.SV.MapTable[FyrMM.currentMap.filename].MapSize
			end
		else
			FyrMM.SV.MapTable[FyrMM.currentMap.filename].MapSize = FyrMM.currentMap.TrueMapSize
		end 
	else
		FyrMM.currentMap.MapId = "unknown"
	end

	if FyrMM.SV.MapTable[FyrMM.currentMap.filename].ZoomLevel then
		FyrMM.currentMap.ZoomLevel = FyrMM.SV.MapTable[FyrMM.currentMap.filename].ZoomLevel
	else
		FyrMM.currentMap.ZoomLevel = FYRMM_DEFAULT_ZOOM_LEVEL
		FyrMM.SV.MapTable[FyrMM.currentMap.filename].ZoomLevel = FyrMM.currentMap.ZoomLevel
	end
	FyrMM.currentMap.ready = true
	CALLBACK_MANAGER:FireCallbacks("OnFyrMiniMapChanged")
end

-- gets tile scale for map
function MM_GetTileDimensions()
	local texW, texH = Fyr_MM_Scroll_Map_0:GetTextureFileDimensions()
	if (texW < 256 or texH < 256) or  (texW > 1024 or texH > 1024) or texW == nil or texH == nil then
		if string.lower(FyrMM.currentMap.filename) ~= nil then
			if FyrMM.MapTable[string.lower(FyrMM.currentMap.filename)] ~= nil then
				texW = FyrMM.MapTable[string.lower(FyrMM.currentMap.filename)].TextureSize
				texH = FyrMM.MapTable[string.lower(FyrMM.currentMap.filename)].TextureSize
			else -- unknown Map
				texW = 256
				texH = 256
			end
		else -- unknown Map
			texW = 256
			texH = 256
		end
	end
	local dx, dy = GetMapNumTiles()
	if dx < 2 or dy < 2 or dx == nil or dy == nil then
		dx = FyrMM.MapTable[string.lower(FyrMM.currentMap.filename)].Dx
		dy = FyrMM.MapTable[string.lower(FyrMM.currentMap.filename)].Dy
	end
	local zoomlevel = FyrMM.currentMap.ZoomLevel
	if zoomlevel == nil then zoomlevel = FYRMM_DEFAULT_ZOOM_LEVEL end
	local tileX = math.floor(zo_round(((FyrMM.currentMap.ZoomLevel/10) * texW * dx) / dx)/2)*2
	local tileY = math.floor(zo_round(((FyrMM.currentMap.ZoomLevel/10) * texW * dy) / dy)/2)*2
	return tileX,tileY
end

function MM_Pins()
	FyrMM.needQuestPinUpdate = true
	zo_callLater(MM_LocationPins,33)
	zo_callLater(MM_POIPins,36)
	zo_callLater(MM_Wayshrines,38)
	zo_callLater(MM_GroupEvent,40)
	zo_callLater(MM_UpdateQuestPins,200)
	zo_callLater(MM_CustomPins, 100)
end

function MM_UpdateMapTiles(timeStamp)
	if (not FyrMM.Visible or Fyr_MM:IsHidden()) and not FyrMM.Initialized then return end
	if not FyrMM.currentMap.ready then return end
	if string.lower(FyrMM.currentMap.filename) == "tamriel_0" then return end
	local MM_TileSizeW, MM_TileSizeH = MM_GetTileDimensions()
	if Fyr_MM_Scroll_Map_0:GetTextureFileName() == FyrMM.currentMap.tiles[1] and
		zo_round(Fyr_MM_Scroll_Map_0:GetWidth()) == zo_round(MM_TileSizeW) and
		zo_round(Fyr_MM_Scroll_Map_0:GetHeight()) == zo_round(MM_TileSizeH) then if timeStamp  == GetFrameTimeMilliseconds() then return end
	else
		if Fyr_MM_Scroll_Map_0:GetTextureFileName() ~= FyrMM.currentMap.tiles[1] then
			zo_callLater(MM_Pins, 2500)
		else
			MM_RescalePinPositions()
		end
	end -- nothing to update if same map
	debug_d("MM_UpdateMapTiles "..tostring(timeStamp))
	local sa, sb, centerSize
	local i = 0
	local tileControl
	local MM_TileSizeW, MM_TileSizeH = MM_GetTileDimensions()
	local mWidth, mHeight = MM_TileSizeW * FyrMM.currentMap.Dx, MM_TileSizeH * FyrMM.currentMap.Dy
	Fyr_MM_Scroll_Map:SetDimensions(mWidth, mHeight)
	if not FyrMM.SV.WheelMap then
		Fyr_MM_Bg:SetColor(0,0,0,1)
		Fyr_MM_Scroll_WheelNS:SetHidden(true)
		Fyr_MM_Scroll_WheelCenter:SetHidden(true)
		Fyr_MM_Scroll_WheelWE:SetHidden(true)
	else
		Fyr_MM_Bg:SetColor(1,1,1,0)
		--Fyr_MM_Scroll_Map:SetHidden(true)
		Fyr_MM_Border:SetHidden(true)
		sa = Fyr_MM:GetWidth() - ((50 / 512) * Fyr_MM:GetWidth())
		sb = (220 / 512) * Fyr_MM:GetWidth()
		Fyr_MM_Scroll_WheelWE:SetDimensions(sa, sb)
		Fyr_MM_Scroll_WheelNS:SetDimensions(sb, sa)
		Fyr_MM_Frame_Control:SetDimensions(Fyr_MM:GetWidth(), Fyr_MM:GetWidth())
		Fyr_MM_Frame_Wheel:SetDimensions(Fyr_MM:GetWidth()+8, Fyr_MM:GetWidth()+8)
		if FyrMM.SV.RotateMap then
			Fyr_MM_Frame_Wheel:SetTextureRotation(FyrMM.currentMap.Heading)
		end
		centerSize = math.sqrt(2 * Fyr_MM:GetWidth() * Fyr_MM:GetWidth()) / 2
		Fyr_MM_Scroll_WheelCenter:SetDimensions(centerSize, centerSize)
		if not FyrMM.currentMap.PlayerX or not FyrMM.currentMap.PlayerY or not FyrMM.currentMap.Heading then
			local x, y, pheading = GetMapPlayerPosition("player")
			FyrMM.currentMap.PlayerNX = x
			FyrMM.currentMap.PlayerNY = y
			FyrMM.currentMap.PlayerX, FyrMM.currentMap.PlayerY = Fyr_MM_Scroll_Map:GetDimensions()
			FyrMM.currentMap.PlayerX = FyrMM.currentMap.PlayerX * x
			FyrMM.currentMap.PlayerY = FyrMM.currentMap.PlayerY * y
			FyrMM.currentMap.Heading = pheading
		end

	end
	local tilec, tilens, tilewe
	local tileposX, tileposY, x, y
	for a=1, FyrMM.currentMap.Dy do
		for b=1, FyrMM.currentMap.Dx do
			i = i + 1
			if GetControl("Fyr_MM_Scroll_Map_"..tostring(i - 1)) == nil then
				tileControl = WINDOW_MANAGER:CreateControl("Fyr_MM_Scroll_Map_"..tostring(i - 1), Fyr_MM_Scroll_Map, CT_TEXTURE)
			else
				tileControl = GetControl("Fyr_MM_Scroll_Map_"..tostring(i - 1))
			end
			if GetControl("Fyr_MM_Scroll_WNS_Map_"..tostring(i - 1)) == nil then
				tilens = WINDOW_MANAGER:CreateControl("Fyr_MM_Scroll_WNS_Map_"..tostring(i - 1), Fyr_MM_Scroll_WheelNS, CT_TEXTURE)
			else
				tilens = GetControl("Fyr_MM_Scroll_WNS_Map_"..tostring(i-1))
			end
			if GetControl("Fyr_MM_Scroll_CW_Map_"..tostring(i - 1)) == nil then
				tilec = WINDOW_MANAGER:CreateControl("Fyr_MM_Scroll_CW_Map_"..tostring(i - 1), Fyr_MM_Scroll_WheelCenter, CT_TEXTURE)
			else
				tilec = GetControl("Fyr_MM_Scroll_CW_Map_"..tostring(i-1))
			end
			if GetControl("Fyr_MM_Scroll_WWE_Map_"..tostring(i - 1)) == nil then
				tilewe = WINDOW_MANAGER:CreateControl("Fyr_MM_Scroll_WWE_Map_"..tostring(i - 1), Fyr_MM_Scroll_WheelWE, CT_TEXTURE)
			else
				tilewe = GetControl("Fyr_MM_Scroll_WWE_Map_"..tostring(i - 1))
			end
			tileControl:SetHidden(FyrMM.SV.WheelMap)
			tilens:SetHidden(not FyrMM.SV.WheelMap)
			tilec:SetHidden(not FyrMM.SV.WheelMap)
			tilewe:SetHidden(not FyrMM.SV.WheelMap)
			tileControl:SetTexture(FyrMM.currentMap.tiles[i])
			tilens:SetTexture(FyrMM.currentMap.tiles[i])
			tilec:SetTexture(FyrMM.currentMap.tiles[i])
			tilewe:SetTexture(FyrMM.currentMap.tiles[i])
			tileControl:SetDimensions(MM_GetTileDimensions())
			tilens:SetDimensions(MM_GetTileDimensions())
			tilec:SetDimensions(MM_GetTileDimensions())
			tilewe:SetDimensions(MM_GetTileDimensions())
			tileControl:SetDrawLayer(0)
			tilens:SetDrawLayer(1)
			tilec:SetDrawLayer(1)
			tilewe:SetDrawLayer(1)
			if FyrMM.SV.RotateMap then
				if not FyrMM.currentMap.PlayerX or not FyrMM.currentMap.PlayerY or not FyrMM.currentMap.Heading then
					local x, y, pheading = GetMapPlayerPosition("player")
					FyrMM.currentMap.PlayerNX = x
					FyrMM.currentMap.PlayerNY = y
					FyrMM.currentMap.PlayerX, FyrMM.currentMap.PlayerY = Fyr_MM_Scroll_Map:GetDimensions()
					FyrMM.currentMap.PlayerX = FyrMM.currentMap.PlayerX * x
					FyrMM.currentMap.PlayerY = FyrMM.currentMap.PlayerY * y
					FyrMM.currentMap.Heading = pheading
				end
				x = ((b-0.5) * mWidth/FyrMM.currentMap.Dx) - FyrMM.currentMap.PlayerX
				y = ((a-0.5) * mHeight/FyrMM.currentMap.Dy) - FyrMM.currentMap.PlayerY
				tileposX = (math.cos(-FyrMM.currentMap.Heading) * x) - (math.sin(-FyrMM.currentMap.Heading) * y)
				tileposY = (math.sin(-FyrMM.currentMap.Heading) * x) + (math.cos(-FyrMM.currentMap.Heading) * y)
				tileControl:SetTextureRotation(FyrMM.currentMap.Heading,0.5,0.5);
				tilens:SetTextureRotation(FyrMM.currentMap.Heading,0.5,0.5);
				tilec:SetTextureRotation(FyrMM.currentMap.Heading,0.5,0.5);
				tilewe:SetTextureRotation(FyrMM.currentMap.Heading,0.5,0.5);
				tilens:ClearAnchors()
				tilec:ClearAnchors()
				tilewe:ClearAnchors()
				if FyrMM.SV.MapAlpha > 80 then 
					tilens:SetScale(1.0055)
					tilec:SetScale(1.0055)
					tilewe:SetScale(1.0055)
					tileControl:SetScale(1.0055)
				else
					tilens:SetScale(1)
					tilec:SetScale(1)
					tilewe:SetScale(1)
					tileControl:SetScale(1)
				end
				tileControl:SetAnchor(CENTER, Fyr_MM_Scroll, CENTER, tileposX, tileposY)
				tilens:SetAnchor(CENTER, Fyr_MM_Scroll_WheelNS, CENTER, tileposX, tileposY)
				tilec:SetAnchor(CENTER, Fyr_MM_Scroll_WheelCenter, CENTER, tileposX, tileposY)
				tilewe:SetAnchor(CENTER, Fyr_MM_Scroll_WheelWE, CENTER, tileposX, tileposY)
			else
				tileposX = ((b-0.5) * mWidth/FyrMM.currentMap.Dx) - mWidth/2
				tileposY = ((a-0.5) * mHeight/FyrMM.currentMap.Dy) - mHeight/2
				tileControl:SetScale(1)
				tilens:SetScale(1)
				tilec:SetScale(1)
				tilewe:SetScale(1)
				tileControl:SetTextureRotation(0);
				tilens:SetTextureRotation(0);
				tilec:SetTextureRotation(0);
				tilewe:SetTextureRotation(0);
				tileControl:ClearAnchors()
				tilens:ClearAnchors()
				tilec:ClearAnchors()
				tilewe:ClearAnchors()
				tileControl:SetAnchor(CENTER, Fyr_MM_Scroll_Map, CENTER, tileposX, tileposY)
				tilens:SetAnchor(CENTER, Fyr_MM_Scroll_Map, CENTER, tileposX, tileposY)
				tilec:SetAnchor(CENTER, Fyr_MM_Scroll_Map, CENTER, tileposX, tileposY)
				tilewe:SetAnchor(CENTER, Fyr_MM_Scroll_Map, CENTER, tileposX, tileposY)
			end
			
		end
	end
	for j=i, Fyr_MM_Scroll_Map:GetNumChildren() do
		tileControl = GetControl("Fyr_MM_Scroll_Map_"..tostring(j))
		tilens = GetControl("Fyr_MM_Scroll_WNS_Map_"..tostring(j))
		tilec = GetControl("Fyr_MM_Scroll_CW_Map_"..tostring(j))
		tilewe = GetControl("Fyr_MM_Scroll_WWE_Map_"..tostring(j))		
		if (tileControl) then
			tileControl:ClearAnchors()
			tileControl:SetHidden(true)
		end
		if (tilens) then
			tilens:ClearAnchors()
			tilens:SetHidden(true)
		end
		if (tilec) then
			tilec:ClearAnchors()
			tilec:SetHidden(true)
		end
		if (tilewe) then
			tilewe:ClearAnchors()
			tilewe:SetHidden(true)
		end
	end
end

function MM_GetScrollObject(control)
	local xl = control:GetLeft()
	local xr = control:GetRight()
	local yt = control:GetTop()
	local yb = control:GetBottom()
	if FyrMM.SV.WheelMap then
		if (xr >= Fyr_MM_Scroll_WheelCenter:GetLeft() + 6 and xl <= Fyr_MM_Scroll_WheelCenter:GetRight() - 10 and yb >= Fyr_MM_Scroll_WheelCenter:GetTop() + 6 and yt <= Fyr_MM_Scroll_WheelCenter:GetBottom() - 10) then
			return Fyr_MM_Scroll_WheelCenter
		end
		if (xr >= Fyr_MM_Scroll_WheelNS:GetLeft() + 6 and xl <= Fyr_MM_Scroll_WheelNS:GetRight() - 10 and yb >= Fyr_MM_Scroll_WheelNS:GetTop() + 6 and yt <= Fyr_MM_Scroll_WheelNS:GetBottom() - 10) then
			return Fyr_MM_Scroll_WheelNS
		end
		if (xr >= Fyr_MM_Scroll_WheelWE:GetLeft() + 6 and xl <= Fyr_MM_Scroll_WheelWE:GetRight() - 10 and yb >= Fyr_MM_Scroll_WheelWE:GetTop() + 6 and yt <= Fyr_MM_Scroll_WheelWE:GetBottom() - 10) then
			return Fyr_MM_Scroll_WheelWE
		end
	else
		return Fyr_MM_Scroll_Map
	end
	return Fyr_MM_Scroll_WheelCenter
end


-----------------------------------------------------------------
-- Map Pins
-----------------------------------------------------------------
local function GetPinTexture(pinType, control)
	if type(ZO_MapPin.PIN_DATA[pinType].texture) == 'string' then
		return ZO_MapPin.PIN_DATA[pinType].texture
	elseif type(ZO_MapPin.PIN_DATA[pinType].texture) == 'function' then
	if(control.m_PinTag.isBreadcrumb) then
	    return breadcrumbQuestPinTextures[pinType]
	else
	    return questPinTextures[pinType]
	end
		return ZO_MapPin.PIN_DATA[pinType].texture(control)
	end
end

function MM_UpdateCustomPinPositions()
	if not FyrMM.Visible or Fyr_MM:IsHidden() or not ZO_WorldMap:IsHidden() or FyrMM.CustomPinsCopying then return end
	local currentZone = MM_GetMapId()
	local mWidth, mHeight = Fyr_MM_Scroll_Map:GetDimensions()
	for i=1, FyrMM.currentMapPins do
		p = Fyr_MM_Scroll_Map_Pins:GetChild(i)
		if p.nX ~= nil and p.nY ~= nil then
			if p.ZoneIndex == currentZone then
					p:SetHidden(not MM_IsCoordinateInRange(p.nX, p.nY))
				if not p:IsHidden() then
					if p.pinTexture ~= nil then
						if p.pinTexture ~= p:GetTextureFileName() then
							p:SetTexture(p.pinTexture)
						end
					end
					MM_SetPinAnchor(p, p.nX, p.nY, Fyr_MM_Scroll_Map_Pins)
					if p.m_Pin:IsMapPing() then
						MM_CreateBorderPin(p)
					end
				end
			else
				p:SetHidden(true)
				p:ClearAnchors()
			end
		end
	end
end

local function MM_InsertCustomPin(v)
	local pin, vb, color, pinTexture, pinSize, pinTooltipInfo
	local mWidth, mHeight = Fyr_MM_Scroll_Map:GetDimensions()
	local mPin = v.m_Pin
	FyrMM.currentMapPins = FyrMM.currentMapPins + 1
	if GetControl("Fyr_MM_Scroll_Map_Pins_Pin"..tostring(FyrMM.currentMapPins)) == nil then
		pin = WINDOW_MANAGER:CreateControl("Fyr_MM_Scroll_Map_Pins_Pin"..tostring(FyrMM.currentMapPins), Fyr_MM_Scroll_Map_Pins, CT_TEXTURE)
	else 
		pin = GetControl("Fyr_MM_Scroll_Map_Pins_Pin"..tostring(FyrMM.currentMapPins))
	end
	pin.IsTreasure = nil
	pin.IsAvailableQuest = nil
	pin.pinTexture = nil
	if pin.BorderPin ~= nil then
		MM_RemoveBorderPin(pin.BorderPin)
	end
	pin.m_Pin = mPin
	pin.ZoneIndex = v.ZoneIndex
	pin.nX = mPin.normalizedX
	pin.nY = mPin.normalizedY
   	-- Apply pin color if applicable
	if v:GetNumChildren() > 0 then -- Pulling Pin colors from Background
		vb = v:GetNamedChild("Background")
		if vb ~= nil then 
			pin:SetColor(vb:GetColor())
		end
	else
		color = ZO_MapPin.PIN_DATA[v.m_Pin.m_PinType].color -- get ZO_MapPin color if available
    	if type(color) == "table" then
			pin:SetColor(unpack(color))
		else
			pin:SetColor(1,1,1,1)
		end
	end
	if pin.m_Pin ~= nil then
		if pin.m_Pin.m_PinType == MAP_PIN_TYPE_PLAYER_WAYPOINT then
			FyrMM.IsWaypoint = true
			if FyrMM.Waypoint ~= nil then
				if FyrMM.Waypoint.BorderPin ~= nil then
					MM_RemoveBorderPin(FyrMM.Waypoint.BorderPin)
				end
			end
			FyrMM.Waypoint = pin
		end
		if pin.m_Pin.m_PinTag ~= nil then
			if type(pin.m_Pin.m_PinTag) == "table" then
				if pin.m_Pin.m_PinTag.IsAvailableQuest then
					pin.IsAvailableQuest = true
					table.insert(FyrMM.AvailableQuestGivers, pin)
				end
			end
		end
	end
	pin:SetHidden(false)
	pin:SetDrawLayer(1)
	pinTexture = ""
	if type(ZO_MapPin.PIN_DATA[mPin.m_PinType].texture) == 'string' then
		pinTexture = ZO_MapPin.PIN_DATA[mPin.m_PinType].texture
	elseif type(ZO_MapPin.PIN_DATA[mPin.m_PinType].texture) == 'function' then
		pinTexture = ZO_MapPin.PIN_DATA[mPin.m_PinType].texture(mPin)
	end
	pin:SetTexture(pinTexture)
	pin.pinTexture = pinTexture
	if string.sub(string.lower(pinTexture),1,12) == "losttreasure" then
		pin.IsTreasure = true
		table.insert(FyrMM.Treasures, pin)
	end
	pinSize = v:GetDesiredHeight() * FyrMM.MM_pScalePercent
	if (pin.m_Pin.m_PinType == MAP_PIN_TYPE_RALLY_POINT) then
		pin:SetTexture("MiniMap/Textures/rally.dds")
		pinSize = 32 * FyrMM.MM_pScalePercent
		FyrMM.IsRally = true
		if FyrMM.Rally ~= nil then
			if FyrMM.Rally.BorderPin ~= nil then
				MM_RemoveBorderPin(FyrMM.Rally.BorderPin)
			end
		end
		FyrMM.Rally = pin
	end
	if (pin.m_Pin.m_PinType == MAP_PIN_TYPE_PING) then
		pin:SetTexture("MiniMap/Textures/ping.dds")
		pinSize = 32 * FyrMM.MM_pScalePercent
		FyrMM.IsPing = true
		if FyrMM.Ping ~= nil then
			if FyrMM.Ping.BorderPin ~= nil then
				MM_RemoveBorderPin(FyrMM.Ping.BorderPin)
			end
		end
		FyrMM.Ping = pin
	end
	if (FyrMM.IsWaypoint or FyrMM.IsRally or FyrMM.IsPing) and FyrMM.SV.BorderPinsWaypoint then
		MM_PlaceWaypointBorderPins()
	end
	MM_SetPinSize(pin, pinSize, 0)
	MM_SetPinAnchor(pin, pin.nX, pin.nY, Fyr_MM_Scroll_Map_Pins)
	pinTooltipInfo = ZO_MapPin.TOOLTIP_CREATORS[mPin.m_PinType]
	pin:SetHandler("OnMouseEnter", function(pin) MM_SetTargetScale(pin, 1.3) if not FyrMM.SV.PinTooltips then return end if pinTooltipInfo == nil then return end
	   				if pinTooltipInfo.tooltip then InitializeTooltip(InformationTooltip, Fyr_MM, TOPLEFT, 0, 0) end
					pinTooltipInfo.creator(pin.m_Pin) MM_IsCurrentLocation(pin) end)
	pin:SetHandler("OnMouseExit", function(pin) MM_SetTargetScale(pin, 1) if pinTooltipInfo == nil then return end
					if pinTooltipInfo.tooltip then ClearTooltip(InformationTooltip) end end)
	pin:SetMouseEnabled(true)
end

local function MM_ClearCustomPinReminder()
	for i=FyrMM.currentMapPins+1, Fyr_MM_Scroll_Map_Pins:GetNumChildren() do
		local l = Fyr_MM_Scroll_Map_Pins:GetChild(i)
		if l ~= nil then
			if l.BorderPin ~= nil then
				MM_RemoveBorderPin(l.BorderPin)
			end
			l:ClearAnchors()
			l:SetHidden(true)
			l.m_Pin = nil
			l.IsTreasure = nil
			l.IsAvailableQuest = nil
			l.pinTexture = nil
		end
	end
end

function MM_CustomPins()
	if FyrMM.Halted then return end
    if not FyrMM.Visible or Fyr_MM:IsHidden() or not ZO_WorldMap:IsHidden() or not FyrMM.MM_Pin_Update_Needed then return end
	if GetFrameTimeMilliseconds() - FyrMM.LastReload < FyrMM.SV.PinRefreshRate * 2 then return end -- Grace time after reload
	debug_d("MM_CustomPins "..tostring(GetFrameTimeMilliseconds()))
	local numChildren = ZO_WorldMapContainer:GetNumChildren()
	FyrMM.Treasures = {}
	FyrMM.AvailableQuestGivers = {}
	FyrMM.CustomPinsCopying = true
	local currentMap, currentZone, _, pinTexture
	MM_SetMapToPlayerLocation()
	currentMap, _, _ = GetCurrentMapTextureFileInfo()
	FyrMM.currentMapPins = 0
	FyrMM.IsWaypoint = false
	FyrMM.Waypoint = nil
	FyrMM.IsRally = false
	FyrMM.Rally = nil
	FyrMM.IsPing = false
	FyrMM.Ping = nil
	currentZone = MM_GetMapId(currentMap)
	if currentZone ~= MM_GetMapId() then -- Very important to get fresh info from the Map at this point!
		CALLBACK_MANAGER:FireCallbacks("OnWorldMapChanged") 
		FyrMM.CustomPinsCopying = false
		zo_callLater(MM_CustomPins, 50)
		return
	end
	for child=1, numChildren do
		childControl = ZO_WorldMapContainer:GetChild(child)
		if childControl.m_Pin ~= nil then
			if childControl.m_Pin:GetUnitTag() ~= 'player'
				and childControl.m_Pin.m_PinType ~= nil and childControl.m_Pin.normalizedX ~= nil and childControl.m_Pin.normalizedY ~= nil then
					if not FyrMM.Visible or Fyr_MM:IsHidden() or not ZO_WorldMap:IsHidden() then MM_ClearCustomPinReminder() return end -- additional check
					if childControl.m_Pin.m_PinType >= MAP_PIN_TYPE_INVALID then
						childControl.ZoneIndex = currentZone
						
						MM_InsertCustomPin(childControl)
					else
						if childControl.m_Pin.m_PinType == MAP_PIN_TYPE_RALLY_POINT or childControl.m_Pin.m_PinType == MAP_PIN_TYPE_PING or childControl.m_Pin.m_PinType == MAP_PIN_TYPE_PLAYER_WAYPOINT then
							childControl.ZoneIndex = currentZone
							MM_InsertCustomPin(childControl)
						end
					end
			end
		end
	end
	MM_ClearCustomPinReminder()
	FyrMM.MM_Pin_Update_Needed = false
	FyrMM.CustomPinsCopying = false
end

------------------------------------------------------------
-- Wayshrine Pins
-----------------------------------------------------------
function MM_UpdateWayshrinePinPositions()
	if not FyrMM.Visible or Fyr_MM:IsHidden() or not ZO_WorldMap:IsHidden() then return end
	local currentZone = MM_GetMapId()
	for i=1, FyrMM.currentWayshrineCount do
		local l = GetControl("Fyr_MM_Scroll_Map_WayshrinePins_Pin"..tostring(i))
		if l ~= nil then
			if l.ZoneIndex == currentZone then
				l:SetHidden(not ZO_WorldMap_IsPinGroupShown(MAP_FILTER_WAYSHRINES))
				MM_SetPinAnchor(l, l.nX, l.nY, Fyr_MM_Scroll_Map_WayshrinePins)
			else
				l:SetHidden(true)
				l:ClearAnchors()
			end
		end
	end
end

local function MM_CreateWayshrinePin(pinType, tag, nX, nY)
	if GetControl("Fyr_MM_Scroll_Map_WayshrinePins_Pin"..tostring(FyrMM.currentWayshrineCount)) == nil then
		wayshrinePin = WINDOW_MANAGER:CreateControl("Fyr_MM_Scroll_Map_WayshrinePins_Pin"..tostring(FyrMM.currentWayshrineCount), Fyr_MM_Scroll_Map_WayshrinePins, CT_TEXTURE)
	else
		wayshrinePin = GetControl("Fyr_MM_Scroll_Map_WayshrinePins_Pin"..tostring(FyrMM.currentWayshrineCount))
	end
	local pin = ZO_Object.New(ZO_MapPin)
	local pinSize = 40 * FyrMM.MM_pScalePercent
	pin.m_PinType = pinType
	pin.m_PinTag = tag
	pin.nX = nX
	pin.nY = nY
	wayshrinePin.m_Pin = pin
	wayshrinePin.ZoneIndex = MM_GetMapId()
	wayshrinePin.nX = nX
	wayshrinePin.nY = nY
	wayshrinePin:SetDrawLayer(1)
	MM_SetPinSize(wayshrinePin, pinSize, 0)
	wayshrinePin:SetTexture(tag[2])
	wayshrinePin:SetHidden(not ZO_WorldMap_IsPinGroupShown(MAP_FILTER_WAYSHRINES))
	MM_SetPinAnchor(wayshrinePin, nX, nY, Fyr_MM_Scroll_Map_WayshrinePins)
	wayshrinePin:SetHandler("OnMouseEnter", function(pin) MM_SetTargetScale(pin, 1.3) if not FyrMM.SV.PinTooltips then return end InitializeTooltip(InformationTooltip, Fyr_MM, TOPLEFT, 0, 0) SetTooltipMessage(pin.m_Pin) end)
	wayshrinePin:SetHandler("OnMouseExit", function(pin) MM_SetTargetScale(pin, 1) ClearTooltip(InformationTooltip) end)
	wayshrinePin:SetHandler("OnMouseUp", function(pin) if not MM_IsCurrentMapCyrodiil() and FyrMM.SV.FastTravelEnabled then
									if MM_IsCurrentLocation(pin.m_Pin) then return end -- No need to recall if player is near wayshrine
										local nodeIndex = pin.m_Pin:GetFastTravelNodeIndex()
										ZO_Dialogs_ReleaseDialog("FAST_TRAVEL_CONFIRM")
										local name = select(2, GetFastTravelNodeInfo(nodeIndex))
										ZO_Dialogs_ShowDialog("FAST_TRAVEL_CONFIRM", {nodeIndex = nodeIndex, recall = true}, {mainTextParams = {name}}) 
       								end end)
	wayshrinePin:SetMouseEnabled(true)
end

function MM_Wayshrines()
	if FyrMM.Halted then zo_callLater(MM_Wayshrines, 20) return end
	if not FyrMM.Visible or Fyr_MM:IsHidden() or not ZO_WorldMap:IsHidden() then return end
	MM_SetMapToPlayerLocation()
	local mapContentType = GetMapContentType()
	FyrMM.currentWayshrineCount = 0
	FyrMM.Wayshrines = {}
	if FyrMM.currentMap.filename ~= "giantsrun_base_0" then
		for nodeIndex = 1, GetNumFastTravelNodes() do
			local known, name, nX, nY, icon, glowIcon, poiType = GetFastTravelNodeInfo(nodeIndex)
			if known or FyrMM.SV.ShowUnexploredPins then
				if not known then icon = "/esoui/art/icons/poi/poi_wayshrine_incomplete.dds" glowIcon = "/esoui/art/icons/poi/poi_wayshrine_glow.dds" end
				local tag = ZO_MapPin.CreateTravelNetworkPinTag(nodeIndex, icon, glowIcon)
				local pinType = MAP_PIN_TYPE_FAST_TRAVEL_WAYSHRINE
				if nX > 0 and nX < 1.0001 and nY > 0 and nY < 1.0001 then
					FyrMM.currentWayshrineCount = FyrMM.currentWayshrineCount + 1
					MM_CreateWayshrinePin(pinType, tag, nX, nY)
					FyrMM.Wayshrines[FyrMM.currentWayshrineCount] = {Closest = false, nDistance = 1, tag = tag, nX = nX, nY = nY, MapId = MM_GetMapId()}
				end
			end
		end
	end
	MM_CleanupWayshrines()
end
------------------------------------------------------------
-- POI Pins
------------------------------------------------------------
function MM_UpdatePOIPinPositions()
	for i=1, FyrMM.currentPOICount do
		local l = Fyr_MM_Scroll_Map_POIPins:GetNamedChild("_Pin"..tostring(i))
		if l ~= nil then
			if l.ZoneIndex == MM_GetMapId() then
				l:SetHidden(not ZO_WorldMap_IsPinGroupShown(MAP_FILTER_OBJECTIVES))
				MM_SetPinAnchor(l, l.nX, l.nY, Fyr_MM_Scroll_Map_POIPins)
			else
				l:SetHidden(true)
				l:ClearAnchors()
			end
		end
	end
end

local function MM_CreatePOIPin(poiIndex)
    local nX, nY, iconType, icon = MM_GetPOIMapInfo(FyrMM.currentMapZoneId, poiIndex)
	if CraftingStations ~= nil and zo_strfind(icon, "icons/poi/poi_crafting_") then return end -- Crafting stations mix-up fix by Garkin
	if not (ZO_MapPin.POI_PIN_TYPES[iconType]) and FyrMM.SV.ShowUnexploredPins then icon = "/esoui/art/inventory/newitem_icon.dds" iconType = MAP_PIN_TYPE_POI_SEEN end
    if nX > 0 and nX < 1.0001 and nY > 0 and nY < 1.0001 and (ZO_MapPin.POI_PIN_TYPES[iconType]) then
        if(not IsPOIWayshrine(FyrMM.currentMapZoneId, poiIndex) or iconType == MAP_PIN_TYPE_POI_SEEN ) then
			FyrMM.currentPOICount = FyrMM.currentPOICount + 1
            local tag = ZO_MapPin.CreatePOIPinTag(FyrMM.currentMapZoneId, poiIndex, icon)
			if Fyr_MM_Scroll_Map_POIPins:GetNamedChild("_Pin"..tostring(FyrMM.currentPOICount)) == nil then
				POIPin = WINDOW_MANAGER:CreateControl("Fyr_MM_Scroll_Map_POIPins_Pin"..tostring(FyrMM.currentPOICount), Fyr_MM_Scroll_Map_POIPins, CT_TEXTURE)
			else
				POIPin = Fyr_MM_Scroll_Map_POIPins:GetNamedChild("_Pin"..tostring(FyrMM.currentPOICount))
			end
			local pin = ZO_Object.New(ZO_MapPin)
			local pinSize = 40 * FyrMM.MM_pScalePercent
			if icon == "/esoui/art/inventory/newitem_icon.dds" then
				pinSize = 32 * FyrMM.MM_pScalePercent
				POIPin:SetColor(FyrMM.SV.UndiscoveredPOIPinColor.r, FyrMM.SV.UndiscoveredPOIPinColor.g, FyrMM.SV.UndiscoveredPOIPinColor.b, FyrMM.SV.UndiscoveredPOIPinColor.a)
			else
				POIPin:SetColor(1, 1, 1, 1)
			end
			POIPin.poiIndex = poiIndex
			pin.m_PinType = iconType
			pin.m_PinTag = tag
			POIPin.m_Pin = pin
			POIPin.ZoneIndex = MM_GetMapId()
			POIPin.nX = nX
			POIPin.nY = nY
			POIPin:SetDrawLayer(1)
			MM_SetPinSize(POIPin, pinSize, 0)
			POIPin:SetTexture(icon)
			POIPin:SetHidden(not ZO_WorldMap_IsPinGroupShown(MAP_FILTER_OBJECTIVES))
			MM_SetPinAnchor(POIPin, nX, nY, Fyr_MM_Scroll_Map_POIPins)
			POIPin:SetHandler("OnMouseEnter", function(pin) MM_SetTargetScale(pin, 1.3) if not FyrMM.SV.PinTooltips then return end InitializeTooltip(InformationTooltip, Fyr_MM, TOPLEFT, 0, 0) SetTooltipMessage(pin.m_Pin) MM_IsCurrentLocation(pin) end)
			POIPin:SetHandler("OnMouseExit", function(pin) MM_SetTargetScale(pin, 1) ClearTooltip(InformationTooltip) end)
			POIPin:SetMouseEnabled(true)
        end
    end
end

function MM_POIPins()
	if FyrMM.Halted then zo_callLater(MM_POIPins, 20) return end  -- delay if still halted
	FyrMM.currentPOICount = 0
	MM_API_Check()
	MM_SetMapToPlayerLocation()
	if FyrMM.currentMap.filename ~= "giantsrun_base_0" then
		for i = 1, MM_GetNumPOIs(FyrMM.currentMapZoneId) do
			MM_CreatePOIPin(i)
		end
	end
	MM_CleanupPOIs()
end

------------------------------------------------------------
-- Location Pins
------------------------------------------------------------

function MM_UpdateLocationPinPositions()
	for i=1, FyrMM.currentLocationsCount do
		local l = Fyr_MM_Scroll_Map_LocationPins:GetNamedChild("_Pin"..tostring(i))
		if l ~= nil then
			if l.ZoneIndex == MM_GetMapId() then
				if FyrMM.SV.ShowUnexploredPins then
					l:SetHidden(false)
				else
					if l:IsHidden() then l:SetHidden(not MM_IsMapLocationVisible(i)) end
				end
				MM_SetPinAnchor(l, l.nX, l.nY, Fyr_MM_Scroll_Map_LocationPins)
			else
				l:SetHidden(true)
				l:ClearAnchors()
			end
		end
	end
end

local function MM_AddLocation(locationIndex)
	if(MM_IsMapLocationVisible(locationIndex) or FyrMM.SV.ShowUnexploredPins) then
		local icon, x, y = MM_GetMapLocationIcon(locationIndex)
		if icon ~= "" and x > 0 and x < 1.0001 and y > 0 and y < 1.0001 then
			FyrMM.currentLocationsCount = FyrMM.currentLocationsCount + 1
            local tag = ZO_MapPin.CreateLocationPinTag(locationIndex, icon)
			if Fyr_MM_Scroll_Map_LocationPins:GetNamedChild("_Pin"..tostring(FyrMM.currentLocationsCount)) == nil then
				locationPin = WINDOW_MANAGER:CreateControl("Fyr_MM_Scroll_Map_LocationPins_Pin"..tostring(FyrMM.currentLocationsCount), Fyr_MM_Scroll_Map_LocationPins, CT_TEXTURE)
			else
				locationPin = Fyr_MM_Scroll_Map_LocationPins:GetNamedChild("_Pin"..tostring(FyrMM.currentLocationsCount))
			end
			local pinSize = 36 * FyrMM.MM_pScalePercent
			local pin = ZO_Object.New(ZO_MapPin)
			locationPin.locationIndex = locationIndex
			pin.m_PinType = MAP_PIN_TYPE_LOCATION
			pin.m_PinTag = tag
			locationPin.m_Pin = pin
			locationPin.m_PinType = MAP_PIN_TYPE_LOCATION
			locationPin.m_PinTag = tag
			locationPin.ZoneIndex = MM_GetMapId()
			locationPin.nX = x
			locationPin.nY = y
			MM_SetPinSize(locationPin, pinSize, 0)
			locationPin:SetDrawLayer(1)
			locationPin:SetTexture(icon)
			locationPin.IsCraftingServicePin = IsCraftingService(locationPin)
			if tag[2] ~= nil then
				if string.sub(tag[2],-8) == "bank.dds" then
					locationPin.IsBankPin = true
				else
					locationPin.IsBankPin = false
				end
				if string.sub(tag[2],-10) == "stable.dds" then
					locationPin.IsStablePin = true
				else
					locationPin.IsStablePin = false
				end
			end
			if string.sub(icon, 1, 17) ~= "ZygorGuidesViewer" then
				if FyrMM.SV.ShowUnexploredPins then
					locationPin:SetHidden(false)
				else
					if locationPin:IsHidden() then locationPin:SetHidden(not MM_IsMapLocationVisible(i)) end
				end
			else
				locationPin:SetHidden(false)
			end
			MM_SetPinAnchor(locationPin, x, y, Fyr_MM_Scroll_Map_LocationPins)
			local pinTooltipInfo = ZO_MapPin.TOOLTIP_CREATORS[MAP_PIN_TYPE_LOCATION]
			locationPin:SetHandler("OnMouseEnter", function(pin) MM_SetTargetScale(pin, 1.3) if not FyrMM.SV.PinTooltips then return end if pinTooltipInfo.tooltip then InitializeTooltip(ZO_MapLocationTooltip, Fyr_MM, TOPLEFT, 0, 0) pinTooltipInfo.creator(pin.m_Pin) MM_IsCurrentLocation(pin) end end)
			locationPin:SetHandler("OnMouseExit", function(pin) MM_SetTargetScale(pin, 1) ClearTooltip(ZO_MapLocationTooltip) end)
			locationPin:SetMouseEnabled(true)
        end
    end
end

function MM_LocationPins()
	if FyrMM.Halted then zo_callLater(MM_LocationPins, 20) return end -- delay if still halted
	FyrMM.currentLocationsCount = 0
	MM_API_Check()
	MM_SetMapToPlayerLocation()
	if FyrMM.currentMap.filename ~= "giantsrun_base_0" then
		for i = 1, MM_GetNumMapLocations() do
			MM_AddLocation(i)
		end
	end
	MM_CleanupMapLocations()
end

------------------------------------------------------------
-- Group Pins
------------------------------------------------------------
function MM_GroupEvent()
	MM_GroupPins()
end

function MM_SetGroupPinTexture(gmPin)
	local LeaderPinSize = FyrMM.SV.LeaderPinSize * FyrMM.MM_pScalePercent
	local MemberPinSize = FyrMM.SV.MemberPinSize * FyrMM.MM_pScalePercent
	local gmPinTexture =""
	local groupInfoTable = {}
	local isgmDps, isgmHeal, isgmTank = GetGroupMemberRoles(gmPin.unitTag)
	if IsUnitGroupLeader(gmPin.unitTag) then
		if FyrMM.SV.LeaderPin == "Default" then
			gmPinTexture = "EsoUI/Art/Compass/groupLeader.dds"
		elseif FyrMM.SV.LeaderPin == "Class" then
			gmPinTexture = GetClassIcon(GetUnitClassId(gmPin.unitTag))
		elseif isgmDps then
		gmPinTexture = "EsoUI/Art/LFG/LFG_dps_down.dds"
    	elseif isgmHeal then
		gmPinTexture = "EsoUI/Art/LFG/LFG_healer_down.dds"
    	elseif isgmTank then
		gmPinTexture = "EsoUI/Art/LFG/LFG_tank_down.dds"
    	else
		gmPinTexture = "EsoUI/Art/Compass/groupLeader.dds"
    	end
		gmPin.m_PinType = MAP_PIN_TYPE_GROUP_LEADER
		MM_SetPinSize(gmPin, LeaderPinSize, 0)
	else
		if FyrMM.SV.MemberPin == "Default" then
			gmPinTexture = "EsoUI/Art/MapPins/UI-WorldMapGroupPip.dds"
		elseif FyrMM.SV.MemberPin == "Class" then
			gmPinTexture = GetClassIcon(GetUnitClassId(gmPin.unitTag))
		elseif isgmDps then
		gmPinTexture = "EsoUI/Art/LFG/LFG_dps_down.dds"
    	elseif isgmHeal then
		gmPinTexture = "EsoUI/Art/LFG/LFG_healer_down.dds"
    	elseif isgmTank then
		gmPinTexture = "EsoUI/Art/LFG/LFG_tank_down.dds"
    	else
			gmPinTexture = "EsoUI/Art/MapPins/UI-WorldMapGroupPip.dds"
		end
		gmPin.m_PinType = MAP_PIN_TYPE_GROUP
		MM_SetPinSize(gmPin, MemberPinSize, 0)
	end
	gmPin:SetTexture(gmPinTexture)
end

function MM_GroupPins()
	if FyrMM.Halted then return end
	local groupSize = GetGroupSize()
	if groupSize == 0 then -- clean up if no group
		if FyrMM.IsGroup then
			for i=1, 24 do
				local ogmPin = Fyr_MM_Scroll_Map_Pins:GetNamedChild("group"..tostring(i))
				if ogmPin ~= nil then
					ogmPin:SetHidden(true)
		 			ogmPin:ClearAnchors()
					if ogmPin.OnBorder then
						if ogmPin.BorderPin then
							ogmPin.BorderPin:ClearAnchors()
							ogmPin.BorderPin:SetHidden()
							ogmPin.BorderPin.pin = nil
							ogmPin.BorderPin = nil
						end
						ogmPin.OnBorder = nil
					end
				end
				local ogmPinInCombat = GetControl("Fyr_MM_Scroll_Map_Pinsgroup"..tostring(i).."_incombat")
				if ogmPinInCombat ~= nil then
					ogmPinInCombat:SetHidden(true)
		 			ogmPinInCombat:ClearAnchors()
				end
			end
		end
		FyrMM.IsGroup = false
		return
	else -- make sure members who left also get cleaned
		debug_d("MM_GroupPins "..tostring(GetFrameTimeMilliseconds()))
		for i = 1, 24 do
			local tag = "group"..tostring(i)
			local ogmPin = GetControl("Fyr_MM_Scroll_Map_Pins"..tag)
			if ogmPin ~= nil and not DoesUnitExist(tag) then -- member left
				ogmPin:SetHidden(true)
		 		ogmPin:ClearAnchors()
				if ogmPin.OnBorder then
					if ogmPin.BorderPin then
						ogmPin.BorderPin:ClearAnchors()
						ogmPin.BorderPin:SetHidden()
						ogmPin.BorderPin.pin = nil
						ogmPin.BorderPin = nil
					end
					ogmPin.OnBorder = nil
				end
				local ogmPinInCombat = GetControl("Fyr_MM_Scroll_Map_Pinsgroup"..tostring(i).."_incombat")
				if ogmPinInCombat ~= nil then
					ogmPinInCombat:SetHidden(true)
		 			ogmPinInCombat:ClearAnchors()
				end
			end
		end
	end
	FyrMM.IsGroup = true
	for i=1, groupSize do
		local gmTag = GetGroupUnitTagByIndex(i)
		local gmPin = nil
		local mW, mH = Fyr_MM_Scroll_Map:GetDimensions()
		if DoesUnitExist(gmTag) and not AreUnitsEqual("player", gmTag) then
			local isgmDead = IsUnitDead(gmTag)
			local isgmInCombat = IsUnitInCombat(gmTag)
			local isgmLeader = IsUnitGroupLeader(gmTag)
			if GetControl("Fyr_MM_Scroll_Map_Pins"..gmTag) == nil then
				gmPin = WINDOW_MANAGER:CreateControl("Fyr_MM_Scroll_Map_Pins"..gmTag, Fyr_MM_Scroll_Map_Pins, CT_TEXTURE)
			else 
				gmPin = GetControl("Fyr_MM_Scroll_Map_Pins"..gmTag)
			end
			if GetControl("Fyr_MM_Scroll_Map_Pins"..gmTag.."_incombat") == nil then
				gmPinInCombat = WINDOW_MANAGER:CreateControl("Fyr_MM_Scroll_Map_Pins"..gmTag.."_incombat", Fyr_MM_Scroll_Map_Pins, CT_TEXTURE)
				if gmPinInCombat ~= nil then
					gmPinInCombat:SetTexture("esoui/art/mappins/ava_attackburst_32.dds")
				end
			else 
				gmPinInCombat = GetControl("Fyr_MM_Scroll_Map_Pins"..gmTag.."_incombat")
			end
			if gmPin ~= nil then
				gmPin.unitTag = gmTag
				if isgmLeader then
					gmPin.m_PinType = MAP_PIN_TYPE_GROUP_LEADER
					if FyrMM.SV.LeaderPinColor ~= nil and FyrMM.SV.LeaderDeadPinColor ~= nil then
						if isgmDead then
							gmPin:SetColor(FyrMM.SV.LeaderDeadPinColor.r, FyrMM.SV.LeaderDeadPinColor.g, FyrMM.SV.LeaderDeadPinColor.b, FyrMM.SV.LeaderDeadPinColor.a)
						else
							gmPin:SetColor(FyrMM.SV.LeaderPinColor.r, FyrMM.SV.LeaderPinColor.g, FyrMM.SV.LeaderPinColor.b, FyrMM.SV.LeaderPinColor.a)
						end
					end
				else
					gmPin.m_PinType = MAP_PIN_TYPE_GROUP
					if FyrMM.SV.MemberPinColor ~= nil then
						if isgmDead then
							gmPin:SetColor(FyrMM.SV.MemberDeadPinColor.r, FyrMM.SV.MemberDeadPinColor.g, FyrMM.SV.MemberDeadPinColor.b, FyrMM.SV.MemberDeadPinColor.a)
						else
							gmPin:SetColor(FyrMM.SV.MemberPinColor.r, FyrMM.SV.MemberPinColor.g, FyrMM.SV.MemberPinColor.b, FyrMM.SV.MemberPinColor.a)
						end
					end
				end
				MM_SetGroupPinTexture(gmPin)
				MM_SetPinSize(gmPinInCombat, gmPin:GetDesiredHeight()+6, 0)
				gmPin:SetDrawLayer(3)
				gmPinInCombat:SetDrawLayer(2)
				local pinTooltipInfo = ZO_MapPin.TOOLTIP_CREATORS[gmPin.m_PinType]
				gmPin:SetHandler("OnMouseEnter", function(gmPin) MM_SetTargetScale(gmPin, 1.3)
								if not FyrMM.SV.PinTooltips then return end
								InitializeTooltip(InformationTooltip, Fyr_MM, TOPLEFT, 0, 0)
								InformationTooltip:AppendUnitName(gmPin.unitTag) end)
				gmPin:SetHandler("OnMouseExit", function(gmPin) MM_SetTargetScale(pin, 1)	ClearTooltip(InformationTooltip) end)
				gmPin:SetMouseEnabled(true)
				if GetUnitZone("player") == GetUnitZone(gmTag) then
					local gmX, gmY = GetMapPlayerPosition(gmTag)
					MM_SetPinAnchor(gmPin, gmX, gmY, Fyr_MM_Scroll_Map_Pins)
					MM_SetPinAnchor(gmPinInCombat, gmX, gmY, Fyr_MM_Scroll_Map_Pins, not (IsUnitInCombat(gmTag) and FyrMM.SV.InCombatState))
					gmPin.nX = gmX
					gmPin.nY = gmY
					gmPinInCombat.nX = gmX
					gmPinInCombat.nY = gmY
					if MM_Is_ValidBorderPin(gmPin) then
						MM_CreateBorderPin(gmPin)
					end
					gmPin:SetHidden(not DoesUnitExist(gmTag))
					gmPinInCombat:SetHidden(not (IsUnitInCombat(gmTag) and FyrMM.SV.InCombatState))
				else
					gmPin:ClearAnchors()
					gmPin:SetHidden(true)
					gmPinInCombat:ClearAnchors()
					gmPinInCombat:SetHidden(true)
				end
			end
		end
	end
end

function MM_GroupPinUpdate()
    if not FyrMM.Visible or Fyr_MM:IsHidden() then return end
	local groupSize = GetGroupSize()
	if groupSize == 0 then return end
	if groupSize > 1 then
		debug_d("MM_GroupPinUpdate "..tostring(GetFrameTimeMilliseconds()))
	end
	for i=1, groupSize do
		local gmTag = GetGroupUnitTagByIndex(i)
		local isgmInCombat = IsUnitInCombat(gmTag)
		local isgmDead = IsUnitDead(gmTag)
		local isgmLeader = IsUnitGroupLeader(gmTag)
		local gmPin = nil
		local gmPinInCombat = nil

		if DoesUnitExist(gmTag) and not AreUnitsEqual("player", gmTag) and IsUnitOnline(gmTag) then
			if GetControl("Fyr_MM_Scroll_Map_Pins"..gmTag) == nil then return else
				gmPin = GetControl("Fyr_MM_Scroll_Map_Pins"..gmTag)
				gmPinInCombat = GetControl("Fyr_MM_Scroll_Map_Pins"..gmTag.."_incombat")
			end
			if gmPin ~= nil then
				gmPin:SetHidden(not DoesUnitExist(gmTag))
			end
			if gmPinInCombat ~= nil and not (IsUnitInCombat(gmTag) and FyrMM.SV.InCombatState) then
					gmPinInCombat:SetHidden(true)
					gmPinInCombat:ClearAnchors()
			end
			if GetUnitZone("player") == GetUnitZone(gmTag) then
				local gmX, gmY = GetMapPlayerPosition(gmTag)
				local mW, mH = Fyr_MM_Scroll_Map:GetDimensions()				 
				MM_SetPinAnchor(gmPin, gmX, gmY, Fyr_MM_Scroll_Map_Pins)
				MM_SetPinAnchor(gmPinInCombat, gmX, gmY, Fyr_MM_Scroll_Map_Pins, not (IsUnitInCombat(gmTag) and FyrMM.SV.InCombatState))
				gmPin.nX = gmX
				gmPin.nY = gmY
				gmPinInCombat.nX = gmX
				gmPinInCombat.nY = gmY
				if MM_Is_ValidBorderPin(gmPin) then
					MM_CreateBorderPin(gmPin)
				end
				if isgmLeader then
					if FyrMM.SV.LeaderPinColor ~= nil and FyrMM.SV.LeaderDeadPinColor ~= nil then
						if isgmDead then
							gmPin:SetColor(FyrMM.SV.LeaderDeadPinColor.r, FyrMM.SV.LeaderDeadPinColor.g, FyrMM.SV.LeaderDeadPinColor.b, FyrMM.SV.LeaderDeadPinColor.a)
						else
							gmPin:SetColor(FyrMM.SV.LeaderPinColor.r, FyrMM.SV.LeaderPinColor.g, FyrMM.SV.LeaderPinColor.b, FyrMM.SV.LeaderPinColor.a)
						end
					end
				else
					if FyrMM.SV.MemberPinColor ~= nil then
						if isgmDead then
							gmPin:SetColor(FyrMM.SV.MemberDeadPinColor.r, FyrMM.SV.MemberDeadPinColor.g, FyrMM.SV.MemberDeadPinColor.b, FyrMM.SV.MemberDeadPinColor.a)
						else
							gmPin:SetColor(FyrMM.SV.MemberPinColor.r, FyrMM.SV.MemberPinColor.g, FyrMM.SV.MemberPinColor.b, FyrMM.SV.MemberPinColor.a)
						end
					end
				end
				gmPin:SetMouseEnabled(true)
			else
				gmPin:ClearAnchors()
				gmPin:SetHidden(true)
				if  gmPin.BorderPin ~= nil then
					MM_RemoveBorderPin(gmPin.BorderPin)
				end
				if gmPinInCombat ~= nil then
					gmPinInCombat:SetHidden(true)
					gmPinInCombat:ClearAnchors()
				end
			end
		else -- clean up for non existant or player unit pins
			if Fyr_MM_Scroll_Map_Pins:GetNamedChild(gmTag) ~= nil then
				gmPin = GetControl("Fyr_MM_Scroll_Map_Pins"..gmTag)
				gmPinInCombat = GetControl("Fyr_MM_Scroll_Map_Pins"..gmTag.."_incombat")
				if gmPin ~= nil then
					gmPin:SetHidden(true)
					gmPin:ClearAnchors()
					if gmPin.BorderPin ~= nil then
						MM_RemoveBorderPin(gmPin.BorderPin)
					end
				end
				if gmPinInCombat ~= nil then
					gmPinInCombat:SetHidden(true)
					gmPinInCombat:ClearAnchors()
				end
			end
		end
	end
end

------------------------------------------------------------
-- Cyrodiil
------------------------------------------------------------

function MM_IsCurrentMapCyrodiil() -- is Player in PvP Map
	local mapOption = ZO_WorldMap_GetMapOptionContext()
	if mapOption == 2 then return true else return false end
end

---------------------------------------------------
-- Quest pin updates
---------------------------------------------------
function MM_GetQuestPinInfo(pinType, isassited, isBreadcrumb, areaRadius)
	if areaRadius == nil then
		areaRadius = 0
	end
	local mWidth, mHeight = Fyr_MM_Scroll_Map:GetDimensions()
	local Diameter = areaRadius * 2 * mHeight * FyrMM.MM_pScalePercent
	if Diameter < 16 then
		Diameter = 16
	end
	local properType, properTexture
	if (pinType == MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION or pinType == MAP_PIN_TYPE_TRACKED_QUEST_CONDITION) then
		if isassited then
			properType = MAP_PIN_TYPE_ASSISTED_QUEST_CONDITION
		else
			properType = MAP_PIN_TYPE_TRACKED_QUEST_CONDITION
		end
	end
	if (pinType == MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION or pinType == MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION) then
		if isassited then
			properType = MAP_PIN_TYPE_ASSISTED_QUEST_OPTIONAL_CONDITION
		else
			properType = MAP_PIN_TYPE_TRACKED_QUEST_OPTIONAL_CONDITION
		end
	end
	if (pinType == MAP_PIN_TYPE_ASSISTED_QUEST_ENDING or pinType == MAP_PIN_TYPE_TRACKED_QUEST_ENDING) then
		if isassited then
			properType = MAP_PIN_TYPE_ASSISTED_QUEST_ENDING
		else
			properType = MAP_PIN_TYPE_TRACKED_QUEST_ENDING
		end
	end
	if areaRadius == 0 then
		if isBreadcrumb then
			return properType, breadcrumbQuestPinTextures[properType], 32 * FyrMM.MM_pScalePercent
		else
			return properType, questPinTextures[properType], 32 * FyrMM.MM_pScalePercent
		end
	else
		if Diameter > 24 then
			if(isassited) then
				return properType, "EsoUI/Art/MapPins/map_assistedAreaPin.dds", Diameter
			else
				return properType, "EsoUI/Art/MapPins/map_areaPin.dds", Diameter
			end
		else
			if(isassited) then
				return properType, "EsoUI/Art/MapPins/map_assistedAreaPin_32.dds", Diameter
			else
				return properType, "EsoUI/Art/MapPins/map_areaPin_32.dds", Diameter
			end
		end
	end
end

function MM_Apply_ProperQuestPinTextures() -- Discrepany fix
	local l, pinType
	for i = 1, MAX_JOURNAL_QUESTS do
		if(IsValidQuestIndex(i)) then
			for a=1, FyrMM.questPinCount do
				l = GetControl("Fyr_MM_Scroll_Map_QuestPins_Pin"..tostring(a))
				if l ~= nil then
					if l.questIndex == i and not l:IsHidden(true) then
						if IsAssisted(l.m_PinType) ~= MM_GetQuestPinInfo(GetTrackedByIndex(i)) then -- discrepancy
							local properType, pinTexture, size = MM_GetQuestPinInfo(l.m_PinType, GetTrackedIsAssisted(TRACK_TYPE_QUEST, l.questIndex), l.m_PinTag.isBreadcrumb, l.areaRadius)
							l.m_PinType = properType
							l:SetTexture(pinTexture)
							MM_SetPinSize(l, size, 0)
							if GetTrackedIsAssisted(TRACK_TYPE_QUEST, l.questIndex) then
								l:SetDrawLayer(3)
							else
								l:SetDrawLayer(2)
							end
						end
					end
				end
			end
		end
	end
end

local function MM_SetAreaPinTextureAndSize(pin, pinDiameter)
	local pinType = pin.m_PinType
	if(ZO_MapPin.PIN_DATA[pinType].minAreaSize and pinDiameter < ZO_MapPin.PIN_DATA[pinType].minAreaSize) then
		pinDiameter = ZO_MapPin.PIN_DATA[pinType].minAreaSize
	end
	if(pinDiameter > 48) then
		if(ASSISTED_PIN_TYPES[pinType]) then
			pin:SetTexture("EsoUI/Art/MapPins/map_assistedAreaPin.dds")
		else
			pin:SetTexture("EsoUI/Art/MapPins/map_areaPin.dds")
		end
	else
		if(ASSISTED_PIN_TYPES[pinType]) then
			pin:SetTexture("EsoUI/Art/MapPins/map_assistedAreaPin_32.dds")
		else
			pin:SetTexture("EsoUI/Art/MapPins/map_areaPin_32.dds")
		end
	end
	if pinDiameter < 16 then
		pinDiameter = 16
	end
	MM_SetPinSize(pin, pinDiameter, 0)
end

local function MM_UpdateQuestPinPosition(l)
	if l ~= nil then
		if l.ZoneIndex == MM_GetMapId() and l.m_PinTag and l.m_PinTag then
			local properType, pinTexture, size = MM_GetQuestPinInfo(l.m_PinType, GetTrackedIsAssisted(TRACK_TYPE_QUEST, l.questIndex), l.m_PinTag.isBreadcrumb, l.areaRadius)
			l.m_PinType = properType
			l:SetTexture(pinTexture)
			MM_SetPinSize(l, size, 0)
			l:SetHidden(not ZO_WorldMap_IsPinGroupShown(MAP_FILTER_QUESTS))
			if GetTrackedIsAssisted(TRACK_TYPE_QUEST, l.questIndex) then
				l:SetDrawLayer(3)
			else
				l:SetDrawLayer(2)
			end
			MM_SetPinAnchor(l, l.normalizedX, l.normalizedY, Fyr_MM_Scroll_Map_QuestPins)
			if FyrMM.SV.WheelMap and l.areaRadius > 0 and l.MM_Tag == nil then
				l:SetParent(Fyr_MM_Scroll_CW_Map_Pins)
			else
				if l.MM_Tag ~= nil then
					if not FyrMM.SV.WheelMap then
						if l.MM_Tag == 1 then
							l:SetParent(Fyr_MM_Scroll_Map_QuestPins)
						end
					else
						if l.areaRadius > 0 then
							if l.MM_Tag == 1 then
								l:SetParent(Fyr_MM_Scroll_CW_Map_Pins)
								if l.secondaryPin ~= nil then
									l.secondaryPin:SetTexture(pinTexture)
								end
								if l.tertiaryPin ~= nil then
									l.tertiaryPin:SetTexture(pinTexture)
								end				
							end
							if l.MM_Tag == 2 then
								l:SetParent(Fyr_MM_Scroll_NS_Map_Pins)
							end
							if l.MM_Tag == 3 then
								l:SetParent(Fyr_MM_Scroll_WE_Map_Pins)
							end
						else
							l.MM_Tag = nil
							l:SetParent(Fyr_MM_Scroll_Map_QuestPins)
						end
					end
				end
			end
			if MM_Is_ValidBorderPin(l) then
				MM_CreateBorderPin(l)
			end
		else
			l:SetHidden(true)
			l:ClearAnchors()
		end
	end
end

function MM_UpdateQuestPinPositions()
	if FyrMM.QuestPinsUpdating then return end
	for i, v in pairs(FyrMM.questPins) do
		MM_UpdateQuestPinPosition(v.Pin)
		if v.Pin.secondaryPin ~= nil then
			MM_UpdateQuestPinPosition(v.Pin.secondaryPin)
		end
		if v.Pin.tertiaryPin ~= nil then
			MM_UpdateQuestPinPosition(v.Pin.tertiaryPin)
		end
	end
end


local function PlayTextureAnimation(pin, loopCount)
	if not pin.m_textureAnimTimeline then
		local anim
		anim, pin.m_textureAnimTimeline = CreateSimpleAnimation(ANIMATION_TEXTURE, pin)
		anim:SetImageData(32, 1)
		anim:SetFramerate(32)
		anim:SetHandler("OnStop", function() pin:SetTextureCoords(0, 1, 0, 1) end)
    end
	pin.m_textureAnimTimeline:SetPlaybackType(ANIMATION_PLAYBACK_LOOP, loopCount)
	pin.m_textureAnimTimeline:PlayFromStart()
end

local function ResetAnimation(pin, resetOptions, loopCount, pulseIcon, overlayIcon, postPulseCallback, min, max)
	resetOptions = resetOptions or RESET_ANIM_PREVENT_PLAY

    -- The animated control
	local pulseControl = pin
    
	if(resetOptions == RESET_ANIM_ALLOW_PLAY) then   
		pulseControl:SetHidden(pulseIcon == nil)
		if(pulseIcon) then
			pulseControl:SetTexture(pulseIcon)
			postPulseCallback = postPulseCallback or ZO_MapPin.DoFinalFadeOutAfterPing
			ZO_AlphaAnimation_GetAnimation(pulseControl):PingPong(.3, 1, 750, loopCount, postPulseCallback)
		end
	elseif(resetOptions == RESET_ANIM_HIDE_CONTROL) then
		ZO_AlphaAnimation_GetAnimation(pulseControl):Stop()
		pulseControl:SetHidden(true)
		pulseControl:StopTextureAnimation()
	elseif(resetOptions == RESET_ANIM_PREVENT_PLAY) then
		ZO_AlphaAnimation_GetAnimation(pulseControl):FadeOut(0, 300, ZO_ALPHA_ANIMATION_OPTION_USE_CURRENT_ALPHA, ZO_MapPin.HidePulseAfterFadeOut)
	end
end

local function ProcessQuestPinClick(pin)
	local PinHandlers = {}
	local Pins = {}
	local HandlerCount = 0
	local Handler = {}
	local entries = {}
	local entry = ""
	Handler.Callback = function (questIndex) QUEST_TRACKER:ForceAssist(questIndex) end
	Handler.Name = zo_strformat(SI_WORLD_MAP_ACTION_SELECT_QUEST, GetJournalQuestName(pin.questIndex))
	table.insert(PinHandlers, Handler)
	table.insert(Pins, pin)
	for i=1, FyrMM.questPinCount do
		local p = GetControl("Fyr_MM_Scroll_Map_QuestPins_Pin"..tostring(i))
		if p ~= nil then
			if p ~= pin and p.normalizedX == pin.normalizedX and p.normalizedY == pin.normalizedY and not p:IsHidden() then
				entry = zo_strformat(SI_WORLD_MAP_ACTION_SELECT_QUEST, GetJournalQuestName(p.questIndex))
				if not valueExists(entry, entries) then
					HandlerCount = HandlerCount + 1
					local Handler = {}
					Handler.Callback = function (questIndex) QUEST_TRACKER:ForceAssist(questIndex) end
					Handler.Name = zo_strformat(SI_WORLD_MAP_ACTION_SELECT_QUEST, GetJournalQuestName(p.questIndex))
					table.insert(PinHandlers, Handler)
					table.insert(Pins, p)
					table.insert(entries, entry)
				end
			end
		end
	end 
	if HandlerCount <= 1 then
		PinHandlers[1].Callback(Pins[1].questIndex)
	else
		ClearMenu()
		for i=1, HandlerCount do
			local Handler = PinHandlers[i]
			local questIndex = Pins[i].questIndex
			local Name = Handler.Name
			if type(Name) == "function" then
				Name = Name(Pins[i])
			end
			AddMenuItem(Name, function() Handler.Callback(questIndex) end)
		end
        ShowMenu(pin)
	end
end

local function MM_CreateQuestAreaSidePins(pin)
	local properType, pinTexture, size = MM_GetQuestPinInfo(pinType, GetTrackedIsAssisted(TRACK_TYPE_QUEST, pin.m_PinTag[1]), pin.m_PinTag.isBreadcrumb, pin.areaRadius)
	FyrMM.questPinCount = FyrMM.questPinCount+1
	local questPinNS
	index = MM_GetQuestFreePinIndex()
	if GetControl("Fyr_MM_Scroll_Map_QuestPins_Pin"..tostring(index)) == nil then
		questPinNS = WINDOW_MANAGER:CreateControl("Fyr_MM_Scroll_Map_QuestPins_Pin"..tostring(index), Fyr_MM_Scroll_NS_Map_Pins, CT_TEXTURE)
	else
		questPinNS = GetControl("Fyr_MM_Scroll_Map_QuestPins_Pin"..tostring(index))
		questPinNS:SetParent(Fyr_MM_Scroll_NS_Map_Pins)
	end
	questPinNS.m_PinTag = pin.m_PinTag
	questPinNS.questIndex = pin.questIndex
	questPinNS.m_PinType = properType
	questPinNS.PinToolTipText = pin.PinToolTipText
	questPinNS.questName = pin.questName
	questPinNS.normalizedX = pin.normalizedX
	questPinNS.normalizedY = pin.normalizedY
	questPinNS.areaRadius = pin.areaRadius
	questPinNS.ZoneIndex = pin.ZoneIndex
	questPinNS:SetTexture(pinTexture)
	MM_SetPinSize(questPinNS, size, 0)
	questPinNS.pinAge = pin.pinAge
	questPinNS:SetHidden(not ZO_WorldMap_IsPinGroupShown(MAP_FILTER_QUESTS))
	questPinNS.MM_Tag = 2
	questPinNS.primaryPin = pin
	pin.secondaryPin = questPinNS
	MM_SetPinAnchor(questPinNS, questPinNS.normalizedX, questPinNS.normalizedY, Fyr_MM_Scroll_Map_QuestPins)
	questPinNS:SetHandler("OnMouseUp", function(pin) ProcessQuestPinClick(pin) MM_UpdateQuestPins() end)
	questPinNS:SetHandler("OnMouseEnter", function(pin) MM_SetTargetScale(pin, 1.3) if not FyrMM.SV.PinTooltips then return end
														InitializeTooltip(InformationTooltip, Fyr_MM, TOPLEFT, 0, 0)
														SetQuestTooltip(pin) end)
	questPinNS:SetHandler("OnMouseExit", function(pin) MM_SetTargetScale(pin, 1) ClearTooltip(InformationTooltip) end)
			
	FyrMM.questPinCount = FyrMM.questPinCount+1
	local questPinWE
	index = MM_GetQuestFreePinIndex()
	if GetControl("Fyr_MM_Scroll_Map_QuestPins_Pin"..tostring(index)) == nil then
		questPinWE = WINDOW_MANAGER:CreateControl("Fyr_MM_Scroll_Map_QuestPins_Pin"..tostring(index), Fyr_MM_Scroll_WE_Map_Pins, CT_TEXTURE)
	else
		questPinWE = GetControl("Fyr_MM_Scroll_Map_QuestPins_Pin"..tostring(index))
		questPinWE:SetParent(Fyr_MM_Scroll_WE_Map_Pins)
	end
	questPinWE.m_PinTag = pin.m_PinTag
	questPinWE.questIndex = pin.questIndex
	questPinWE.m_PinType = properType
	questPinWE.PinToolTipText = pin.PinToolTipText
	questPinWE.questName = pin.questName
	questPinWE.normalizedX = pin.normalizedX
	questPinWE.normalizedY = pin.normalizedY
	questPinWE.areaRadius = pin.areaRadius
	questPinWE.ZoneIndex = pin.ZoneIndex
	questPinWE:SetTexture(pinTexture)
	MM_SetPinSize(questPinWE, size, 0)
	questPinWE.pinAge = pin.pinAge
	questPinWE:SetHidden(not ZO_WorldMap_IsPinGroupShown(MAP_FILTER_QUESTS))
	questPinWE.MM_Tag = 3
	questPinWE.primaryPin = pin
	pin.tertiaryPin = questPinWE
	MM_SetPinAnchor(questPinWE, questPinWE.normalizedX, questPinWE.normalizedY, Fyr_MM_Scroll_Map_QuestPins)
	questPinWE:SetHandler("OnMouseUp", function(pin) ProcessQuestPinClick(pin) MM_UpdateQuestPins() end)
	questPinWE:SetHandler("OnMouseEnter", function(pin) MM_SetTargetScale(pin, 1.3) if not FyrMM.SV.PinTooltips then return end
														InitializeTooltip(InformationTooltip, Fyr_MM, TOPLEFT, 0, 0)
														SetQuestTooltip(pin) end)
	questPinWE:SetHandler("OnMouseExit", function(pin) MM_SetTargetScale(pin, 1) ClearTooltip(InformationTooltip) end)
end

local function MM_QuestPinExists(pinType, tag, xLoc, yLoc, areaRadius)
	local l
	for i, v in pairs(FyrMM.questPins) do
		if v.Pin ~= nil then
			l = v.Pin
			if l.m_PinTag then
				if l.m_PinTag[1] == tag[1] and l.m_PinTag[2] == tag[2] and l.m_PinTag[3] == tag[3] and l.m_PinType == pinType and l.areaRadius == areaRadius and l.normalizedX == xLoc and l.normalizedY == yLoc then
					MM_RemoveQuestPin(l)
				end
			end
		end
	end
	return false
end

function MM_CreateQuestPin(pinType, tag, xLoc, yLoc, areaRadius)
	if MM_QuestPinExists(pinType, tag, xLoc, yLoc, areaRadius) then return end -- dupe elimination
	FyrMM.questPinCount = FyrMM.questPinCount+1
	local questPin
	local pinData = {}
	local index = MM_GetQuestFreePinIndex()
	if FyrMM.SV.WheelMap and areaRadius > 0 then
		if GetControl("Fyr_MM_Scroll_Map_QuestPins_Pin"..tostring(index)) == nil then
			questPin = WINDOW_MANAGER:CreateControl("Fyr_MM_Scroll_Map_QuestPins_Pin"..tostring(index), Fyr_MM_Scroll_CW_Map_Pins, CT_TEXTURE)
		else
			questPin = GetControl("Fyr_MM_Scroll_Map_QuestPins_Pin"..tostring(index))
			questPin:SetParent(Fyr_MM_Scroll_CW_Map_Pins)
		end
	else
		if GetControl("Fyr_MM_Scroll_Map_QuestPins_Pin"..tostring(index)) == nil then
			questPin = WINDOW_MANAGER:CreateControl("Fyr_MM_Scroll_Map_QuestPins_Pin"..tostring(index), Fyr_MM_Scroll_Map_QuestPins, CT_TEXTURE)
		else
			questPin = GetControl("Fyr_MM_Scroll_Map_QuestPins_Pin"..tostring(index))
			questPin:SetParent(Fyr_MM_Scroll_Map_QuestPins)
		end
	end
	local properType, pinTexture, size = MM_GetQuestPinInfo(pinType, GetTrackedIsAssisted(TRACK_TYPE_QUEST, tag[1]), tag.isBreadcrumb, areaRadius)
	pinType = properType
	questPin.m_PinTag = tag
	questPin.questIndex = tag[1]
	questPin.m_PinType = properType
	questPin.PinToolTipText = GenerateQuestConditionTooltipLine(tag[1], tag[3], tag[2])
	questPin.questName = GetJournalQuestName(tag[1])
	questPin.normalizedX = xLoc
	questPin.normalizedY = yLoc
	questPin.areaRadius = areaRadius
	questPin.ZoneIndex = MM_GetMapId()

	questPin.pinAge = GetFrameTimeMilliseconds()

	pinData.questIndex = tag[1]
	pinData.questName = GetJournalQuestName(tag[1])
	pinData.coditionText = GenerateQuestConditionTooltipLine(tag[1], tag[3], tag[2])
	pinData.stepIndex = tag[3]
	pinData.conditionIndex = tag[2]
	pinData.pinIndex = index
	pinData.normalizedX = xLoc
	pinData.normalizedY = yLoc
	pinData.areaRadius = areaRadius
	pinData.isBreadcrumb = tag.isBreadcrumb
	pinData.isAssisted = GetTrackedIsAssisted(TRACK_TYPE_QUEST, tag[1])
	pinData.ZoneIndex = MM_GetMapId()
	pinData.Pin = questPin
	pinData.tag = tag
	local questdataIndex = questpinDataExists(pinData, FyrMM.questPins)
	if questdataIndex == nil then
		table.insert(FyrMM.questPins, pinData)
		questdataIndex = questpinDataExists(pinData, FyrMM.questPins)
	else
		FyrMM.questPins[questdataIndex] = pinData
	end
	questPin.questdataIndex = questdataIndex
	local questPinData = ZO_MapPin.PIN_DATA[pinType]
	if(questPinData ~= nil) then
		local _, pulseTexture, glowTexture = GetPinTexture(pinType, questPin)
		questPin:SetTexture(pinTexture)
		MM_SetPinSize(questPin, size, 0)
		if(pulseTexture) then
			ResetAnimation(questPin, RESET_ANIM_ALLOW_PLAY, LONG_LOOP_COUNT, pulseTexture, overlayTexture, ZO_MapPin.DoFinalFadeInAfterPing)
		else if(glowTexture) then
			ResetAnimation(questPin, RESET_ANIM_HIDE_CONTROL)
			end
		end
		questPin:SetDrawLevel(zo_max(questPinData.level, 1))
		if(questPinData.isAnimated) then
			PlayTextureAnimation(questPin, LOOP_INDEFINITELY)
		end
		if FyrMM.SV.WheelMap and questPin.areaRadius > 0 then
			questPin.MM_Tag = 1
			MM_CreateQuestAreaSidePins(questPin)
		else
			if questPin.secondaryPin ~= nil then
					questPin.secondaryPin.MM_Tag = nil
					MM_RemoveQuestPin(questPin.secondaryPin)
			end
			if questPin.tertiaryPin ~= nil then
					questPin.tertiaryPin.MM_Tag = nil
					MM_RemoveQuestPin(questPin.tertiaryPin)
			end
			questPin.MM_Tag = nil
			questPin.primaryPin = nil
			questPin.secondaryPin = nil
			questPin.tertiaryPin = nil
			questPin:SetParent(Fyr_MM_Scroll_Map_QuestPins)
		end
		questPin:SetHidden(not ZO_WorldMap_IsPinGroupShown(MAP_FILTER_QUESTS))
		MM_SetPinAnchor(questPin, questPin.normalizedX, questPin.normalizedY, Fyr_MM_Scroll_Map_QuestPins)
		if MM_Is_ValidBorderPin(questPin) then
			MM_CreateBorderPin(questPin)
		end
		if GetTrackedIsAssisted(TRACK_TYPE_QUEST, tag[1]) then
			questPin:SetDrawLayer(3)
		else
			questPin:SetDrawLayer(2)
		end
		questPin:SetHandler("OnMouseUp", function(pin) ProcessQuestPinClick(pin) MM_UpdateQuestPins() end)
		questPin:SetHandler("OnMouseEnter", function(pin) MM_SetTargetScale(pin, 1.3) if not FyrMM.SV.PinTooltips then return end
								InitializeTooltip(InformationTooltip, Fyr_MM, TOPLEFT, 0, 0)
								SetQuestTooltip(pin) MM_IsCurrentLocation(pin)
								end)
		questPin:SetHandler("OnMouseExit", function(pin) MM_SetTargetScale(pin, 1) ClearTooltip(InformationTooltip) end)
		questPin:SetMouseEnabled(true)
	end
end

local function MM_OnQuestPositionRequestComplete(eventCode, taskId, pinType, xLoc, yLoc, areaRadius, insideCurrentMapWorld, isBreadcrumb)
	local tag = FyrMM.currentTasks[taskId]
	if(tag and insideCurrentMapWorld) then
		if FyrMM.currentTasks[taskId].Fetched then
			zo_callLater(MM_RequestQuestPinUpdate,100)
			if FyrMM.currentTasks[taskId].ZoneIndex ~= MM_GetMapId() then
				FyrMM.currentTasks[taskId] = nil
				return
			end
		else
			if FyrMM.currentTasks[taskId].ZO_MapVisible then return end
			local pinData = {}
			pinData.questIndex = tag[1]
			pinData.questName = GetJournalQuestName(tag[1])
			pinData.coditionText = GenerateQuestConditionTooltipLine(tag[1], tag[3], tag[2])
			pinData.stepIndex = tag[3]
			pinData.conditionIndex = tag[2]
			pinData.normalizedX = xLoc
			pinData.normalizedY = yLoc
			pinData.areaRadius = areaRadius
			pinData.isBreadcrumb = isBreadcrumb
			pinData.isAssisted = GetTrackedIsAssisted(TRACK_TYPE_QUEST, tag[1])
			pinData.ZoneIndex = MM_GetMapId()
			pinData.tag = tag
			local requestedquestdataIndex = questpinDataExists(pinData, FyrMM.requestedquestPins)
			if requestedquestdataIndex == nil then
				table.insert(FyrMM.requestedquestPins, pinData)
			else
				FyrMM.requestedquestPins[requestedquestdataIndex] = pinData
			end
			pinData = {}
		end
		if tag.ZoneIndex == MM_GetMapId() then
			tag.isBreadcrumb = isBreadcrumb
			MM_CreateQuestPin(pinType, tag, xLoc, yLoc, areaRadius)
		end
	else
		if isBreadcrumb then FyrMM.needQuestPinUpdate = true end
	end
	if tag then
		FyrMM.currentTasks[taskId] = nil
	end
	if MM_TaskCount() == 0 then
		FyrMM.QuestTasksPending = false
	else
		FyrMM.QuestTasksPending = true
	end
end

local function MM_AddQuestPins(questIndex)
	if(ZO_WorldMap_IsPinGroupShown(MAP_FILTER_QUESTS)) then
		local assisted = GetTrackedIsAssisted(TRACK_TYPE_QUEST, questIndex)
		if(GetJournalQuestIsComplete(questIndex)) then
			local tag = ZO_MapPin.CreateQuestPinTag(questIndex, QUEST_MAIN_STEP_INDEX, 1)
			if not TaskExists(tag) then
			local taskId = MM_RequestJournalQuestConditionAssistance(questIndex, QUEST_MAIN_STEP_INDEX, 1, assisted)
				if taskId ~= nil then
					FyrMM.LastQuestPinRequest = GetFrameTimeMilliseconds()
					FyrMM.currentTasks[taskId] = {}
					tag.ZoneIndex = MM_GetMapId()
					FyrMM.currentTasks[taskId] = tag
					FyrMM.currentTasks[taskId].RequestTimeStamp = FyrMM.LastQuestPinRequest
				end
			end
	else	
			for stepIndex = QUEST_MAIN_STEP_INDEX, GetJournalQuestNumSteps(questIndex) do
				for conditionIndex = 1, GetJournalQuestNumConditions(questIndex, stepIndex) do
					local _, _, isFailCondition, isComplete = GetJournalQuestConditionValues(questIndex, stepIndex, conditionIndex)
					if(not (isFailCondition or isComplete)) then
						local tag = ZO_MapPin.CreateQuestPinTag(questIndex, stepIndex, conditionIndex)
						if not TaskExists(tag) then
							local taskId = MM_RequestJournalQuestConditionAssistance(questIndex, stepIndex, conditionIndex, assisted)
							if taskId ~= nil then
								FyrMM.LastQuestPinRequest = GetFrameTimeMilliseconds()
								FyrMM.currentTasks[taskId] = {}
								tag.ZoneIndex = MM_GetMapId()
				    			FyrMM.currentTasks[taskId] = tag
								FyrMM.currentTasks[taskId].RequestTimeStamp = FyrMM.LastQuestPinRequest
								end
						end
					end
				end
			end	    
		end
	end
end

function MM_UpdateQuestPins()
	if FyrMM.Halted then return end
	if MM_TaskCount() > 0 and GetFrameTimeMilliseconds() - FyrMM.LastQuestPinRequest > FYRMM_QUEST_PIN_REQUEST_TIMEOUT then MM_DestroyTasks() end
	if MM_TaskCount() > 0 then return end
	if MM_TaskCount() == 0 and GetFrameTimeMilliseconds() - FyrMM.LastQuestPinRequest < FYRMM_QUEST_PIN_REQUEST_MINIMUM_DELAY then return end --spam
	FyrMM.questPinCount = MM_GetQuestPinCount()
	FyrMM.QuestPinsUpdating = true
	FyrMM.QuestTasksPending = true
	for i = 1, MAX_JOURNAL_QUESTS do
		if(IsValidQuestIndex(i)) then
			MM_AddQuestPins(i)
		end
	end
end

function MM_RequestQuestPinUpdate()
	FyrMM.needQuestPinUpdate = true
end

---------------------------------------------------
-- Keep Network updates
---------------------------------------------------
function MM_UpdateKeepNetworkPositions()
	if not MM_IsCurrentMapCyrodiil() or Fyr_MM:IsHidden() or not FyrMM.currentMap.ready then return end
	local  mWidth, mHeight = Fyr_MM_Scroll_Map:GetDimensions()
	local Count, l, startX, startY, endX, endY
	for i=1, 100 do
		l = GetControl("Fyr_MM_Scroll_Map_Links_Link"..tostring(i))
		if l ~= nil then
			if FyrMM.SV.WheelMap then
				l:SetParent(Fyr_MM_Scroll_CW_Map_Pins)
			else
				l:SetParent(Fyr_MM_Scroll_Map_Links)
			end
			if FyrMM.SV.RotateMap then
				l:ClearAnchors()
				l:SetAnchor(TOPLEFT, Fyr_MM_Scroll, CENTER, MM_GetRotatedPosition(l.startNX, l.startNY))
				l:SetAnchor(BOTTOMRIGHT, Fyr_MM_Scroll, CENTER, MM_GetRotatedPosition(l.endNX, l.endNY))
			else
				startX, startY, endX, endY = l.startNX * mWidth - mWidth/2, l.startNY * mHeight -mHeight/2, l.endNX * mWidth - mWidth/2, l.endNY * mHeight -mHeight/2
				l:ClearAnchors()
				l:SetAnchor(TOPLEFT, Fyr_MM_Scroll_Map_Links, CENTER, zo_round(startX), zo_round(startY) )
				l:SetAnchor(BOTTOMRIGHT , Fyr_MM_Scroll_Map_Links, CENTER, zo_round(endX),  zo_round(endY))
			end
		end
		l = GetControl("Fyr_MM_Scroll_Map_LinksNS_Link"..tostring(i))
		if l ~= nil then
			if FyrMM.SV.RotateMap then
				l:ClearAnchors()
				l:SetAnchor(TOPLEFT, Fyr_MM_Scroll, CENTER, MM_GetRotatedPosition(l.startNX, l.startNY))
				l:SetAnchor(BOTTOMRIGHT, Fyr_MM_Scroll, CENTER, MM_GetRotatedPosition(l.endNX, l.endNY))
			else
				startX, startY, endX, endY = l.startNX * mWidth - mWidth/2, l.startNY * mHeight -mHeight/2, l.endNX * mWidth - mWidth/2, l.endNY * mHeight -mHeight/2
				l:ClearAnchors()
				l:SetAnchor(TOPLEFT, Fyr_MM_Scroll_Map_Links, CENTER, zo_round(startX), zo_round(startY) )
				l:SetAnchor(BOTTOMRIGHT , Fyr_MM_Scroll_Map_Links, CENTER, zo_round(endX),  zo_round(endY))
			end
		end
		l = GetControl("Fyr_MM_Scroll_Map_LinksWE_Link"..tostring(i))
		if l ~= nil then
			if FyrMM.SV.RotateMap then
				l:ClearAnchors()
				l:SetAnchor(TOPLEFT, Fyr_MM_Scroll, CENTER, MM_GetRotatedPosition(l.startNX, l.startNY))
				l:SetAnchor(BOTTOMRIGHT, Fyr_MM_Scroll, CENTER, MM_GetRotatedPosition(l.endNX, l.endNY))
			else
				startX, startY, endX, endY = l.startNX * mWidth - mWidth/2, l.startNY * mHeight -mHeight/2, l.endNX * mWidth - mWidth/2, l.endNY * mHeight -mHeight/2
				l:ClearAnchors()
				l:SetAnchor(TOPLEFT, Fyr_MM_Scroll_Map_Links, CENTER, zo_round(startX), zo_round(startY) )
				l:SetAnchor(BOTTOMRIGHT , Fyr_MM_Scroll_Map_Links, CENTER, zo_round(endX),  zo_round(endY))
			end
		end
	end

	Count = Fyr_MM_Scroll_Map_Kill_Locations:GetNumChildren()
	for i=1, Count do
		l = Fyr_MM_Scroll_Map_Kill_Locations:GetChild(i)
		if l ~= nil then
			MM_SetPinAnchor(l, l.normalizedX, l.normalizedY, Fyr_MM_Scroll_Map_Kill_Locations)
		end
	end
	Count = Fyr_MM_Scroll_Map_ForwardCamps:GetNumChildren()
	for i=1, Count do
		l = Fyr_MM_Scroll_Map_ForwardCamps:GetChild(i)
		if l ~= nil then
			MM_SetPinAnchor(l, l.normalizedX, l.normalizedY, Fyr_MM_Scroll_Map_ForwardCamps)
		end
	end
	Count = Fyr_MM_Scroll_Map_Objectives:GetNumChildren()
	for i=1, Count do
		l = Fyr_MM_Scroll_Map_Objectives:GetChild(i)
		if l ~= nil then
			MM_SetPinAnchor(l, l.normalizedX, l.normalizedY, Fyr_MM_Scroll_Map_Objectives)
		end
	end
	Count = Fyr_MM_Scroll_Map_Keeps:GetNumChildren()
	for i=1, Count do
		l = Fyr_MM_Scroll_Map_Keeps:GetChild(i)
		if l ~= nil then
			MM_SetPinAnchor(l, l.normalizedX, l.normalizedY, Fyr_MM_Scroll_Map_Keeps)
		end
	end
	Count = Fyr_MM_Scroll_Map_Keeps_Under_Attack:GetNumChildren()
	for i=1, Count do
		l = Fyr_MM_Scroll_Map_Keeps_Under_Attack:GetChild(i)
		if l ~= nil then
			MM_SetPinAnchor(l, l.normalizedX, l.normalizedY, Fyr_MM_Scroll_Map_Keeps_Under_Attack)
		end
	end
end

function MM_UpdateKeepNetwork()
	if FyrMM.Halted then return end
	if not MM_IsCurrentMapCyrodiil() or (not FyrMM.Visible or Fyr_MM:IsHidden()) or (not FyrMM.currentMap.ready and not FyrMM.currentMap.mapBuilt) then return end
	MM_CleanUpKeepNetwork()
	local historyPercent = 100.0
	local playerAlliance = GetUnitAlliance("player")
    local bgContext = ZO_WorldMap_GetBattlegroundQueryType()
	local  mWidth, mHeight = Fyr_MM_Scroll_Map:GetDimensions()
	for i = 1, GetNumKeeps() do
		local keepId, kbgContext = GetKeepKeysByIndex(i)
		if IsLocalBattlegroundContext(kbgContext) then
			local pinType, normalizedX, normalizedY = GetHistoricalKeepPinInfo(keepId, bgContext, historyPercent)
			local keepAlliance = GetKeepAlliance(keepId, bgContext) 
			local keepUnderAttack = GetHistoricalKeepUnderAttack(keepId, bgContext, historyPercent)
			local keepUnderAttackPinType = ZO_WorldMap_GetUnderAttackPinForKeepPin(pinType)
			if MM_IsCoordinatesInMap(normalizedX, normalizedY) then
				if keepUnderAttack then 
					if Fyr_MM_Scroll_Map_Keeps_Under_Attack:GetNamedChild("_Keep"..tostring(keepId)) == nil then
			  			uakeepControl = WINDOW_MANAGER:CreateControl("Fyr_MM_Scroll_Map_Keeps_Under_Attack_Keep"..tostring(keepId), Fyr_MM_Scroll_Map_Keeps_Under_Attack, CT_TEXTURE)
					else
						uakeepControl = Fyr_MM_Scroll_Map_Keeps_Under_Attack:GetNamedChild("_Keep"..tostring(keepId))
					end
					uakeepControl:SetTexture(GetPinTexture(keepUnderAttackPinType, uakeepControl))
					uakeepControl.normalizedX = normalizedX
					uakeepControl.normalizedY = normalizedY
					uakeepControl.keepId = keepId
					uakeepControl.pinType = keepUnderAttackPinType
					uakeepControl:SetHidden(false)
					uakeepControl:SetDrawLayer(1)
					MM_SetPinSize(uakeepControl, ZO_MapPin.PIN_DATA[keepUnderAttackPinType].size * FyrMM.MM_pScalePercent, 0)
					MM_SetPinAnchor(uakeepControl, normalizedX, normalizedY, Fyr_MM_Scroll_Map_Keeps_Under_Attack)
				end
				if GetControl("Fyr_MM_Scroll_Map_Keeps_Keep"..tostring(keepId)) == nil then
					keepControl = WINDOW_MANAGER:CreateControl("Fyr_MM_Scroll_Map_Keeps_Keep"..tostring(keepId), Fyr_MM_Scroll_Map_Keeps, CT_TEXTURE)
				else
					keepControl = GetControl("Fyr_MM_Scroll_Map_Keeps_Keep"..tostring(keepId))
				end
				keepControl.normalizedX = normalizedX
				keepControl.normalizedY = normalizedY
				keepControl:SetTexture(GetPinTexture(pinType, keepControl))
				keepControl.keepId = keepId
				keepControl.pinType = pinType
				keepControl:SetDrawLayer(3)
				MM_SetPinSize(keepControl, ZO_MapPin.PIN_DATA[pinType].size * FyrMM.MM_pScalePercent, 0)
				keepControl:SetHidden(false)
				MM_SetPinAnchor(keepControl, normalizedX, normalizedY, Fyr_MM_Scroll_Map_Keeps)
				local pinTooltipInfo = ZO_MapPin.TOOLTIP_CREATORS[pinType]
				keepControl:SetHandler("OnMouseEnter", function(keepControl) MM_SetTargetScale(keepControl, 1.3) if not FyrMM.SV.PinTooltips then return end
										if pinTooltipInfo.tooltip then
				  							if pinTooltipInfo.tooltip == ZO_KeepTooltip then
												ZO_KeepTooltip:SetKeep(keepControl.keepId, ZO_WorldMap_GetBattlegroundQueryType(), historyPercent)
												ZO_KeepTooltip:SetHidden(false)
												ZO_KeepTooltip:ClearAnchors()
												ZO_KeepTooltip:SetAnchor(TOPLEFT, Fyr_MM, TOPRIGHT, 0, 0)
			  								end
		    							end end)
				keepControl:SetHandler("OnMouseExit", function(keepControl) MM_SetTargetScale(keepControl, 1)
										if pinTooltipInfo.tooltip then
											if pinTooltipInfo.tooltip == ZO_KeepTooltip then
												ZO_KeepTooltip:SetHidden(true)
										end end end)
				keepControl:SetMouseEnabled(true)
			else
				keepControl = Fyr_MM_Scroll_Map_Keeps:GetNamedChild("_Keep"..tostring(keepId))
				uakeepControl = Fyr_MM_Scroll_Map_Keeps_Under_Attack:GetNamedChild("_Keep"..tostring(keepId))
		if keepControl ~= nil then
					keepControl:SetHidden(true)
				end
				if uakeepControl ~= nil then
					uakeepControl:SetHidden(true)
				end
			end
		end
	end
	local numForwardCamps = GetNumForwardCamps(bgContext) -- Needs testing
	FyrMM.currentForwardCamps = 0
    for i = 1, numForwardCamps do
        local pinType, normalizedX, normalizedY, normalizedRadius = GetForwardCampPinInfo(bgContext, i)        
        if(normalizedX > 0 and normalizedX < 1.0001 and normalizedY > 0 and normalizedY < 1.0001) then
            if(not ZO_WorldMap_IsPinGroupShown(MAP_FILTER_AVA_GRAVEYARD_AREAS)) then
                normalizedRadius = 0
            end
			FyrMM.currentForwardCamps = FyrMM.currentForwardCamps + 1
			if Fyr_MM_Scroll_Map_ForwardCamps:GetNamedChild("_Pin"..tostring(FyrMM.currentForwardCamps)) == nil then
				forwardCampControl = WINDOW_MANAGER:CreateControl("Fyr_MM_Scroll_Map_ForwardCamps_Pin"..tostring(FyrMM.currentForwardCamps), Fyr_MM_Scroll_Map_Objectives, CT_TEXTURE)
			else
				forwardCampControl = Fyr_MM_Scroll_Map_ForwardCamps:GetNamedChild("_Pin"..tostring(FyrMM.currentForwardCamps))
			end
			if Fyr_MM_Scroll_Map_ForwardCamps:GetNamedChild("_Pin"..tostring(FyrMM.currentForwardCamps).."_Blob") == nil then
				forwardCampBlobControl = WINDOW_MANAGER:CreateControl("Fyr_MM_Scroll_Map_ForwardCamps_Pin"..tostring(FyrMM.currentForwardCamps).."_Blob", Fyr_MM_Scroll_Map_Objectives, CT_TEXTURE)
			else
				forwardCampBlobControl = Fyr_MM_Scroll_Map_ForwardCamps:GetNamedChild("_Pin"..tostring(FyrMM.currentForwardCamps).."_Blob")
			end
			local pin = ZO_Object.New(ZO_MapPin)
			forwardCampControl.normalizedX = normalizedX
			forwardCampControl.normalizedY = normalizedY
			forwardCampBlobControl.normalizedX = normalizedX
			forwardCampBlobControl.normalizedY = normalizedY
			pin.normalizedX = normalizedX
			pin.normalizedY = normalizedY
			pin.normalizedRadius = normalizedRadius
			pin.m_PinType = pinType
			pin.m_PinTag = ZO_MapPin.CreateForwardCampPinTag(i)
			forwardCampBlobControl.m_Pin = pin
			forwardCampBlobControl:SetDrawLayer(3)
			forwardCampBlobControl:SetTexture("EsoUI/Art/MapPins/map_areaPin.dds")
			forwardCampControl.m_Pin = pin
			forwardCampControl:SetDrawLayer(3)
			forwardCampControl:SetTexture(ZO_MapPin.PIN_DATA[pinType].texture)
			local campIconSize = 64 * FyrMM.MM_pScalePercent
			local campBlobSize = mHeight * normalizedRadius * 2
			MM_SetPinSize(forwardCampControl, campIconSize, 0)
			MM_SetPinSize(forwardCampBlobControl, campBlobSize, 0)
			forwardCampControl:SetHidden(false)
			forwardCampBlobControl:SetHidden(false)
			MM_SetPinAnchor(forwardCampControl, normalizedX, normalizedY, Fyr_MM_Scroll_Map_ForwardCamps)
			MM_SetPinAnchor(forwardCampBlobControl, normalizedX, normalizedY, Fyr_MM_Scroll_Map_ForwardCamps)
			local pinTooltipInfo = ZO_MapPin.TOOLTIP_CREATORS[pinType]
			forwardCampControl:SetHandler("OnMouseEnter", function(pin) MM_SetTargetScale(pin , 1.3) if not FyrMM.SV.PinTooltips then return end
										if pinTooltipInfo.tooltip then
				  							if pinTooltipInfo.tooltip == ZO_KeepTooltip then
												ZO_KeepTooltip:SetForwardCamp(pin.m_Pin:GetForwardCampIndex())
												ZO_KeepTooltip:SetHidden(false)
												ZO_KeepTooltip:ClearAnchors()
												ZO_KeepTooltip:SetAnchor(TOPLEFT, Fyr_MM, TOPRIGHT, 0, 0)
			  								end
		    							end end)
			forwardCampControl:SetHandler("OnMouseExit", function(pin) MM_SetTargetScale(pin, 1)
										if pinTooltipInfo.tooltip then
											if pinTooltipInfo.tooltip == ZO_KeepTooltip then
												ZO_KeepTooltip:SetHidden(true)
										end end end)
			forwardCampControl:SetMouseEnabled(true)
			
        end
    end   
	local numObjectives = GetNumAvAObjectives()
    for i = 1, numObjectives do
		local okeepId, objectiveId, obgContext = GetAvAObjectiveKeysByIndex(i)
	if(IsLocalBattlegroundContext(obgContext)) then	
	    if(ZO_WorldMap_IsObjectiveShown(okeepId, objectiveId, obgContext)) then 
		--To do... spawn locations
		--local opinType, spawnX, spawnY = GetAvAObjectiveSpawnPinInfo(okeepId, objectiveId, obgContext)  
				local opinType, currentX, currentY, continuousUpdate = GetAvAObjectivePinInfo(okeepId, objectiveId, bgContext)
				if(opinType ~= MAP_PIN_TYPE_INVALID) then
					if Fyr_MM_Scroll_Map_Objectives:GetNamedChild("_Objective"..tostring(objectiveId)) == nil then
						objectiveControl = WINDOW_MANAGER:CreateControl("Fyr_MM_Scroll_Map_Objectives_Objective"..tostring(objectiveId), Fyr_MM_Scroll_Map_Objectives, CT_TEXTURE)
					else
						objectiveControl = Fyr_MM_Scroll_Map_Objectives:GetNamedChild("_Objective"..tostring(objectiveId))
					end
					objectiveControl.normalizedX = currentX
					objectiveControl.normalizedY = currentY
					objectiveControl:SetDrawLayer(3)
					objectiveControl:SetTexture(GetPinTexture(opinType, objectiveControl))
					MM_SetPinSize(objectiveControl, ZO_MapPin.PIN_DATA[opinType].size * FyrMM.MM_pScalePercent, 0)
					objectiveControl:SetHidden(false)
					MM_SetPinAnchor(objectiveControl, currentX, currentY, Fyr_MM_Scroll_Map_Objectives)
					objectiveControl.keepId = okeepId
					objectiveControl.objectiveId = objectiveId
					objectiveControl:SetHandler("OnMouseEnter", function(objectiveControl) MM_SetTargetScale(objectiveControl, 1.3) if not FyrMM.SV.PinTooltips then return end
												InitializeTooltip(InformationTooltip, Fyr_MM, TOPLEFT, 0, 0)
												InformationTooltip:AddLine(zo_strformat(SI_AVA_OBJECTIVE_ARTIFACT_TOOLTIP, GetAvAObjectiveInfo(objectiveControl.keepId, objectiveControl.objectiveId, ZO_WorldMap_GetBattlegroundQueryType())))
												end)
					objectiveControl:SetHandler("OnMouseExit", function(objectiveControl) MM_SetTargetScale(objectiveControl, 1) ClearTooltip(InformationTooltip) end)
					objectiveControl:SetMouseEnabled(true)
		    if(continuousUpdate) then
			------------ To do... Continuous Position Update for opinType, keepId, objectiveId    
		    end
		end
				-- To do ... assisted pins
		   --if(AVA_OBJECTIVE_PINS_WITH_ARROWS[opinType]) then
		   --end
			end
		end
	end
	--- Kill Locations (Battles)
	--- 
	local killPinCount = 0
	for i = 1, GetNumKillLocations() do
		local pinType, normalizedX, normalizedY = GetKillLocationPinInfo(i)            
		if(pinType ~= MAP_PIN_TYPE_INVALID) then
			if(ZO_WorldMap_IsPinGroupShown(MAP_FILTER_KILL_LOCATIONS)) then
                if ((normalizedX < 1.001 or normalizedY < 1.001) and (normalizedX > -.001 or normalizedY > -.001)) then
				killPinCount = killPinCount + 1
				if GetControl("Fyr_MM_Scroll_Map_Kill_Locations_Pin"..tostring(killPinCount)) == nil then
					killPin = WINDOW_MANAGER:CreateControl("Fyr_MM_Scroll_Map_Kill_Locations_Pin"..tostring(killPinCount), Fyr_MM_Scroll_Map_Kill_Locations, CT_TEXTURE)
				else
					killPin = GetControl("Fyr_MM_Scroll_Map_Kill_Locations_Pin"..tostring(killPinCount))
				end
					local killPinSize = ZO_MapPin.PIN_DATA[pinType].size * FyrMM.MM_pScalePercent
					killPin:SetTexture(ZO_MapPin.PIN_DATA[pinType].texture)
					MM_SetPinSize(killPin, killPinSize, 0)
					local pin = ZO_Object.New(ZO_MapPin)
					pin.normalizedX = normalizedX
					pin.normalizedY = normalizedY
					pin.m_PinType = pinType
					pin.m_PinTag = i
					killPin.m_Pin = pin
					killPin.normalizedX = normalizedX
					killPin.normalizedY = normalizedY
					killPin:SetDrawLayer(3)
					killPin:SetHidden(false)
					MM_SetPinAnchor(killPin, normalizedX, normalizedY, Fyr_MM_Scroll_Map_Kill_Locations)
                end
            end
        end
    end
	
	local Count = Fyr_MM_Scroll_Map_Kill_Locations:GetNumChildren()
	if Count > killPinCount then
		for i=killPinCount+1, Count do
			local l = Fyr_MM_Scroll_Map_Kill_Locations:GetNamedChild("_Pin"..tostring(i))
			if l ~= nil then
				l:ClearAnchors()
				l:SetHidden(true)
			end
		end
	end

	local r,g,b
	local numLinks = GetNumKeepTravelNetworkLinks(bgContext)
	local linkControl, linkControlNS, linkControlWE

	for linkIndex = 1, numLinks do
		local linkType, linkOwner, restrictedToAlliance, startNX, startNY, endNX, endNY = GetHistoricalKeepTravelNetworkLinkInfo(linkIndex, bgContext, historyPercent)
		if startNX < 1 or startNY < 1 or endNX < 1 or endNY < 1 then
			local startX, startY, endX, endY = startNX * mWidth - mWidth/2, startNY * mHeight -mHeight/2, endNX * mWidth - mWidth/2, endNY * mHeight -mHeight/2
			if GetControl("Fyr_MM_Scroll_Map_Links_Link"..tostring(linkIndex)) == nil then
				linkControl = WINDOW_MANAGER:CreateControl("Fyr_MM_Scroll_Map_Links_Link"..tostring(linkIndex), Fyr_MM_Scroll_Map_Links, CT_LINE)
			else
				linkControl = GetControl("Fyr_MM_Scroll_Map_Links_Link"..tostring(linkIndex))
			end
			if GetControl("Fyr_MM_Scroll_Map_LinksNS_Link"..tostring(linkIndex)) == nil then
				linkControlNS = WINDOW_MANAGER:CreateControl("Fyr_MM_Scroll_Map_LinksNS_Link"..tostring(linkIndex), Fyr_MM_Scroll_NS_Map_Pins, CT_LINE)
			else
				linkControlNS = GetControl("Fyr_MM_Scroll_Map_LinksNS_Link"..tostring(linkIndex))
			end
			if GetControl("Fyr_MM_Scroll_Map_LinksWE_Link"..tostring(linkIndex)) == nil then
				linkControlWE = WINDOW_MANAGER:CreateControl("Fyr_MM_Scroll_Map_LinksWE_Link"..tostring(linkIndex), Fyr_MM_Scroll_WE_Map_Pins, CT_LINE)
			else
				linkControlWE = GetControl("Fyr_MM_Scroll_Map_LinksWE_Link"..tostring(linkIndex))
			end
			linkControl.startNX = startNX
			linkControl.startNY = startNY
			linkControl.endNX = endNX
			linkControl.endNY = endNY
			linkControl:SetHidden(false)
			linkControl:SetDrawLayer(1)

			linkControlNS.startNX = startNX
			linkControlNS.startNY = startNY
			linkControlNS.endNX = endNX
			linkControlNS.endNY = endNY
			linkControlNS:SetHidden(false)
			linkControlNS:SetDrawLayer(1)

			linkControlWE.startNX = startNX
			linkControlWE.startNY = startNY
			linkControlWE.endNX = endNX
			linkControlWE.endNY = endNY
			linkControlWE:SetHidden(false)
			linkControlWE:SetDrawLayer(1)

			local linkThickness = math.floor((zo_round(80 * FyrMM.MM_pScalePercent)/10)/2)*2
			if linkThickness < 6 then
				linkThickness = 6
			end
			linkControl:SetThickness(linkThickness)
			linkControlNS:SetThickness(linkThickness)
			linkControlWE:SetThickness(linkThickness)

			if(GetKeepFastTravelInteraction()) then
				if(linkOwner == playerAlliance) then
					if(linkType == FAST_TRAVEL_LINK_ACTIVE) then
						linkControl:SetColor(ZO_KeepNetwork.LINK_READY_COLOR:UnpackRGBA())
						linkControlNS:SetColor(ZO_KeepNetwork.LINK_READY_COLOR:UnpackRGBA())
						linkControlWE:SetColor(ZO_KeepNetwork.LINK_READY_COLOR:UnpackRGBA())
					else
						linkControl:SetColor(ZO_KeepNetwork.LINK_NOT_READY_COLOR:UnpackRGBA())
						linkControlNS:SetColor(ZO_KeepNetwork.LINK_NOT_READY_COLOR:UnpackRGBA())
						linkControlWE:SetColor(ZO_KeepNetwork.LINK_NOT_READY_COLOR:UnpackRGBA())
					end
				else
					r,g,b = GetAllianceColor(linkOwner):UnpackRGB()
					linkControl:SetColor(r, g, b, ZO_KeepNetwork.ALLIANCE_OWNER_ALPHA[linkOwner])
					linkControlNS:SetColor(r, g, b, ZO_KeepNetwork.ALLIANCE_OWNER_ALPHA[linkOwner])
					linkControlWE:SetColor(r, g, b, ZO_KeepNetwork.ALLIANCE_OWNER_ALPHA[linkOwner])
				end
			else
				r,g,b = GetAllianceColor(linkOwner):UnpackRGB()
				linkControl:SetColor(r, g, b, ZO_KeepNetwork.ALLIANCE_OWNER_ALPHA[linkOwner])
				linkControlNS:SetColor(r, g, b, ZO_KeepNetwork.ALLIANCE_OWNER_ALPHA[linkOwner])
				linkControlWE:SetColor(r, g, b, ZO_KeepNetwork.ALLIANCE_OWNER_ALPHA[linkOwner])
			end
			if(linkType == FAST_TRAVEL_LINK_IN_COMBAT) then
				linkControl:SetTexture("EsoUI/Art/AvA/AvA_transitLine_dashed.dds")
				linkControlNS:SetTexture("EsoUI/Art/AvA/AvA_transitLine_dashed.dds")
				linkControlWE:SetTexture("EsoUI/Art/AvA/AvA_transitLine_dashed.dds")
			else
				linkControl:SetTexture("EsoUI/Art/AvA/AvA_transitLine.dds")
				linkControlNS:SetTexture("EsoUI/Art/AvA/AvA_transitLine.dds")
				linkControlWE:SetTexture("EsoUI/Art/AvA/AvA_transitLine.dds")
			end
			if FyrMM.SV.WheelMap then
				linkControl:SetParent(Fyr_MM_Scroll_CW_Map_Pins)
			else
				linkControl:SetParent(Fyr_MM_Scroll_Map_Links)
			end
			if FyrMM.SV.RotateMap then
				linkControl:SetAnchor(TOPLEFT, Fyr_MM_Scroll, CENTER, MM_GetRotatedPosition(startNX, startNY))
				linkControl:SetAnchor(BOTTOMRIGHT, Fyr_MM_Scroll, CENTER, MM_GetRotatedPosition(endNX, endNY))
				linkControlNS:SetAnchor(TOPLEFT, Fyr_MM_Scroll, CENTER, MM_GetRotatedPosition(startNX, startNY))
				linkControlNS:SetAnchor(BOTTOMRIGHT, Fyr_MM_Scroll, CENTER, MM_GetRotatedPosition(endNX, endNY))
				linkControlWE:SetAnchor(TOPLEFT, Fyr_MM_Scroll, CENTER, MM_GetRotatedPosition(startNX, startNY))
				linkControlWE:SetAnchor(BOTTOMRIGHT, Fyr_MM_Scroll, CENTER, MM_GetRotatedPosition(endNX, endNY))
			else
				linkControl:SetAnchor(TOPLEFT, Fyr_MM_Scroll_Map_Links, CENTER, zo_round(startX), zo_round(startY))
				linkControl:SetAnchor(BOTTOMRIGHT , Fyr_MM_Scroll_Map_Links, CENTER, zo_round(endX), zo_round(endY))
				linkControlNS:SetAnchor(TOPLEFT, Fyr_MM_Scroll_Map_Links, CENTER, zo_round(startX), zo_round(startY))
				linkControlNS:SetAnchor(BOTTOMRIGHT , Fyr_MM_Scroll_Map_Links, CENTER, zo_round(endX), zo_round(endY))
				linkControlWE:SetAnchor(TOPLEFT, Fyr_MM_Scroll_Map_Links, CENTER, zo_round(startX), zo_round(startY))
				linkControlWE:SetAnchor(BOTTOMRIGHT , Fyr_MM_Scroll_Map_Links, CENTER, zo_round(endX), zo_round(endY))
			end

			-- Link Locks
			if(linkOwner == ALLIANCE_NONE and restrictedToAlliance ~= ALLIANCE_NONE) then
				if Fyr_MM_Scroll_Map_Locks:GetNamedChild("_Lock"..tostring(linkIndex)) == nil then
					lockControl = WINDOW_MANAGER:CreateControl("Fyr_MM_Scroll_Map_Locks_Lock" .. tostring(linkIndex), Fyr_MM_Scroll_Map_Locks, CT_TEXTURE)
					lockControl:SetAlpha(0.4)
				else
					lockControl = Fyr_MM_Scroll_Map_Locks:GetNamedChild("_Lock"..tostring(linkIndex))
				end
				lockControl:SetTexture("/esoui/art/ava/ava_transitlocked.dds")
				MM_SetPinSize(lockControl, 16 * FyrMM.MM_pScalePercent, 0)
				lockControl:SetHidden(false)
				r,g,b = GetAllianceColor(restrictedToAlliance):UnpackRGB()
				lockControl:SetColor(r, g, b, 1)
				lockControl.alliance = restrictedToAlliance
				lockControl:SetDrawLayer(2)
				lockControl:SetAnchor(CENTER, linkControl, CENTER, 0, 0)
				lockControl.Lock = true
				lockControl:SetHandler("OnMouseEnter", function(lockControl) MM_SetTargetScale(lockControl, 1.3) if not FyrMM.SV.PinTooltips then return end
										ZO_Tooltips_ShowTextTooltip(self, nil, zo_strformat(SI_TOOLTIP_ALLIANCE_RESTRICTED_LINK, GetAllianceName(lockControl.alliance))) end)
				lockControl:SetHandler("OnMouseExit", function(lockControl) MM_SetTargetScale(lockControl, 1) ZO_Tooltips_HideTextTooltip() end)
				lockControl:SetMouseEnabled(true)
			end
		end
	end
end
-------------------------------------------------------------
-- Miscelaneous functions
-------------------------------------------------------------
function MM_IsCoordinatesInMap(nX, nY, nW, nH)
	if nW == nil then nW = 128 end
	if nH == nil then nH = 128 end
	local mH, mW = Fyr_MM_Scroll_Map:GetDimensions()
	local wH, wW = Fyr_MM_Scroll:GetDimensions()
	local pX, pY, _ = GetMapPlayerPosition("player")
	if  mH == nil or mW == nil or wH == nil or wW == nil or nX == nil or nY == nil then return true end
	local X = nX * mH
	local Y = nY * mW
	local mXmin = pX * mW - wW/2 - nW/2 + 4
	local mXmax = pX * mW + wW/2 + nW/2 - 4
	local mYmin = pY * mH - wH/2 -nH/2 + 4
	local mYmax = pY * mH + wH/2 + nW/2 - 4
	return  not (X < mXmin or X > mXmax or Y < mYmin or Y > mYmax)
end

function MM_SetCurrentMapZoom(newZoom)
	FyrMM.currentMap.ZoomLevel = newZoom
	if FyrMM.SV.MapTable[FyrMM.currentMap.filename] ~= nil then 
		FyrMM.SV.MapTable[FyrMM.currentMap.filename].ZoomLevel = newZoom
	end
	Fyr_MM_ZoomLevel:SetText(newZoom)
end

function MM_UnregisterUpdates()
	FyrMM.Halted = true
	FyrMM.HaltTimeOffset = GetFrameTimeMilliseconds()
	EVENT_MANAGER:UnregisterForUpdate("OnUpdateFyrMMMapView")
	EVENT_MANAGER:UnregisterForUpdate("OnUpdateFyrMMMapPins")
	EVENT_MANAGER:UnregisterForUpdate("OnUpdateFyrMMMapGroupPins")
	EVENT_MANAGER:UnregisterForUpdate("OnUpdateFyrMMMapZone")
	EVENT_MANAGER:UnregisterForUpdate("OnUpdateFyrMMMapPosition")
	EVENT_MANAGER:UnregisterForUpdate("OnUpdateFyrMMMapKeepNetwork")
end

function MM_Register_Updates()
	MM_UnregisterUpdates()
	FyrMM.Halted = false
	FyrMM.HaltTimeOffset = 0
	EVENT_MANAGER:RegisterForUpdate("OnUpdateFyrMMMapView", FyrMM.SV.ViewRefreshRate, MM_UpdateMapTiles)
	EVENT_MANAGER:RegisterForUpdate("OnUpdateFyrMMMapPins", FyrMM.SV.PinRefreshRate, MM_PinUpdate)
	EVENT_MANAGER:RegisterForUpdate("OnUpdateFyrMMMapGroupPins", FyrMM.SV.MapRefreshRate, MM_GroupPinUpdate)
	EVENT_MANAGER:RegisterForUpdate("OnUpdateFyrMMMapZone", FyrMM.SV.ZoneRefreshRate, MM_ZoneUpdate)
	EVENT_MANAGER:RegisterForUpdate("OnUpdateFyrMMMapPosition", FyrMM.SV.MapRefreshRate, MM_PositionUpdate)
	EVENT_MANAGER:RegisterForUpdate("OnUpdateFyrMMMapKeepNetwork", FyrMM.SV.KeepNetworkRefreshRate, MM_UpdateKeepNetwork)
end

-------------------------------------------------------------
-- On Initialized
-------------------------------------------------------------
function MM_LoadScreen() -- Initialize Player group events
	if not FyrMM.SV.StartupInfo then
		d("|ceeeeeeMiniMap by |c006600Fyrakin |ceeeeee v"..FyrMM.Panel.version.."|r")
	end
	if FYRMM_ZOOM_INCREMENT_AMOUNT == nil then
		FYRMM_ZOOM_INCREMENT_AMOUNT = 1
	end
	EVENT_MANAGER:RegisterForEvent( "MiniMapOnUnitCreated", EVENT_UNIT_CREATED  , MM_GroupEvent )
	EVENT_MANAGER:RegisterForEvent( "MiniMapOnUnitDestroyed", EVENT_UNIT_DESTROYED  , MM_GroupEvent )
	EVENT_MANAGER:RegisterForEvent( "MiniMapOnGroupDisbanded", EVENT_GROUP_DISBANDED  , MM_GroupEvent )
	EVENT_MANAGER:RegisterForEvent( "MiniMapOnLeaderUpdated", EVENT_LEADER_UPDATE  , MM_GroupEvent )
	MM_GroupEvent()
	MM_UpdateQuestPins()
	local pinTooltipInfo = ZO_MapPin.TOOLTIP_CREATORS[MAP_PIN_TYPE_PLAYER]
	Fyr_MM_Player:SetHandler("OnMouseEnter", function(Fyr_MM_Player) MM_SetTargetScale(Fyr_MM_Player, 1.3)
							if not FyrMM.SV.PinTooltips then return end
							InitializeTooltip(InformationTooltip, Fyr_MM, TOPLEFT, 0, 0)
							InformationTooltip:AppendUnitName("player") end)
	Fyr_MM_Player:SetHandler("OnMouseExit", function(Fyr_MM_Player) MM_SetTargetScale(Fyr_MM_Player, 1) ClearTooltip(InformationTooltip) end)
	Fyr_MM_Player:SetMouseEnabled(true)
	EVENT_MANAGER:UnregisterForEvent( "MiniMap", EVENT_PLAYER_ACTIVATED )
	--zo_callLater(MM_InitialPreload,FyrMM.SV.MapRefreshRate)
end

local function MM_InitialPreloadEnd()
	debug_d("MM_InitialPreloadEnd "..tostring(GetFrameTimeMilliseconds()))
    zo_callLater(MM_Show,100)
	zo_callLater(MM_UpdateMapTiles,1)
	zo_callLater(MM_PinUpdate,200)
	zo_callLater(MM_LocationPins,25)
	zo_callLater(MM_POIPins,30)
	zo_callLater(MM_Wayshrines,20)
	zo_callLater(MM_GroupEvent,40)
	zo_callLater(MM_UpdateQuestPins,50)
	if FyrMM.SV.BorderPins then
		zo_callLater(MM_PlaceBorderPins, 2000)
	end
	zo_callLater(MM_RescalePinPositions, 1000)
end

function MM_InitialPreload()
	debug_d("MM_InitialPreload "..tostring(GetFrameTimeMilliseconds()))
	MM_MapHalfDiagonal()
	FyrMM.InitialPreloadTimeStamp = GetFrameTimeMilliseconds()
	MM_SetMapToPlayerLocation()
	FyrMM.currentMapZoneId = GetCurrentMapZoneIndex() 
	MM_UpdateMapInfo()
	MM_UpdateMapTiles()
	MM_PositionUpdate()
	MM_InitialPreloadEnd()
end

local function MM_OnInit() -- Initialize Map and Update events after add-on load
	Fyr_MM_Frame_Control:SetAnchor(CENTER, Fyr_MM, CENTER, 0, 0)
	Fyr_MM_Wheel_Background:SetAnchor(CENTER, Fyr_MM, CENTER, 0, 0)
	Fyr_MM_Wheel_Background:SetTexture("MiniMap/Textures/wheelbackground.dds")
	Fyr_MM_Scroll_WheelNS:SetAnchor(CENTER, Fyr_MM_Scroll, CENTER, 0, 0)
	Fyr_MM_Scroll_WheelWE:SetAnchor(CENTER, Fyr_MM_Scroll, CENTER, 0, 0)
	Fyr_MM_Scroll_WheelCenter:SetAnchor(CENTER, Fyr_MM_Scroll, CENTER, 0, 0)
	MenuAnimation = ZO_AlphaAnimation:New(Fyr_MM_Menu)

	FyrMM.MM_Pin_Update_Needed = true
	FyrMM.LAM = LibStub("LibAddonMenu-2.0")
	FyrMM.CPL = FyrMM.LAM:RegisterAddonPanel("FyrMiniMap", FyrMM.Panel)
	FyrMM.SettingsPanel = FyrMM.LAM:RegisterOptionControls("FyrMiniMap", FyrMM.Options)

	Fyr_MM:SetHandler("OnMouseWheel", function(self, delta, ctrl, alt, shift) if not FyrMM.SV.MouseWheel then return end if delta < 0 then MM_ZoomOut() else MM_ZoomIn() end end)
	MM_UpdateLabels()
	EVENT_MANAGER:RegisterForUpdate("OnUpdateFyrMMHideCheck", 100, MM_HideCheck)
	EVENT_MANAGER:RegisterForEvent( "MiniMap", EVENT_QUEST_ADDED, MM_RequestQuestPinUpdate)
	EVENT_MANAGER:RegisterForEvent( "MiniMap", EVENT_QUEST_ADVANCED, MM_RequestQuestPinUpdate)
	EVENT_MANAGER:RegisterForEvent( "MiniMap", EVENT_QUEST_COMPLETE_DIALOG, MM_RequestQuestPinUpdate)
	EVENT_MANAGER:RegisterForEvent( "MiniMap", EVENT_QUEST_COMPLETE, MM_RequestQuestPinUpdate)
	EVENT_MANAGER:RegisterForEvent( "MiniMap", EVENT_QUEST_CONDITION_COUNTER_CHANGED, MM_RequestQuestPinUpdate)
	EVENT_MANAGER:RegisterForEvent( "MiniMap", EVENT_QUEST_LIST_UPDATED, MM_RequestQuestPinUpdate)
	EVENT_MANAGER:RegisterForEvent( "MiniMap", EVENT_QUEST_OFFERED, MM_RequestQuestPinUpdate)
	EVENT_MANAGER:RegisterForEvent( "MiniMap", EVENT_QUEST_OPTIONAL_STEP_ADVANCED, MM_RequestQuestPinUpdate)
	EVENT_MANAGER:RegisterForEvent( "MiniMap", EVENT_MOUSE_REQUEST_ABANDON_QUEST, MM_RequestQuestPinUpdate)
	EVENT_MANAGER:RegisterForEvent( "MiniMap", EVENT_QUEST_REMOVED, MM_RequestQuestPinUpdate)
	EVENT_MANAGER:RegisterForEvent( "MiniMap", EVENT_QUEST_TOOL_UPDATED, MM_RequestQuestPinUpdate)
	EVENT_MANAGER:RegisterForEvent( "MiniMap", EVENT_ACTIVE_QUEST_TOOL_CLEARED, MM_RequestQuestPinUpdate)
	EVENT_MANAGER:RegisterForEvent( "MiniMap", EVENT_ACTIVE_QUEST_TOOL_CHANGED, MM_RequestQuestPinUpdate)
	EVENT_MANAGER:RegisterForEvent( "MiniMap", EVENT_OBJECTIVES_UPDATED, MM_RequestQuestPinUpdate)
	EVENT_MANAGER:RegisterForEvent( "MiniMap", EVENT_POI_UPDATED, MM_POIPins)
	EVENT_MANAGER:RegisterForEvent( "MiniMap", EVENT_DISCOVERY_EXPERIENCE, MM_Wayshrines)
    QUEST_TRACKER:RegisterCallback("QuestTrackerAssistStateChanged", function() MM_UpdateQuestPinPositions() end)
	QUEST_TRACKER:RegisterCallback("QuestTrackerRefreshedMapPins", function() MM_RequestQuestPinUpdate() end)
	CALLBACK_MANAGER:RegisterCallback("OnFyrMiniNewMapEntered", MM_Reload)
	CALLBACK_MANAGER:RegisterCallback("OnFyrMiniMapChanged", MM_UpdateLabels)
	CALLBACK_MANAGER:RegisterCallback("OnWorldMapChanged", function(manual) if manual == nil then zo_callLater(MM_ZoneCheck,30) return false end end)
	CALLBACK_MANAGER:RegisterCallback("OnWorldMapModeChanged", function() zo_callLater(function() if ZO_WorldMap:IsHidden() then zo_callLater(function() if SetMapToPlayerLocation() ~= SET_MAP_RESULT_CURRENT_MAP_UNCHANGED  then CALLBACK_MANAGER:FireCallbacks("OnWorldMapChanged")	end end, 10) zo_callLater(MM_Register_Updates, 300) else MM_UnregisterUpdates() end end, 10) end)

	ZO_PreHook(ZO_WorldMapPins, "RemovePins", function() FyrMM.LastReload = GetFrameTimeMilliseconds() FyrMM.MM_Pin_Update_Needed = true end)
	ZO_PreHook(ZO_WorldMapPins, "CreatePin", function() FyrMM.LastReload = GetFrameTimeMilliseconds() FyrMM.MM_Pin_Update_Needed = true end)
	ZO_PreHook(ZO_WorldMapPins, "RefreshCustomPins", function() FyrMM.LastReload = GetFrameTimeMilliseconds() FyrMM.MM_Pin_Update_Needed = true end)
	ZO_PreHook(ZO_WorldMapPins, "AddCustomPin", function() FyrMM.LastReload = GetFrameTimeMilliseconds() FyrMM.MM_Pin_Update_Needed = true end)
	ZO_PreHook(ZO_Fishing, "StartInteraction", function() local action = GetGameCameraInteractableActionInfo() if zo_strformat(SI_GAME_CAMERA_TARGET, action) == GetString(SI_GAMECAMERAACTIONTYPE13) then zo_callLater(MM_RequestQuestPinUpdate,4000) end return false end)
	ZO_PreHook(COMPASS, "PerformFullAreaQuestUpdate", MM_RequestQuestPinUpdate)
	ZO_PreHook(ZO_WorldMap, "SetHidden", MM_WorldMapShowHide)


	ZO_PreHookHandler(ZO_GameMenu_InGame, "OnShow", function() zo_callLater(MM_HideCheck,10) end)
	ZO_PreHookHandler(ZO_GameMenu_InGame, "OnHide", function() zo_callLater(MM_HideCheck,10) end)
	ZO_PreHookHandler(ZO_InteractWindow, "OnShow", function() zo_callLater(MM_HideCheck,10) end)
	ZO_PreHookHandler(ZO_InteractWindow, "OnHide", function() zo_callLater(MM_HideCheck,10) end)
	ZO_PreHookHandler(ZO_KeybindStripControl, "OnShow", function() zo_callLater(MM_HideCheck,10) end)
	ZO_PreHookHandler(ZO_KeybindStripControl, "OnHide", function() zo_callLater(MM_HideCheck,10) end)
	ZO_PreHookHandler(ZO_MainMenuCategoryBar, "OnShow", function() zo_callLater(MM_HideCheck,10) end)
	ZO_PreHookHandler(ZO_MainMenuCategoryBar, "OnHide", function() zo_callLater(MM_HideCheck,10) end)

	--EVENT_MANAGER:RegisterForEvent( "MiniMap", EVENT_ZONE_CHANGED, function() FyrMM.MM_Pin_Update_Needed = true end)
	zo_callLater(MM_InitFinish,FyrMM.SV.ZoneRefreshRate)
end

function MM_InitFinish()
	FyrMM.Initialized = true
	if FyrMM.SV.MenuAutoHide then
		zo_callLater(MM_MenuFadeOut, 3000)
	end
end

function MM_MenuFadeIn()
	if Fyr_MM_Menu:GetAlpha() > 0 or FyrMM.SV.MenuDisabled or FyrMM.MenuFadingIn or Fyr_MM:IsHidden() then return end
	FyrMM.MenuFadingIn = true
	if FyrMM.SV.ZoneFrameLocationOption == "Default" then
		Fyr_MM_ZoneFrame:ClearAnchors()
		Fyr_MM_ZoneFrame:SetAnchor(TOP, Fyr_MM_Menu, BOTTOM, 0, -Fyr_MM_Menu:GetHeight()/5)
		Fyr_MM_ZoneFrame:SetMovable(false)
	end
	if FyrMM.OverMiniMap or FyrMM.OverMenu then
		MenuAnimation:FadeIn(0, 1000, ZO_ALPHA_ANIMATION_OPTION_FORCE_ALPHA, function() FyrMM.MenuFadingIn = false end)
	end
end

function MM_MenuFadeOut()
	if not FyrMM.SV.MenuAutoHide or FyrMM.OverMiniMap or FyrMM.OverMenu or Fyr_MM_Menu:GetAlpha() == 0 or FyrMM.SV.MenuDisabled  or FyrMM.MenuFadingOut then return end
	FyrMM.MenuFadingOut = true
	MenuAnimation:FadeOut(0, 1000, ZO_ALPHA_ANIMATION_OPTION_FORCE_ALPHA, function() FyrMM.MenuFadingOut = false
																			if FyrMM.SV.ZoneFrameLocationOption == "Default" then
																				Fyr_MM_ZoneFrame:ClearAnchors()
																				Fyr_MM_ZoneFrame:SetAnchor(TOP, Fyr_MM_Border, BOTTOM)
																				Fyr_MM_ZoneFrame:SetMovable(false)
																			end end)
end

local function MM_OnLoaded(eventCode, addOnName)
	if addOnName ~= "MiniMap" then return end
	FyrMM.Initialized = false
	MM_CreateDataTables()
	FyrMM.SV = ZO_SavedVars:NewAccountWide( "FyrMMSV" , 5 , nil , FyrMM.Defaults , nil )
	if FyrMM.SV ~= nil then
		MM_LoadSavedVars()
	end
	MM_API_Check()
	Fyr_MM:SetResizeHandleSize(MOUSE_CURSOR_RESIZE_NS)
	Fyr_MM:SetHandler("OnMouseEnter", function() FyrMM.OverMiniMap = true MM_MenuFadeIn() Fyr_MM_Close:SetAlpha(1) end)
	Fyr_MM:SetHandler("OnMouseExit", function() FyrMM.OverMiniMap = false zo_callLater(MM_MenuFadeOut, 3000) Fyr_MM_Close:SetAlpha(0) end)
	Fyr_MM_Menu:SetHandler("OnMouseEnter", function() FyrMM.OverMenu = true MM_MenuFadeIn() Fyr_MM_Close:SetAlpha(1) end)
	Fyr_MM_Menu:SetHandler("OnMouseExit", function() FyrMM.OverMenu = false zo_callLater(MM_MenuFadeOut, 3000) Fyr_MM_Close:SetAlpha(0) end)
	Fyr_MM:SetHandler("OnMouseUp", function(self) if not FyrMM.SV.LockPosition then
						local width = Fyr_MM:GetWidth()
						local height = Fyr_MM:GetHeight()
						MM_SetMapWidth(width)
						MM_SetMapHeight(height)
						FyrMM.SV.position.offsetX = Fyr_MM:GetLeft()
						FyrMM.SV.position.offsetY = Fyr_MM:GetTop()
						MM_MapHalfDiagonal()
						MM_RefreshPanel()
					else
						local pos = {}
						pos.anchorTo = GetControl(pos.anchorTo)
						Fyr_MM:SetAnchor(FyrMM.SV.position.point, pos.anchorTo, FyrMM.SV.position.relativePoint, FyrMM.SV.position.offsetX, FyrMM.SV.position.offsetY)
						Fyr_MM:SetDimensions(FyrMM.SV.MapWidth, FyrMM.SV.MapHeight)
					end	end)
	Fyr_MM_Coordinates:SetHandler("OnMouseUp", function(self) local pos = {}
								_, pos[1], pos[2], pos[3], pos[4], pos[5] = Fyr_MM_Coordinates:GetAnchor() if pos[2] ~= nil then pos[2] = pos[2]:GetName() end
								FyrMM.SV.CoordinatesAnchor = pos end)
	Fyr_MM_ZoneFrame:SetHandler("OnMouseUp", function(self) local pos = {}
								_, pos[1], pos[2], pos[3], pos[4], pos[5] = Fyr_MM_ZoneFrame:GetAnchor() if pos[1] == nil then return end if pos[2] ~= nil then pos[2] = pos[2]:GetName() end
								FyrMM.SV.ZoneFrameAnchor = pos end)
	Fyr_MM_Scroll:SetScrollBounding(0)
    Fyr_MM_Player_incombat:SetTexture("esoui/art/mappins/ava_attackburst_32.dds")
	MM_AxisSwitch()
	zo_callLater(MM_OnInit,1000) 
end

-----------------------------------------
-- Key bind functions
-----------------------------------------
function MM_RescalePinPositions()
	zo_callLater(MM_UpdateQuestPinPositions,1)
	zo_callLater(MM_UpdateLocationPinPositions,1)
	zo_callLater(MM_UpdatePOIPinPositions,1)
	zo_callLater(MM_UpdateWayshrinePinPositions,1)
	zo_callLater(MM_UpdateCustomPinPositions,1)
	zo_callLater(MM_GroupPinUpdate,1)
	zo_callLater(MM_UpdateKeepNetwork,1)
	zo_callLater(MM_PlaceBorderPins, 100)
end

function MM_ZoomOut()
    if not FyrMM.Visible or Fyr_MM:IsHidden() then return end
    local zoomLevel = FyrMM.currentMap.ZoomLevel
	zoomLevel = zoomLevel - FYRMM_ZOOM_INCREMENT_AMOUNT
	if zoomLevel < FYRMM_ZOOM_MIN then zoomLevel = FYRMM_ZOOM_MIN end
	PlaySound(SOUNDS.MAP_ZOOM_OUT)
	MM_SetCurrentMapZoom(zoomLevel)
	MM_UpdateMapTiles()
end

function MM_ZoomIn()
    if not FyrMM.Visible or Fyr_MM:IsHidden() then return end
    local zoomLevel = FyrMM.currentMap.ZoomLevel
	zoomLevel = zoomLevel + FYRMM_ZOOM_INCREMENT_AMOUNT
	if zoomLevel > FYRMM_ZOOM_MAX then zoomLevel = FYRMM_ZOOM_MAX end
	PlaySound(SOUNDS.MAP_ZOOM_IN)
	MM_SetCurrentMapZoom(zoomLevel)
	MM_UpdateMapTiles()
end

function MM_ToggleVisible()
	if ZO_WorldMap:IsHidden() and ZO_InteractWindow:IsHidden() and ZO_KeybindStripControl:IsHidden() then
		if FyrMM.Visible then
			PlaySound(SOUNDS.MAP_WINDOW_CLOSE)
		else
			PlaySound(SOUNDS.MAP_WINDOW_OPEN)
		end
    	FyrMM.Visible = not FyrMM.Visible
    end
end

EVENT_MANAGER:RegisterForEvent( "MiniMap", EVENT_QUEST_POSITION_REQUEST_COMPLETE, MM_OnQuestPositionRequestComplete)
EVENT_MANAGER:RegisterForEvent( "MiniMap", EVENT_ADD_ON_LOADED , MM_OnLoaded)
EVENT_MANAGER:RegisterForEvent( "MiniMap", EVENT_ZONE_CHANGED, MM_UpdateLabels)
EVENT_MANAGER:RegisterForEvent( "MiniMap", EVENT_PLAYER_ACTIVATED  , MM_LoadScreen)
